/* nibbles-game.c generated by valac 0.56.17, the Vala compiler
 * generated from nibbles-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 * grep -ne ' $' *.vala
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gio/gio.h>

#define NIBBLES_GAME_MAX_WORMS 6
#define NIBBLES_GAME_MAX_SPEED 4
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define NIBBLES_GAME_WARPCHAR 'W'
#define NIBBLES_GAME_MAX_LEVEL 26
#define WORM_GROW_FACTOR 4
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef gboolean (*KeypressHandlerFunction) (guint a, guint b, gboolean* remove_handler, gpointer user_data);
typedef enum  {
	GAME_STATUS_GAMEOVER,
	GAME_STATUS_VICTORY,
	GAME_STATUS_NEWROUND
} GameStatus;

#define TYPE_GAME_STATUS (game_status_get_type ())
typedef gboolean (*_LocalFunc0_) (GValue* value, GVariant* variant, void* data, gpointer user_data);
typedef GVariant* (*_LocalFunc1_) (GValue* value, const GVariantType* type, void* data, gpointer user_data);

#define TYPE_NIBBLES_GAME (nibbles_game_get_type ())
#define NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_GAME, NibblesGame))
#define NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_GAME, NibblesGameClass))
#define IS_NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_GAME))
#define IS_NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_GAME))
#define NIBBLES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_GAME, NibblesGameClass))

typedef struct _NibblesGame NibblesGame;
typedef struct _NibblesGameClass NibblesGameClass;
typedef struct _NibblesGamePrivate NibblesGamePrivate;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;
enum  {
	NIBBLES_GAME_0_PROPERTY,
	NIBBLES_GAME_SKIP_SCORE_PROPERTY,
	NIBBLES_GAME_CURRENT_LEVEL_PROPERTY,
	NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY,
	NIBBLES_GAME_SPEED_PROPERTY,
	NIBBLES_GAME_GAMEDELAY_PROPERTY,
	NIBBLES_GAME_PROGRESS_PROPERTY,
	NIBBLES_GAME_START_LEVEL_PROPERTY,
	NIBBLES_GAME_WIDTH_PROPERTY,
	NIBBLES_GAME_HEIGHT_PROPERTY,
	NIBBLES_GAME_NUMHUMANS_PROPERTY,
	NIBBLES_GAME_NUMAI_PROPERTY,
	NIBBLES_GAME_NUMWORMS_PROPERTY,
	NIBBLES_GAME_WORMS_PROPERTY,
	NIBBLES_GAME_WORM_PROPS_PROPERTY,
	NIBBLES_GAME_IS_RUNNING_PROPERTY,
	NIBBLES_GAME_PAUSED_PROPERTY,
	NIBBLES_GAME_FAKES_PROPERTY,
	NIBBLES_GAME_NUM_PROPERTIES
};
static GParamSpec* nibbles_game_properties[NIBBLES_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_EAST = WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_SOUTH = WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_WEST = WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP,
	WORM_DIRECTION_NORTH = WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())
typedef GeeList* (*WormGetOtherWormsType) (Worm* _self_, gpointer user_data);

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
typedef GeeList* (*WormGetBonusesType) (gpointer user_data);
typedef struct _WormPrivate WormPrivate;

#define TYPE_WORM_POSITIONS (worm_positions_get_type ())
#define WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_POSITIONS, WormPositions))
#define WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_POSITIONS, WormPositionsClass))
#define IS_WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_POSITIONS))
#define IS_WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_POSITIONS))
#define WORM_POSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_POSITIONS, WormPositionsClass))

typedef struct _WormPositions WormPositions;
typedef struct _WormPositionsClass WormPositionsClass;

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())
typedef struct _BoniPrivate BoniPrivate;
enum  {
	NIBBLES_GAME_BONUS_APPLIED_SIGNAL,
	NIBBLES_GAME_LOG_SCORE_SIGNAL,
	NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL,
	NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL,
	NIBBLES_GAME_WARP_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_REMOVED_SIGNAL,
	NIBBLES_GAME_GET_PKGDATADIR_SIGNAL,
	NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL,
	NIBBLES_GAME_REDRAW_SIGNAL,
	NIBBLES_GAME_PLAY_SOUND_SIGNAL,
	NIBBLES_GAME_NUM_SIGNALS
};
static guint nibbles_game_signals[NIBBLES_GAME_NUM_SIGNALS] = {0};

struct _NibblesGame {
	GObject parent_instance;
	NibblesGamePrivate * priv;
	gint _progress;
	gint* levels_uncompleated;
	gint levels_uncompleated_length1;
	gint _levels_uncompleated_size_;
	gint* board;
	gint board_length1;
	gint board_length2;
	gboolean added_keypress_handler;
};

struct _NibblesGameClass {
	GObjectClass parent_class;
};

struct _NibblesGamePrivate {
	gboolean _skip_score;
	gint _current_level;
	gboolean _three_dimensional_view;
	gint _speed;
	gint _gamedelay;
	gint _start_level;
	guint8 _width;
	guint8 _height;
	gint _numhumans;
	gint _numai;
	gint _numworms;
	GeeLinkedList* _worms;
	GeeHashMap* _worm_props;
	Boni* boni;
	WarpManager* warp_manager;
	gboolean _is_running;
	gboolean _is_paused;
	guint main_id;
	gboolean _fakes;
	guint8 bonus_cycle;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gint rounds_to_stay_still;
	gboolean is_stopped;
	WormPositions* list;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _Position {
	guint8 x;
	guint8 y;
};

struct _Boni {
	GObject parent_instance;
	BoniPrivate * priv;
	gint progress;
};

struct _BoniClass {
	GObjectClass parent_class;
};

static gint NibblesGame_private_offset;
static gpointer nibbles_game_parent_class = NULL;

VALA_EXTERN GType game_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType nibbles_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGame, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN GType boni_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Boni, g_object_unref)
VALA_EXTERN GType warp_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManager, g_object_unref)
VALA_EXTERN Boni* boni_new (void);
VALA_EXTERN Boni* boni_construct (GType object_type);
VALA_EXTERN WarpManager* warp_manager_new (void);
VALA_EXTERN WarpManager* warp_manager_construct (GType object_type);
VALA_EXTERN NibblesGame* nibbles_game_new (gint start_level,
                               gint speed,
                               gint gamedelay,
                               gboolean fakes,
                               gboolean three_dimensional_view,
                               guint8 width,
                               guint8 height,
                               gboolean no_random);
VALA_EXTERN NibblesGame* nibbles_game_construct (GType object_type,
                                     gint start_level,
                                     gint speed,
                                     gint gamedelay,
                                     gboolean fakes,
                                     gboolean three_dimensional_view,
                                     guint8 width,
                                     guint8 height,
                                     gboolean no_random);
VALA_EXTERN void nibbles_game_new_level (NibblesGame* self,
                             gint level_id);
VALA_EXTERN gboolean nibbles_game_keypress (NibblesGame* self,
                                guint keyval,
                                guint keycode,
                                gboolean* remove_handler);
static gboolean _nibbles_game_keypress_keypress_handler_function (guint a,
                                                           guint b,
                                                           gboolean* remove_handler,
                                                           gpointer self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gboolean nibbles_game_load_board (NibblesGame* self,
                                  gchar** future_board,
                                  gint future_board_length1,
                                  guint8 regular_bonus);
VALA_EXTERN gint nibbles_game_get_numworms (NibblesGame* self);
VALA_EXTERN guint8 nibbles_game_get_height (NibblesGame* self);
VALA_EXTERN void boni_reset (Boni* self,
                 guint8 regular_bonus);
VALA_EXTERN void warp_manager_clear_warps (WarpManager* self);
VALA_EXTERN guint8 nibbles_game_get_width (NibblesGame* self);
VALA_EXTERN GeeLinkedList* nibbles_game_get_worms (NibblesGame* self);
VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
VALA_EXTERN void warp_manager_add_warp_source (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void warp_manager_add_warp_target (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void nibbles_game_start (NibblesGame* self,
                         gboolean add_initial_bonus);
static void nibbles_game_add_bonus (NibblesGame* self,
                             gboolean regular);
static void nibbles_game_set_is_running (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN gint nibbles_game_get_speed (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_gamedelay (NibblesGame* self);
static gboolean __lambda6_ (NibblesGame* self);
static gboolean nibbles_game_main_loop_cb (NibblesGame* self);
static gboolean ___lambda6__gsource_func (gpointer self);
VALA_EXTERN void nibbles_game_stop (NibblesGame* self);
VALA_EXTERN void nibbles_game_reset (NibblesGame* self,
                         gint start_level);
VALA_EXTERN void nibbles_game_set_skip_score (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN gint nibbles_game_get_progress (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_current_level (NibblesGame* self,
                                     gint value);
static void _vala_array_add2 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static gint nibbles_game_remove_one_uncompleated_level (NibblesGame* self);
static void nibbles_game_set_is_paused (NibblesGame* self,
                                 gboolean value);
static gint* _vala_array_dup1 (gint* self,
                        gssize length);
static gint* _vala_array_dup2 (gint* self,
                        gssize length);
static gint* _vala_array_dup3 (gint* self,
                        gssize length);
static gint* _vala_array_dup4 (gint* self,
                        gssize length);
static gint* _vala_array_dup5 (gint* self,
                        gssize length);
static void _vala_array_add3 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void nibbles_game_end (NibblesGame* self);
VALA_EXTERN GameStatus* nibbles_game_get_game_status (NibblesGame* self);
static gboolean _game_status_equal (const GameStatus * s1,
                             const GameStatus * s2);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN gint nibbles_game_get_current_level (NibblesGame* self);
VALA_EXTERN Worm* nibbles_game_get_winner (NibblesGame* self);
static void nibbles_game_move_worms (NibblesGame* self);
VALA_EXTERN void nibbles_game_create_worms (NibblesGame* self,
                                GeeArrayList* worm_settings);
VALA_EXTERN gint nibbles_game_get_numai (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numhumans (NibblesGame* self);
static void nibbles_game_set_numworms (NibblesGame* self,
                                gint value);
static GeeList* nibbles_game_get_other_worms (NibblesGame* self,
                                       Worm* _self_);
static GeeList* _nibbles_game_get_other_worms_worm_get_other_worms_type (Worm* _self_,
                                                                  gpointer self);
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
VALA_EXTERN GeeList* nibbles_game_get_bonuses (NibblesGame* self);
static GeeList* _nibbles_game_get_bonuses_worm_get_bonuses_type (gpointer self);
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height,
                WormGetOtherWormsType cb0,
                gpointer cb0_target,
                WormGetBonusesType cb1,
                gpointer cb1_target);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height,
                      WormGetOtherWormsType cb0,
                      gpointer cb0_target,
                      WormGetBonusesType cb1,
                      gpointer cb1_target);
static void nibbles_game_bonus_found_cb (NibblesGame* self,
                                  Worm* worm);
static void _nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                                    gpointer self);
VALA_EXTERN GType worm_positions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormPositions, g_object_unref)
VALA_EXTERN void nibbles_game_load_worm_properties (NibblesGame* self,
                                        GeeArrayList* worm_settings);
VALA_EXTERN void nibbles_game_add_worms (NibblesGame* self);
VALA_EXTERN void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
VALA_EXTERN gboolean boni_too_many_missed (Boni* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
VALA_EXTERN void boni_on_worms_move (Boni* self,
                         guint8* missed_bonuses_to_replace);
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   GeeLinkedList* worms);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
VALA_EXTERN gboolean warp_manager_get_warp_target (WarpManager* self,
                                       guint8 x,
                                       guint8 y,
                                       gboolean horizontal,
                                       guint8* target_x,
                                       guint8* target_y);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           GeeLinkedList* worms,
                           Position* position);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* head_position);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void nibbles_game_reverse_worms (NibblesGame* self,
                                 Worm* worm);
VALA_EXTERN void worm_reverse (Worm* self);
static gboolean nibbles_game_is_space_empty (NibblesGame* self,
                                      guint8 x,
                                      guint8 y,
                                      gboolean* worms_at,
                                      gint worms_at_length1,
                                      gint worms_at_length2);
VALA_EXTERN Bonus* boni_get_bonus (Boni* self,
                       guint8 x,
                       guint8 y);
VALA_EXTERN gboolean nibbles_game_get_fakes (NibblesGame* self);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
static inline void _nibbles_game_add_bonus (NibblesGame* self,
                              guint8 x,
                              guint8 y,
                              BonusType bonus_type,
                              gboolean fake,
                              guint16 countdown);
VALA_EXTERN Bonus* bonus_new (guint8 x,
                  guint8 y,
                  BonusType bonus_type,
                  gboolean fake,
                  guint16 countdown);
VALA_EXTERN Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        BonusType bonus_type,
                        gboolean fake,
                        guint16 countdown);
VALA_EXTERN gboolean boni_add_bonus (Boni* self,
                         Bonus* bonus);
VALA_EXTERN BonusType bonus_get_bonus_type (Bonus* self);
static void nibbles_game_apply_bonus (NibblesGame* self,
                               Bonus* bonus,
                               Worm* worm);
VALA_EXTERN gboolean bonus_get_fake (Bonus* self);
VALA_EXTERN guint8 boni_new_regular_bonus_eaten (Boni* self);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN gint worm_get_length (Worm* self);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint erase_size);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN void worm_add_bonus_eaten_position (Worm* self,
                                    guint8 x,
                                    guint8 y);
VALA_EXTERN void boni_remove_bonus (Boni* self,
                        Bonus* bonus);
VALA_EXTERN gboolean boni_last_regular_bonus (Boni* self);
static GameStatus* _game_status_dup (GameStatus* self);
VALA_EXTERN guint nibbles_game_humans_left (NibblesGame* self);
static gboolean __lambda7_ (NibblesGame* self,
                     GValue* value,
                     GVariant* variant,
                     void* data);
static inline gint nibbles_game_get_color_num (const gchar* color);
static gboolean ___lambda7___localfunc0_ (GValue* value,
                                   GVariant* variant,
                                   void* data,
                                   gpointer self);
static GVariant* __lambda8_ (NibblesGame* self,
                      GValue* value,
                      const GVariantType* type,
                      void* data);
static inline gchar* nibbles_game_get_color_string (gint color);
static GVariant* ___lambda8___localfunc1_ (GValue* value,
                                    const GVariantType* type,
                                    void* data,
                                    gpointer self);
VALA_EXTERN GeeHashMap* nibbles_game_get_worm_props (NibblesGame* self);
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_get_id (Worm* self);
VALA_EXTERN gboolean nibbles_game_handle_keypress (NibblesGame* self,
                                       guint keyval,
                                       guint keycode);
VALA_EXTERN gboolean nibbles_game_get_is_running (NibblesGame* self);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keycode,
                               GeeHashMap* worm_props,
                               gint* board,
                               gint board_length1,
                               gint board_length2,
                               GeeLinkedList* worms);
VALA_EXTERN GeeList* boni_get_bonuses (Boni* self);
VALA_EXTERN gboolean nibbles_game_get_skip_score (NibblesGame* self);
VALA_EXTERN gboolean nibbles_game_get_three_dimensional_view (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_three_dimensional_view (NibblesGame* self,
                                              gboolean value);
VALA_EXTERN void nibbles_game_set_speed (NibblesGame* self,
                             gint value);
static void nibbles_game_set_gamedelay (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_progress (NibblesGame* self,
                                gint value);
VALA_EXTERN gint nibbles_game_get_start_level (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_start_level (NibblesGame* self,
                                   gint value);
static void nibbles_game_set_width (NibblesGame* self,
                             guint8 value);
static void nibbles_game_set_height (NibblesGame* self,
                              guint8 value);
VALA_EXTERN void nibbles_game_set_numhumans (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_numai (NibblesGame* self,
                             gint value);
static gboolean nibbles_game_get_is_paused (NibblesGame* self);
VALA_EXTERN gboolean nibbles_game_get_paused (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_paused (NibblesGame* self,
                              gboolean value);
VALA_EXTERN void nibbles_game_set_fakes (NibblesGame* self,
                             gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_STRING__VOID (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GObject * nibbles_game_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _nibbles_game___lambda9_ (NibblesGame* self,
                               Bonus* bonus);
static void __nibbles_game___lambda9__boni_bonus_removed (Boni* _sender,
                                                   Bonus* bonus,
                                                   gpointer self);
static void nibbles_game_finalize (GObject * obj);
static GType nibbles_game_get_type_once (void);
static void _vala_nibbles_game_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_nibbles_game_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

 G_GNUC_NO_INLINE static GType
game_status_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_STATUS_GAMEOVER, "GAME_STATUS_GAMEOVER", "gameover"}, {GAME_STATUS_VICTORY, "GAME_STATUS_VICTORY", "victory"}, {GAME_STATUS_NEWROUND, "GAME_STATUS_NEWROUND", "newround"}, {0, NULL, NULL}};
	GType game_status_type_id;
	game_status_type_id = g_enum_register_static ("GameStatus", values);
	return game_status_type_id;
}

GType
game_status_get_type (void)
{
	static gsize game_status_type_id__once = 0;
	if (g_once_init_enter (&game_status_type_id__once)) {
		GType game_status_type_id;
		game_status_type_id = game_status_get_type_once ();
		g_once_init_leave (&game_status_type_id__once, game_status_type_id);
	}
	return game_status_type_id__once;
}

static inline gpointer
nibbles_game_get_instance_private (NibblesGame* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesGame_private_offset);
}

NibblesGame*
nibbles_game_construct (GType object_type,
                        gint start_level,
                        gint speed,
                        gint gamedelay,
                        gboolean fakes,
                        gboolean three_dimensional_view,
                        guint8 width,
                        guint8 height,
                        gboolean no_random)
{
	NibblesGame * self = NULL;
	guint32 _tmp0_ = 0U;
#line 132 "../src/nibbles-game.vala"
	self = (NibblesGame*) g_object_new (object_type, "skip-score", start_level != 1, "current-level", start_level, "speed", speed, "gamedelay", gamedelay, "fakes", fakes, "three-dimensional-view", three_dimensional_view, "width", width, "height", height, NULL);
#line 133 "../src/nibbles-game.vala"
	if (no_random) {
#line 133 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) 42;
#line 713 "nibbles-game.c"
	} else {
		time_t _tmp1_;
#line 133 "../src/nibbles-game.vala"
		_tmp1_ = time (NULL);
#line 133 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) _tmp1_;
#line 720 "nibbles-game.c"
	}
#line 133 "../src/nibbles-game.vala"
	g_random_set_seed (_tmp0_);
#line 130 "../src/nibbles-game.vala"
	return self;
#line 726 "nibbles-game.c"
}

NibblesGame*
nibbles_game_new (gint start_level,
                  gint speed,
                  gint gamedelay,
                  gboolean fakes,
                  gboolean three_dimensional_view,
                  guint8 width,
                  guint8 height,
                  gboolean no_random)
{
#line 130 "../src/nibbles-game.vala"
	return nibbles_game_construct (TYPE_NIBBLES_GAME, start_level, speed, gamedelay, fakes, three_dimensional_view, width, height, no_random);
#line 741 "nibbles-game.c"
}

static gboolean
_nibbles_game_keypress_keypress_handler_function (guint a,
                                                  guint b,
                                                  gboolean* remove_handler,
                                                  gpointer self)
{
	gboolean result;
	result = nibbles_game_keypress ((NibblesGame*) self, a, b, remove_handler);
#line 145 "../src/nibbles-game.vala"
	return result;
#line 754 "nibbles-game.c"
}

static gchar*
g_file_stream_read_line (FILE* self)
{
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp3_;
	gchar* result;
#line 4109 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4111 "glib-2.0.vapi"
	ret = NULL;
#line 4112 "glib-2.0.vapi"
	while (TRUE) {
#line 770 "nibbles-game.c"
		GString* _tmp0_;
		GString* _tmp2_;
#line 4112 "glib-2.0.vapi"
		c = fgetc (self);
#line 4112 "glib-2.0.vapi"
		if (!(c != EOF)) {
#line 4112 "glib-2.0.vapi"
			break;
#line 779 "nibbles-game.c"
		}
#line 4113 "glib-2.0.vapi"
		_tmp0_ = ret;
#line 4113 "glib-2.0.vapi"
		if (_tmp0_ == NULL) {
#line 785 "nibbles-game.c"
			GString* _tmp1_;
#line 4114 "glib-2.0.vapi"
			_tmp1_ = g_string_new ("");
#line 4114 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 4114 "glib-2.0.vapi"
			ret = _tmp1_;
#line 793 "nibbles-game.c"
		}
#line 4116 "glib-2.0.vapi"
		if (c == ((gint) '\n')) {
#line 4117 "glib-2.0.vapi"
			break;
#line 799 "nibbles-game.c"
		}
#line 4119 "glib-2.0.vapi"
		_tmp2_ = ret;
#line 4119 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp2_, (gchar) c);
#line 805 "nibbles-game.c"
	}
#line 4121 "glib-2.0.vapi"
	_tmp3_ = ret;
#line 4121 "glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 4122 "glib-2.0.vapi"
		result = NULL;
#line 4122 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4122 "glib-2.0.vapi"
		return result;
#line 817 "nibbles-game.c"
	} else {
		GString* _tmp4_;
		gchar* _tmp5_;
#line 4124 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 4124 "glib-2.0.vapi"
		_tmp5_ = ((GString*) _tmp4_)->str;
#line 4124 "glib-2.0.vapi"
		((GString*) _tmp4_)->str = NULL;
#line 4124 "glib-2.0.vapi"
		result = _tmp5_;
#line 4124 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4124 "glib-2.0.vapi"
		return result;
#line 833 "nibbles-game.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 157 "../src/nibbles-game.vala"
	if ((*length) == (*size)) {
#line 157 "../src/nibbles-game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 157 "../src/nibbles-game.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 849 "nibbles-game.c"
	}
#line 157 "../src/nibbles-game.vala"
	(*array)[(*length)++] = value;
#line 157 "../src/nibbles-game.vala"
	(*array)[*length] = NULL;
#line 855 "nibbles-game.c"
}

void
nibbles_game_new_level (NibblesGame* self,
                        gint level_id)
{
	gchar* level_name = NULL;
	gchar* _tmp1_;
	gchar* filename = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	FILE* file = NULL;
	FILE* _tmp6_;
	gchar* line = NULL;
	gchar** board = NULL;
	gchar** _tmp7_;
	gint board_length1;
	gint _board_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
#line 141 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/nibbles-game.vala"
	if (!self->added_keypress_handler) {
#line 883 "nibbles-game.c"
		gboolean _tmp0_ = FALSE;
#line 145 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL], 0, _nibbles_game_keypress_keypress_handler_function, self, &_tmp0_);
#line 145 "../src/nibbles-game.vala"
		self->added_keypress_handler = _tmp0_;
#line 889 "nibbles-game.c"
	}
#line 147 "../src/nibbles-game.vala"
	_tmp1_ = g_strdup_printf ("level%03d.gnl", level_id);
#line 147 "../src/nibbles-game.vala"
	level_name = _tmp1_;
#line 148 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_GET_PKGDATADIR_SIGNAL], 0, &_tmp2_);
#line 148 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 148 "../src/nibbles-game.vala"
	_tmp4_ = g_build_filename (_tmp3_, "levels", level_name, NULL, NULL);
#line 148 "../src/nibbles-game.vala"
	_tmp5_ = _tmp4_;
#line 148 "../src/nibbles-game.vala"
	_g_free0 (_tmp3_);
#line 148 "../src/nibbles-game.vala"
	filename = _tmp5_;
#line 151 "../src/nibbles-game.vala"
	_tmp6_ = g_fopen (filename, "r");
#line 151 "../src/nibbles-game.vala"
	_fclose0 (file);
#line 151 "../src/nibbles-game.vala"
	file = _tmp6_;
#line 151 "../src/nibbles-game.vala"
	if (file == NULL) {
#line 152 "../src/nibbles-game.vala"
		g_error ("nibbles-game.vala:152: Nibbles couldn't find pixmap file: %s", filename);
#line 917 "nibbles-game.c"
	}
#line 155 "../src/nibbles-game.vala"
	_tmp7_ = g_new0 (gchar*, 0 + 1);
#line 155 "../src/nibbles-game.vala"
	board = _tmp7_;
#line 155 "../src/nibbles-game.vala"
	board_length1 = 0;
#line 155 "../src/nibbles-game.vala"
	_board_size_ = board_length1;
#line 156 "../src/nibbles-game.vala"
	while (TRUE) {
#line 929 "nibbles-game.c"
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 156 "../src/nibbles-game.vala"
		_tmp8_ = g_file_stream_read_line (file);
#line 156 "../src/nibbles-game.vala"
		_g_free0 (line);
#line 156 "../src/nibbles-game.vala"
		line = _tmp8_;
#line 156 "../src/nibbles-game.vala"
		_tmp9_ = line;
#line 156 "../src/nibbles-game.vala"
		if (!(_tmp9_ != NULL)) {
#line 156 "../src/nibbles-game.vala"
			break;
#line 946 "nibbles-game.c"
		}
#line 157 "../src/nibbles-game.vala"
		_tmp10_ = line;
#line 157 "../src/nibbles-game.vala"
		_tmp11_ = g_strdup ((const gchar*) _tmp10_);
#line 157 "../src/nibbles-game.vala"
		_vala_array_add1 (&board, &board_length1, &_board_size_, _tmp11_);
#line 954 "nibbles-game.c"
	}
#line 158 "../src/nibbles-game.vala"
	_tmp12_ = board;
#line 158 "../src/nibbles-game.vala"
	_tmp12__length1 = board_length1;
#line 158 "../src/nibbles-game.vala"
	_tmp13_ = self->priv->_numworms;
#line 158 "../src/nibbles-game.vala"
	if (!nibbles_game_load_board (self, _tmp12_, (gint) _tmp12__length1, (guint8) (8 + _tmp13_))) {
#line 159 "../src/nibbles-game.vala"
		g_error ("nibbles-game.vala:159: Level file appears to be damaged: %s", filename);
#line 966 "nibbles-game.c"
	}
#line 141 "../src/nibbles-game.vala"
	board = (_vala_array_free (board, board_length1, (GDestroyNotify) g_free), NULL);
#line 141 "../src/nibbles-game.vala"
	_g_free0 (line);
#line 141 "../src/nibbles-game.vala"
	_fclose0 (file);
#line 141 "../src/nibbles-game.vala"
	_g_free0 (filename);
#line 141 "../src/nibbles-game.vala"
	_g_free0 (level_name);
#line 978 "nibbles-game.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 992 "nibbles-game.c"
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gchar* _tmp0_;
	gint result;
#line 1333 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1334 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1334 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1334 "glib-2.0.vapi"
	return result;
#line 1009 "nibbles-game.c"
}

gboolean
nibbles_game_load_board (NibblesGame* self,
                         gchar** future_board,
                         gint future_board_length1,
                         guint8 regular_bonus)
{
	guint8 _tmp0_;
	Boni* _tmp1_;
	WarpManager* _tmp2_;
	gchar* tmpboard = NULL;
	gint count = 0;
	gboolean result;
#line 162 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_height;
#line 164 "../src/nibbles-game.vala"
	if (future_board_length1 != ((gint) _tmp0_)) {
#line 165 "../src/nibbles-game.vala"
		result = FALSE;
#line 165 "../src/nibbles-game.vala"
		return result;
#line 1034 "nibbles-game.c"
	}
#line 167 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->boni;
#line 167 "../src/nibbles-game.vala"
	boni_reset (_tmp1_, regular_bonus);
#line 168 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->warp_manager;
#line 168 "../src/nibbles-game.vala"
	warp_manager_clear_warps (_tmp2_);
#line 171 "../src/nibbles-game.vala"
	count = 0;
#line 1046 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 172 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 1051 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 172 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 172 "../src/nibbles-game.vala"
			while (TRUE) {
#line 1058 "nibbles-game.c"
				guint8 _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				guint8 _tmp9_;
#line 172 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 1066 "nibbles-game.c"
					guint8 _tmp4_;
#line 172 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 172 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 1072 "nibbles-game.c"
				}
#line 172 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 172 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_height;
#line 172 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 172 "../src/nibbles-game.vala"
					break;
#line 1082 "nibbles-game.c"
				}
#line 174 "../src/nibbles-game.vala"
				_tmp6_ = future_board[i];
#line 174 "../src/nibbles-game.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 174 "../src/nibbles-game.vala"
				_g_free0 (tmpboard);
#line 174 "../src/nibbles-game.vala"
				tmpboard = _tmp7_;
#line 175 "../src/nibbles-game.vala"
				_tmp8_ = tmpboard;
#line 175 "../src/nibbles-game.vala"
				_tmp9_ = self->priv->_width;
#line 175 "../src/nibbles-game.vala"
				if (g_utf8_strlen (_tmp8_, (gssize) -1) != ((gint) _tmp9_)) {
#line 176 "../src/nibbles-game.vala"
					result = FALSE;
#line 176 "../src/nibbles-game.vala"
					_g_free0 (tmpboard);
#line 176 "../src/nibbles-game.vala"
					return result;
#line 1104 "nibbles-game.c"
				}
				{
					guint8 j = 0U;
#line 177 "../src/nibbles-game.vala"
					j = (guint8) 0;
#line 1110 "nibbles-game.c"
					{
						gboolean _tmp10_ = FALSE;
#line 177 "../src/nibbles-game.vala"
						_tmp10_ = TRUE;
#line 177 "../src/nibbles-game.vala"
						while (TRUE) {
#line 1117 "nibbles-game.c"
							guint8 _tmp12_;
							gunichar char_value = 0U;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
#line 177 "../src/nibbles-game.vala"
							if (!_tmp10_) {
#line 1124 "nibbles-game.c"
								guint8 _tmp11_;
#line 177 "../src/nibbles-game.vala"
								_tmp11_ = j;
#line 177 "../src/nibbles-game.vala"
								j = _tmp11_ + 1;
#line 1130 "nibbles-game.c"
							}
#line 177 "../src/nibbles-game.vala"
							_tmp10_ = FALSE;
#line 177 "../src/nibbles-game.vala"
							_tmp12_ = self->priv->_width;
#line 177 "../src/nibbles-game.vala"
							if (!(j < _tmp12_)) {
#line 177 "../src/nibbles-game.vala"
								break;
#line 1140 "nibbles-game.c"
							}
#line 179 "../src/nibbles-game.vala"
							_tmp13_ = tmpboard;
#line 179 "../src/nibbles-game.vala"
							_tmp14_ = tmpboard;
#line 179 "../src/nibbles-game.vala"
							char_value = string_get_char (_tmp13_, (glong) string_index_of_nth_char (_tmp14_, (glong) j));
#line 180 "../src/nibbles-game.vala"
							switch (char_value) {
#line 180 "../src/nibbles-game.vala"
								case '.':
#line 180 "../src/nibbles-game.vala"
								case '+':
#line 1154 "nibbles-game.c"
								{
									gint* _tmp15_;
									gint _tmp15__length1;
									gint _tmp15__length2;
#line 185 "../src/nibbles-game.vala"
									_tmp15_ = self->board;
#line 185 "../src/nibbles-game.vala"
									_tmp15__length1 = self->board_length1;
#line 185 "../src/nibbles-game.vala"
									_tmp15__length2 = self->board_length2;
#line 185 "../src/nibbles-game.vala"
									_tmp15_[(j * _tmp15__length2) + i] = (gint) 'a';
#line 186 "../src/nibbles-game.vala"
									break;
#line 1169 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9475U:
#line 1173 "nibbles-game.c"
								{
									gint* _tmp16_;
									gint _tmp16__length1;
									gint _tmp16__length2;
#line 190 "../src/nibbles-game.vala"
									_tmp16_ = self->board;
#line 190 "../src/nibbles-game.vala"
									_tmp16__length1 = self->board_length1;
#line 190 "../src/nibbles-game.vala"
									_tmp16__length2 = self->board_length2;
#line 190 "../src/nibbles-game.vala"
									_tmp16_[(j * _tmp16__length2) + i] = (gint) 'b';
#line 191 "../src/nibbles-game.vala"
									break;
#line 1188 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9473U:
#line 1192 "nibbles-game.c"
								{
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
#line 193 "../src/nibbles-game.vala"
									_tmp17_ = self->board;
#line 193 "../src/nibbles-game.vala"
									_tmp17__length1 = self->board_length1;
#line 193 "../src/nibbles-game.vala"
									_tmp17__length2 = self->board_length2;
#line 193 "../src/nibbles-game.vala"
									_tmp17_[(j * _tmp17__length2) + i] = (gint) 'c';
#line 194 "../src/nibbles-game.vala"
									break;
#line 1207 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9495U:
#line 1211 "nibbles-game.c"
								{
									gint* _tmp18_;
									gint _tmp18__length1;
									gint _tmp18__length2;
#line 196 "../src/nibbles-game.vala"
									_tmp18_ = self->board;
#line 196 "../src/nibbles-game.vala"
									_tmp18__length1 = self->board_length1;
#line 196 "../src/nibbles-game.vala"
									_tmp18__length2 = self->board_length2;
#line 196 "../src/nibbles-game.vala"
									_tmp18_[(j * _tmp18__length2) + i] = (gint) 'd';
#line 197 "../src/nibbles-game.vala"
									break;
#line 1226 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9499U:
#line 1230 "nibbles-game.c"
								{
									gint* _tmp19_;
									gint _tmp19__length1;
									gint _tmp19__length2;
#line 199 "../src/nibbles-game.vala"
									_tmp19_ = self->board;
#line 199 "../src/nibbles-game.vala"
									_tmp19__length1 = self->board_length1;
#line 199 "../src/nibbles-game.vala"
									_tmp19__length2 = self->board_length2;
#line 199 "../src/nibbles-game.vala"
									_tmp19_[(j * _tmp19__length2) + i] = (gint) 'e';
#line 200 "../src/nibbles-game.vala"
									break;
#line 1245 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9487U:
#line 1249 "nibbles-game.c"
								{
									gint* _tmp20_;
									gint _tmp20__length1;
									gint _tmp20__length2;
#line 202 "../src/nibbles-game.vala"
									_tmp20_ = self->board;
#line 202 "../src/nibbles-game.vala"
									_tmp20__length1 = self->board_length1;
#line 202 "../src/nibbles-game.vala"
									_tmp20__length2 = self->board_length2;
#line 202 "../src/nibbles-game.vala"
									_tmp20_[(j * _tmp20__length2) + i] = (gint) 'f';
#line 203 "../src/nibbles-game.vala"
									break;
#line 1264 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9491U:
#line 1268 "nibbles-game.c"
								{
									gint* _tmp21_;
									gint _tmp21__length1;
									gint _tmp21__length2;
#line 205 "../src/nibbles-game.vala"
									_tmp21_ = self->board;
#line 205 "../src/nibbles-game.vala"
									_tmp21__length1 = self->board_length1;
#line 205 "../src/nibbles-game.vala"
									_tmp21__length2 = self->board_length2;
#line 205 "../src/nibbles-game.vala"
									_tmp21_[(j * _tmp21__length2) + i] = (gint) 'g';
#line 206 "../src/nibbles-game.vala"
									break;
#line 1283 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9531U:
#line 1287 "nibbles-game.c"
								{
									gint* _tmp22_;
									gint _tmp22__length1;
									gint _tmp22__length2;
#line 208 "../src/nibbles-game.vala"
									_tmp22_ = self->board;
#line 208 "../src/nibbles-game.vala"
									_tmp22__length1 = self->board_length1;
#line 208 "../src/nibbles-game.vala"
									_tmp22__length2 = self->board_length2;
#line 208 "../src/nibbles-game.vala"
									_tmp22_[(j * _tmp22__length2) + i] = (gint) 'h';
#line 209 "../src/nibbles-game.vala"
									break;
#line 1302 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9507U:
#line 1306 "nibbles-game.c"
								{
									gint* _tmp23_;
									gint _tmp23__length1;
									gint _tmp23__length2;
#line 211 "../src/nibbles-game.vala"
									_tmp23_ = self->board;
#line 211 "../src/nibbles-game.vala"
									_tmp23__length1 = self->board_length1;
#line 211 "../src/nibbles-game.vala"
									_tmp23__length2 = self->board_length2;
#line 211 "../src/nibbles-game.vala"
									_tmp23_[(j * _tmp23__length2) + i] = (gint) 'i';
#line 212 "../src/nibbles-game.vala"
									break;
#line 1321 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9515U:
#line 1325 "nibbles-game.c"
								{
									gint* _tmp24_;
									gint _tmp24__length1;
									gint _tmp24__length2;
#line 214 "../src/nibbles-game.vala"
									_tmp24_ = self->board;
#line 214 "../src/nibbles-game.vala"
									_tmp24__length1 = self->board_length1;
#line 214 "../src/nibbles-game.vala"
									_tmp24__length2 = self->board_length2;
#line 214 "../src/nibbles-game.vala"
									_tmp24_[(j * _tmp24__length2) + i] = (gint) 'j';
#line 215 "../src/nibbles-game.vala"
									break;
#line 1340 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9523U:
#line 1344 "nibbles-game.c"
								{
									gint* _tmp25_;
									gint _tmp25__length1;
									gint _tmp25__length2;
#line 217 "../src/nibbles-game.vala"
									_tmp25_ = self->board;
#line 217 "../src/nibbles-game.vala"
									_tmp25__length1 = self->board_length1;
#line 217 "../src/nibbles-game.vala"
									_tmp25__length2 = self->board_length2;
#line 217 "../src/nibbles-game.vala"
									_tmp25_[(j * _tmp25__length2) + i] = (gint) 'k';
#line 218 "../src/nibbles-game.vala"
									break;
#line 1359 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9547U:
#line 1363 "nibbles-game.c"
								{
									gint* _tmp26_;
									gint _tmp26__length1;
									gint _tmp26__length2;
#line 220 "../src/nibbles-game.vala"
									_tmp26_ = self->board;
#line 220 "../src/nibbles-game.vala"
									_tmp26__length1 = self->board_length1;
#line 220 "../src/nibbles-game.vala"
									_tmp26__length2 = self->board_length2;
#line 220 "../src/nibbles-game.vala"
									_tmp26_[(j * _tmp26__length2) + i] = (gint) 'l';
#line 221 "../src/nibbles-game.vala"
									break;
#line 1378 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9650U:
#line 180 "../src/nibbles-game.vala"
								case 'm':
#line 1384 "nibbles-game.c"
								{
									gint* _tmp27_;
									gint _tmp27__length1;
									gint _tmp27__length2;
									gint _tmp28_;
#line 226 "../src/nibbles-game.vala"
									_tmp27_ = self->board;
#line 226 "../src/nibbles-game.vala"
									_tmp27__length1 = self->board_length1;
#line 226 "../src/nibbles-game.vala"
									_tmp27__length2 = self->board_length2;
#line 226 "../src/nibbles-game.vala"
									_tmp27_[(j * _tmp27__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 227 "../src/nibbles-game.vala"
									_tmp28_ = self->priv->_numworms;
#line 227 "../src/nibbles-game.vala"
									if (count < _tmp28_) {
#line 1402 "nibbles-game.c"
										GeeLinkedList* _tmp29_;
										gpointer _tmp30_;
										Worm* _tmp31_;
										gint _tmp32_;
#line 229 "../src/nibbles-game.vala"
										_tmp29_ = self->priv->_worms;
#line 229 "../src/nibbles-game.vala"
										_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, count);
#line 229 "../src/nibbles-game.vala"
										_tmp31_ = (Worm*) _tmp30_;
#line 229 "../src/nibbles-game.vala"
										worm_set_start (_tmp31_, j, i, WORM_DIRECTION_UP);
#line 229 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp31_);
#line 230 "../src/nibbles-game.vala"
										_tmp32_ = count;
#line 230 "../src/nibbles-game.vala"
										count = _tmp32_ + 1;
#line 1421 "nibbles-game.c"
									}
#line 232 "../src/nibbles-game.vala"
									break;
#line 1425 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9664U:
#line 180 "../src/nibbles-game.vala"
								case 'n':
#line 1431 "nibbles-game.c"
								{
									gint* _tmp33_;
									gint _tmp33__length1;
									gint _tmp33__length2;
									gint _tmp34_;
#line 235 "../src/nibbles-game.vala"
									_tmp33_ = self->board;
#line 235 "../src/nibbles-game.vala"
									_tmp33__length1 = self->board_length1;
#line 235 "../src/nibbles-game.vala"
									_tmp33__length2 = self->board_length2;
#line 235 "../src/nibbles-game.vala"
									_tmp33_[(j * _tmp33__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 236 "../src/nibbles-game.vala"
									_tmp34_ = self->priv->_numworms;
#line 236 "../src/nibbles-game.vala"
									if (count < _tmp34_) {
#line 1449 "nibbles-game.c"
										GeeLinkedList* _tmp35_;
										gpointer _tmp36_;
										Worm* _tmp37_;
										gint _tmp38_;
#line 238 "../src/nibbles-game.vala"
										_tmp35_ = self->priv->_worms;
#line 238 "../src/nibbles-game.vala"
										_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, count);
#line 238 "../src/nibbles-game.vala"
										_tmp37_ = (Worm*) _tmp36_;
#line 238 "../src/nibbles-game.vala"
										worm_set_start (_tmp37_, j, i, WORM_DIRECTION_LEFT);
#line 238 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp37_);
#line 239 "../src/nibbles-game.vala"
										_tmp38_ = count;
#line 239 "../src/nibbles-game.vala"
										count = _tmp38_ + 1;
#line 1468 "nibbles-game.c"
									}
#line 241 "../src/nibbles-game.vala"
									break;
#line 1472 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9660U:
#line 180 "../src/nibbles-game.vala"
								case 'o':
#line 1478 "nibbles-game.c"
								{
									gint* _tmp39_;
									gint _tmp39__length1;
									gint _tmp39__length2;
									gint _tmp40_;
#line 244 "../src/nibbles-game.vala"
									_tmp39_ = self->board;
#line 244 "../src/nibbles-game.vala"
									_tmp39__length1 = self->board_length1;
#line 244 "../src/nibbles-game.vala"
									_tmp39__length2 = self->board_length2;
#line 244 "../src/nibbles-game.vala"
									_tmp39_[(j * _tmp39__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 245 "../src/nibbles-game.vala"
									_tmp40_ = self->priv->_numworms;
#line 245 "../src/nibbles-game.vala"
									if (count < _tmp40_) {
#line 1496 "nibbles-game.c"
										GeeLinkedList* _tmp41_;
										gpointer _tmp42_;
										Worm* _tmp43_;
										gint _tmp44_;
#line 247 "../src/nibbles-game.vala"
										_tmp41_ = self->priv->_worms;
#line 247 "../src/nibbles-game.vala"
										_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, count);
#line 247 "../src/nibbles-game.vala"
										_tmp43_ = (Worm*) _tmp42_;
#line 247 "../src/nibbles-game.vala"
										worm_set_start (_tmp43_, j, i, WORM_DIRECTION_DOWN);
#line 247 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp43_);
#line 248 "../src/nibbles-game.vala"
										_tmp44_ = count;
#line 248 "../src/nibbles-game.vala"
										count = _tmp44_ + 1;
#line 1515 "nibbles-game.c"
									}
#line 250 "../src/nibbles-game.vala"
									break;
#line 1519 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 9654U:
#line 180 "../src/nibbles-game.vala"
								case 'p':
#line 1525 "nibbles-game.c"
								{
									gint* _tmp45_;
									gint _tmp45__length1;
									gint _tmp45__length2;
									gint _tmp46_;
#line 253 "../src/nibbles-game.vala"
									_tmp45_ = self->board;
#line 253 "../src/nibbles-game.vala"
									_tmp45__length1 = self->board_length1;
#line 253 "../src/nibbles-game.vala"
									_tmp45__length2 = self->board_length2;
#line 253 "../src/nibbles-game.vala"
									_tmp45_[(j * _tmp45__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 254 "../src/nibbles-game.vala"
									_tmp46_ = self->priv->_numworms;
#line 254 "../src/nibbles-game.vala"
									if (count < _tmp46_) {
#line 1543 "nibbles-game.c"
										GeeLinkedList* _tmp47_;
										gpointer _tmp48_;
										Worm* _tmp49_;
										gint _tmp50_;
#line 256 "../src/nibbles-game.vala"
										_tmp47_ = self->priv->_worms;
#line 256 "../src/nibbles-game.vala"
										_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, count);
#line 256 "../src/nibbles-game.vala"
										_tmp49_ = (Worm*) _tmp48_;
#line 256 "../src/nibbles-game.vala"
										worm_set_start (_tmp49_, j, i, WORM_DIRECTION_RIGHT);
#line 256 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp49_);
#line 257 "../src/nibbles-game.vala"
										_tmp50_ = count;
#line 257 "../src/nibbles-game.vala"
										count = _tmp50_ + 1;
#line 1562 "nibbles-game.c"
									}
#line 259 "../src/nibbles-game.vala"
									break;
#line 1566 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 'Q':
#line 180 "../src/nibbles-game.vala"
								case 'R':
#line 180 "../src/nibbles-game.vala"
								case 'S':
#line 180 "../src/nibbles-game.vala"
								case 'T':
#line 180 "../src/nibbles-game.vala"
								case 'U':
#line 180 "../src/nibbles-game.vala"
								case 'V':
#line 180 "../src/nibbles-game.vala"
								case 'W':
#line 180 "../src/nibbles-game.vala"
								case 'X':
#line 180 "../src/nibbles-game.vala"
								case 'Y':
#line 180 "../src/nibbles-game.vala"
								case 'Z':
#line 1588 "nibbles-game.c"
								{
									gboolean _tmp51_ = FALSE;
									gint* _tmp52_;
									gint _tmp52__length1;
									gint _tmp52__length2;
									WarpManager* _tmp53_;
									gint* _tmp54_;
									gint _tmp54__length1;
									gint _tmp54__length2;
									gint _tmp55_;
									gint* _tmp56_;
									gint _tmp56__length1;
									gint _tmp56__length2;
									gint* _tmp57_;
									gint _tmp57__length1;
									gint _tmp57__length2;
									gint* _tmp58_;
									gint _tmp58__length1;
									gint _tmp58__length2;
									gint* _tmp59_;
									gint _tmp59__length1;
									gint _tmp59__length2;
#line 272 "../src/nibbles-game.vala"
									if (((gint) j) == 0) {
#line 272 "../src/nibbles-game.vala"
										_tmp51_ = TRUE;
#line 1615 "nibbles-game.c"
									} else {
#line 272 "../src/nibbles-game.vala"
										_tmp51_ = ((gint) i) == 0;
#line 1619 "nibbles-game.c"
									}
#line 272 "../src/nibbles-game.vala"
									if (_tmp51_) {
#line 273 "../src/nibbles-game.vala"
										result = FALSE;
#line 273 "../src/nibbles-game.vala"
										_g_free0 (tmpboard);
#line 273 "../src/nibbles-game.vala"
										return result;
#line 1629 "nibbles-game.c"
									}
#line 275 "../src/nibbles-game.vala"
									_tmp52_ = self->board;
#line 275 "../src/nibbles-game.vala"
									_tmp52__length1 = self->board_length1;
#line 275 "../src/nibbles-game.vala"
									_tmp52__length2 = self->board_length2;
#line 275 "../src/nibbles-game.vala"
									_tmp52_[(j * _tmp52__length2) + i] = (gint) char_value;
#line 276 "../src/nibbles-game.vala"
									_tmp53_ = self->priv->warp_manager;
#line 276 "../src/nibbles-game.vala"
									_tmp54_ = self->board;
#line 276 "../src/nibbles-game.vala"
									_tmp54__length1 = self->board_length1;
#line 276 "../src/nibbles-game.vala"
									_tmp54__length2 = self->board_length2;
#line 276 "../src/nibbles-game.vala"
									_tmp55_ = _tmp54_[(j * _tmp54__length2) + i];
#line 276 "../src/nibbles-game.vala"
									warp_manager_add_warp_source (_tmp53_, _tmp55_, (guint8) (j - 1), (guint8) (i - 1));
#line 278 "../src/nibbles-game.vala"
									_tmp56_ = self->board;
#line 278 "../src/nibbles-game.vala"
									_tmp56__length1 = self->board_length1;
#line 278 "../src/nibbles-game.vala"
									_tmp56__length2 = self->board_length2;
#line 278 "../src/nibbles-game.vala"
									_tmp56_[((j - 1) * _tmp56__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 279 "../src/nibbles-game.vala"
									_tmp57_ = self->board;
#line 279 "../src/nibbles-game.vala"
									_tmp57__length1 = self->board_length1;
#line 279 "../src/nibbles-game.vala"
									_tmp57__length2 = self->board_length2;
#line 279 "../src/nibbles-game.vala"
									_tmp57_[(j * _tmp57__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 280 "../src/nibbles-game.vala"
									_tmp58_ = self->board;
#line 280 "../src/nibbles-game.vala"
									_tmp58__length1 = self->board_length1;
#line 280 "../src/nibbles-game.vala"
									_tmp58__length2 = self->board_length2;
#line 280 "../src/nibbles-game.vala"
									_tmp58_[((j - 1) * _tmp58__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 281 "../src/nibbles-game.vala"
									_tmp59_ = self->board;
#line 281 "../src/nibbles-game.vala"
									_tmp59__length1 = self->board_length1;
#line 281 "../src/nibbles-game.vala"
									_tmp59__length2 = self->board_length2;
#line 281 "../src/nibbles-game.vala"
									_tmp59_[(j * _tmp59__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 283 "../src/nibbles-game.vala"
									g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL], 0, (guint8) (j - 1), (guint8) (i - 1));
#line 284 "../src/nibbles-game.vala"
									break;
#line 1687 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 'r':
#line 180 "../src/nibbles-game.vala"
								case 's':
#line 180 "../src/nibbles-game.vala"
								case 't':
#line 180 "../src/nibbles-game.vala"
								case 'u':
#line 180 "../src/nibbles-game.vala"
								case 'v':
#line 180 "../src/nibbles-game.vala"
								case 'w':
#line 180 "../src/nibbles-game.vala"
								case 'x':
#line 180 "../src/nibbles-game.vala"
								case 'y':
#line 180 "../src/nibbles-game.vala"
								case 'z':
#line 1707 "nibbles-game.c"
								{
									WarpManager* _tmp60_;
									gint* _tmp61_;
									gint _tmp61__length1;
									gint _tmp61__length2;
#line 296 "../src/nibbles-game.vala"
									_tmp60_ = self->priv->warp_manager;
#line 296 "../src/nibbles-game.vala"
									warp_manager_add_warp_target (_tmp60_, (((gint) char_value) - ((gint) 'a')) + ((gint) 'A'), j, i);
#line 297 "../src/nibbles-game.vala"
									_tmp61_ = self->board;
#line 297 "../src/nibbles-game.vala"
									_tmp61__length1 = self->board_length1;
#line 297 "../src/nibbles-game.vala"
									_tmp61__length2 = self->board_length2;
#line 297 "../src/nibbles-game.vala"
									_tmp61_[(j * _tmp61__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 298 "../src/nibbles-game.vala"
									break;
#line 1727 "nibbles-game.c"
								}
#line 180 "../src/nibbles-game.vala"
								case 'a':
#line 180 "../src/nibbles-game.vala"
								case 'b':
#line 180 "../src/nibbles-game.vala"
								case 'c':
#line 180 "../src/nibbles-game.vala"
								case 'd':
#line 180 "../src/nibbles-game.vala"
								case 'e':
#line 180 "../src/nibbles-game.vala"
								case 'f':
#line 180 "../src/nibbles-game.vala"
								case 'g':
#line 180 "../src/nibbles-game.vala"
								case 'h':
#line 180 "../src/nibbles-game.vala"
								case 'i':
#line 180 "../src/nibbles-game.vala"
								case 'j':
#line 180 "../src/nibbles-game.vala"
								case 'k':
#line 180 "../src/nibbles-game.vala"
								case 'l':
#line 1753 "nibbles-game.c"
								{
									gint* _tmp62_;
									gint _tmp62__length1;
									gint _tmp62__length2;
#line 313 "../src/nibbles-game.vala"
									_tmp62_ = self->board;
#line 313 "../src/nibbles-game.vala"
									_tmp62__length1 = self->board_length1;
#line 313 "../src/nibbles-game.vala"
									_tmp62__length2 = self->board_length2;
#line 313 "../src/nibbles-game.vala"
									_tmp62_[(j * _tmp62__length2) + i] = (gint) char_value;
#line 314 "../src/nibbles-game.vala"
									break;
#line 1768 "nibbles-game.c"
								}
								default:
								{
#line 317 "../src/nibbles-game.vala"
									result = FALSE;
#line 317 "../src/nibbles-game.vala"
									_g_free0 (tmpboard);
#line 317 "../src/nibbles-game.vala"
									return result;
#line 1778 "nibbles-game.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 321 "../src/nibbles-game.vala"
	result = TRUE;
#line 321 "../src/nibbles-game.vala"
	_g_free0 (tmpboard);
#line 321 "../src/nibbles-game.vala"
	return result;
#line 1793 "nibbles-game.c"
}

static gboolean
__lambda6_ (NibblesGame* self)
{
	gboolean result;
#line 337 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) ((self->priv->bonus_cycle + 1) % 3);
#line 338 "../src/nibbles-game.vala"
	if (((gint) self->priv->bonus_cycle) == 0) {
#line 339 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, FALSE);
#line 1806 "nibbles-game.c"
	}
#line 340 "../src/nibbles-game.vala"
	result = nibbles_game_main_loop_cb (self);
#line 340 "../src/nibbles-game.vala"
	return result;
#line 1812 "nibbles-game.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ ((NibblesGame*) self);
#line 336 "../src/nibbles-game.vala"
	return result;
#line 1822 "nibbles-game.c"
}

void
nibbles_game_start (NibblesGame* self,
                    gboolean add_initial_bonus)
{
	gint _tmp0_ = 0;
	gint _tmp1_;
#line 329 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 331 "../src/nibbles-game.vala"
	if (add_initial_bonus) {
#line 332 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, TRUE);
#line 1837 "nibbles-game.c"
	}
#line 334 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, TRUE);
#line 336 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_speed;
#line 336 "../src/nibbles-game.vala"
	if (_tmp1_ == 1) {
#line 1845 "nibbles-game.c"
		gint _tmp2_;
#line 336 "../src/nibbles-game.vala"
		_tmp2_ = self->priv->_gamedelay;
#line 336 "../src/nibbles-game.vala"
		_tmp0_ = (_tmp2_ * 3) / 2;
#line 1851 "nibbles-game.c"
	} else {
		gint _tmp3_;
		gint _tmp4_;
#line 336 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_gamedelay;
#line 336 "../src/nibbles-game.vala"
		_tmp4_ = self->priv->_speed;
#line 336 "../src/nibbles-game.vala"
		_tmp0_ = _tmp3_ * _tmp4_;
#line 1861 "nibbles-game.c"
	}
#line 336 "../src/nibbles-game.vala"
	self->priv->main_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp0_, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 342 "../src/nibbles-game.vala"
	g_source_set_name_by_id (self->priv->main_id, "[Nibbles] main_loop_cb");
#line 1867 "nibbles-game.c"
}

void
nibbles_game_stop (NibblesGame* self)
{
#line 345 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, FALSE);
#line 349 "../src/nibbles-game.vala"
	if (self->priv->main_id == ((guint) 0)) {
#line 350 "../src/nibbles-game.vala"
		return;
#line 1881 "nibbles-game.c"
	}
#line 351 "../src/nibbles-game.vala"
	g_source_remove (self->priv->main_id);
#line 352 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 1887 "nibbles-game.c"
}

static void
_vala_array_add2 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 363 "../src/nibbles-game.vala"
	if ((*length) == (*size)) {
#line 363 "../src/nibbles-game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 363 "../src/nibbles-game.vala"
		*array = g_renew (gint, *array, *size);
#line 1902 "nibbles-game.c"
	}
#line 363 "../src/nibbles-game.vala"
	(*array)[(*length)++] = value;
#line 1906 "nibbles-game.c"
}

inline void
nibbles_game_reset (NibblesGame* self,
                    gint start_level)
{
	gint _tmp0_;
	gint _tmp1_;
#line 355 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/nibbles-game.vala"
	nibbles_game_set_skip_score (self, start_level != 1);
#line 358 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_progress (self);
#line 358 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 358 "../src/nibbles-game.vala"
	if (_tmp1_ != 1) {
#line 359 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, start_level);
#line 1927 "nibbles-game.c"
	} else {
		{
			gint i = 0;
#line 363 "../src/nibbles-game.vala"
			i = NIBBLES_GAME_MAX_LEVEL;
#line 1933 "nibbles-game.c"
			{
				gboolean _tmp2_ = FALSE;
#line 363 "../src/nibbles-game.vala"
				_tmp2_ = TRUE;
#line 363 "../src/nibbles-game.vala"
				while (TRUE) {
#line 363 "../src/nibbles-game.vala"
					if (!_tmp2_) {
#line 1942 "nibbles-game.c"
						gint _tmp3_;
#line 363 "../src/nibbles-game.vala"
						_tmp3_ = i;
#line 363 "../src/nibbles-game.vala"
						i = _tmp3_ - 1;
#line 363 "../src/nibbles-game.vala"
						_vala_array_add2 (&self->levels_uncompleated, &self->levels_uncompleated_length1, &self->_levels_uncompleated_size_, _tmp3_);
#line 1950 "nibbles-game.c"
					}
#line 363 "../src/nibbles-game.vala"
					_tmp2_ = FALSE;
#line 363 "../src/nibbles-game.vala"
					if (!(i > 0)) {
#line 363 "../src/nibbles-game.vala"
						break;
#line 1958 "nibbles-game.c"
					}
				}
			}
		}
#line 364 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, nibbles_game_remove_one_uncompleated_level (self));
#line 1965 "nibbles-game.c"
	}
#line 366 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, FALSE);
#line 1969 "nibbles-game.c"
}

static gint*
_vala_array_dup1 (gint* self,
                  gssize length)
{
#line 374 "../src/nibbles-game.vala"
	if (length > 0) {
#line 374 "../src/nibbles-game.vala"
		return g_memdup2 (self, length * sizeof (gint));
#line 1980 "nibbles-game.c"
	}
#line 374 "../src/nibbles-game.vala"
	return NULL;
#line 1984 "nibbles-game.c"
}

static gint*
_vala_array_dup2 (gint* self,
                  gssize length)
{
#line 376 "../src/nibbles-game.vala"
	if (length > 0) {
#line 376 "../src/nibbles-game.vala"
		return g_memdup2 (self, length * sizeof (gint));
#line 1995 "nibbles-game.c"
	}
#line 376 "../src/nibbles-game.vala"
	return NULL;
#line 1999 "nibbles-game.c"
}

static gint*
_vala_array_dup3 (gint* self,
                  gssize length)
{
#line 379 "../src/nibbles-game.vala"
	if (length > 0) {
#line 379 "../src/nibbles-game.vala"
		return g_memdup2 (self, length * sizeof (gint));
#line 2010 "nibbles-game.c"
	}
#line 379 "../src/nibbles-game.vala"
	return NULL;
#line 2014 "nibbles-game.c"
}

static gint*
_vala_array_dup4 (gint* self,
                  gssize length)
{
#line 380 "../src/nibbles-game.vala"
	if (length > 0) {
#line 380 "../src/nibbles-game.vala"
		return g_memdup2 (self, length * sizeof (gint));
#line 2025 "nibbles-game.c"
	}
#line 380 "../src/nibbles-game.vala"
	return NULL;
#line 2029 "nibbles-game.c"
}

static gint*
_vala_array_dup5 (gint* self,
                  gssize length)
{
#line 381 "../src/nibbles-game.vala"
	if (length > 0) {
#line 381 "../src/nibbles-game.vala"
		return g_memdup2 (self, length * sizeof (gint));
#line 2040 "nibbles-game.c"
	}
#line 381 "../src/nibbles-game.vala"
	return NULL;
#line 2044 "nibbles-game.c"
}

static void
_vala_array_add3 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 382 "../src/nibbles-game.vala"
	if ((*length) == (*size)) {
#line 382 "../src/nibbles-game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 382 "../src/nibbles-game.vala"
		*array = g_renew (gint, *array, *size);
#line 2059 "nibbles-game.c"
	}
#line 382 "../src/nibbles-game.vala"
	(*array)[(*length)++] = value;
#line 2063 "nibbles-game.c"
}

static gint
nibbles_game_remove_one_uncompleated_level (NibblesGame* self)
{
	gint32 index = 0;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint level = 0;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_;
	gint result;
#line 369 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 371 "../src/nibbles-game.vala"
	_tmp0_ = self->levels_uncompleated;
#line 371 "../src/nibbles-game.vala"
	_tmp0__length1 = self->levels_uncompleated_length1;
#line 371 "../src/nibbles-game.vala"
	index = g_random_int_range ((gint32) 0, (gint32) _tmp0__length1);
#line 372 "../src/nibbles-game.vala"
	_tmp1_ = self->levels_uncompleated;
#line 372 "../src/nibbles-game.vala"
	_tmp1__length1 = self->levels_uncompleated_length1;
#line 372 "../src/nibbles-game.vala"
	_tmp2_ = _tmp1_[index];
#line 372 "../src/nibbles-game.vala"
	level = _tmp2_;
#line 373 "../src/nibbles-game.vala"
	if (index == ((gint32) 0)) {
#line 2095 "nibbles-game.c"
		gint* _tmp3_;
		gint _tmp3__length1;
		gint* _tmp4_;
		gint _tmp4__length1;
		gint* _tmp5_;
		gint _tmp5__length1;
#line 374 "../src/nibbles-game.vala"
		_tmp3_ = self->levels_uncompleated;
#line 374 "../src/nibbles-game.vala"
		_tmp3__length1 = self->levels_uncompleated_length1;
#line 374 "../src/nibbles-game.vala"
		_tmp4_ = self->levels_uncompleated;
#line 374 "../src/nibbles-game.vala"
		_tmp4__length1 = self->levels_uncompleated_length1;
#line 374 "../src/nibbles-game.vala"
		_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup1 (_tmp4_ + 1, _tmp4__length1 - 1) : _tmp4_;
#line 374 "../src/nibbles-game.vala"
		_tmp5__length1 = _tmp4__length1 - 1;
#line 374 "../src/nibbles-game.vala"
		self->levels_uncompleated = (g_free (self->levels_uncompleated), NULL);
#line 374 "../src/nibbles-game.vala"
		self->levels_uncompleated = _tmp5_;
#line 374 "../src/nibbles-game.vala"
		self->levels_uncompleated_length1 = _tmp5__length1;
#line 374 "../src/nibbles-game.vala"
		self->_levels_uncompleated_size_ = self->levels_uncompleated_length1;
#line 2122 "nibbles-game.c"
	} else {
		gint* _tmp6_;
		gint _tmp6__length1;
#line 375 "../src/nibbles-game.vala"
		_tmp6_ = self->levels_uncompleated;
#line 375 "../src/nibbles-game.vala"
		_tmp6__length1 = self->levels_uncompleated_length1;
#line 375 "../src/nibbles-game.vala"
		if (index == ((gint32) (_tmp6__length1 - 1))) {
#line 2132 "nibbles-game.c"
			gint* _tmp7_;
			gint _tmp7__length1;
			gint* _tmp8_;
			gint _tmp8__length1;
#line 376 "../src/nibbles-game.vala"
			_tmp7_ = self->levels_uncompleated;
#line 376 "../src/nibbles-game.vala"
			_tmp7__length1 = self->levels_uncompleated_length1;
#line 376 "../src/nibbles-game.vala"
			_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup2 (_tmp7_ + 0, ((gint) index) - 0) : _tmp7_;
#line 376 "../src/nibbles-game.vala"
			_tmp8__length1 = ((gint) index) - 0;
#line 376 "../src/nibbles-game.vala"
			self->levels_uncompleated = (g_free (self->levels_uncompleated), NULL);
#line 376 "../src/nibbles-game.vala"
			self->levels_uncompleated = _tmp8_;
#line 376 "../src/nibbles-game.vala"
			self->levels_uncompleated_length1 = _tmp8__length1;
#line 376 "../src/nibbles-game.vala"
			self->_levels_uncompleated_size_ = self->levels_uncompleated_length1;
#line 2153 "nibbles-game.c"
		} else {
			gint* a = NULL;
			gint* _tmp9_;
			gint _tmp9__length1;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint a_length1;
			gint _a_size_;
			gint* b = NULL;
			gint* _tmp11_;
			gint _tmp11__length1;
			gint* _tmp12_;
			gint _tmp12__length1;
			gint* _tmp13_;
			gint _tmp13__length1;
			gint b_length1;
			gint _b_size_;
			gint* _tmp14_;
			gint _tmp14__length1;
			gint* _tmp15_;
			gint _tmp15__length1;
#line 379 "../src/nibbles-game.vala"
			_tmp9_ = self->levels_uncompleated;
#line 379 "../src/nibbles-game.vala"
			_tmp9__length1 = self->levels_uncompleated_length1;
#line 379 "../src/nibbles-game.vala"
			_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup3 (_tmp9_ + 0, ((gint) index) - 0) : _tmp9_;
#line 379 "../src/nibbles-game.vala"
			_tmp10__length1 = ((gint) index) - 0;
#line 379 "../src/nibbles-game.vala"
			a = _tmp10_;
#line 379 "../src/nibbles-game.vala"
			a_length1 = _tmp10__length1;
#line 379 "../src/nibbles-game.vala"
			_a_size_ = a_length1;
#line 380 "../src/nibbles-game.vala"
			_tmp11_ = self->levels_uncompleated;
#line 380 "../src/nibbles-game.vala"
			_tmp11__length1 = self->levels_uncompleated_length1;
#line 380 "../src/nibbles-game.vala"
			_tmp12_ = self->levels_uncompleated;
#line 380 "../src/nibbles-game.vala"
			_tmp12__length1 = self->levels_uncompleated_length1;
#line 380 "../src/nibbles-game.vala"
			_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup4 (_tmp12_ + ((gint) (index + 1)), _tmp12__length1 - ((gint) (index + 1))) : _tmp12_;
#line 380 "../src/nibbles-game.vala"
			_tmp13__length1 = _tmp12__length1 - ((gint) (index + 1));
#line 380 "../src/nibbles-game.vala"
			b = _tmp13_;
#line 380 "../src/nibbles-game.vala"
			b_length1 = _tmp13__length1;
#line 380 "../src/nibbles-game.vala"
			_b_size_ = b_length1;
#line 381 "../src/nibbles-game.vala"
			_tmp14_ = a;
#line 381 "../src/nibbles-game.vala"
			_tmp14__length1 = a_length1;
#line 381 "../src/nibbles-game.vala"
			_tmp15_ = (_tmp14_ != NULL) ? _vala_array_dup5 (_tmp14_, _tmp14__length1) : _tmp14_;
#line 381 "../src/nibbles-game.vala"
			_tmp15__length1 = _tmp14__length1;
#line 381 "../src/nibbles-game.vala"
			self->levels_uncompleated = (g_free (self->levels_uncompleated), NULL);
#line 381 "../src/nibbles-game.vala"
			self->levels_uncompleated = _tmp15_;
#line 381 "../src/nibbles-game.vala"
			self->levels_uncompleated_length1 = _tmp15__length1;
#line 381 "../src/nibbles-game.vala"
			self->_levels_uncompleated_size_ = self->levels_uncompleated_length1;
#line 2223 "nibbles-game.c"
			{
				gint i = 0;
#line 382 "../src/nibbles-game.vala"
				i = 0;
#line 2228 "nibbles-game.c"
				{
					gboolean _tmp16_ = FALSE;
#line 382 "../src/nibbles-game.vala"
					_tmp16_ = TRUE;
#line 382 "../src/nibbles-game.vala"
					while (TRUE) {
#line 2235 "nibbles-game.c"
						gint* _tmp20_;
						gint _tmp20__length1;
#line 382 "../src/nibbles-game.vala"
						if (!_tmp16_) {
#line 2240 "nibbles-game.c"
							gint* _tmp17_;
							gint _tmp17__length1;
							gint _tmp18_;
							gint _tmp19_;
#line 382 "../src/nibbles-game.vala"
							_tmp17_ = b;
#line 382 "../src/nibbles-game.vala"
							_tmp17__length1 = b_length1;
#line 382 "../src/nibbles-game.vala"
							_tmp18_ = i;
#line 382 "../src/nibbles-game.vala"
							i = _tmp18_ + 1;
#line 382 "../src/nibbles-game.vala"
							_tmp19_ = _tmp17_[_tmp18_];
#line 382 "../src/nibbles-game.vala"
							_vala_array_add3 (&self->levels_uncompleated, &self->levels_uncompleated_length1, &self->_levels_uncompleated_size_, _tmp19_);
#line 2257 "nibbles-game.c"
						}
#line 382 "../src/nibbles-game.vala"
						_tmp16_ = FALSE;
#line 382 "../src/nibbles-game.vala"
						_tmp20_ = b;
#line 382 "../src/nibbles-game.vala"
						_tmp20__length1 = b_length1;
#line 382 "../src/nibbles-game.vala"
						if (!(i < _tmp20__length1)) {
#line 382 "../src/nibbles-game.vala"
							break;
#line 2269 "nibbles-game.c"
						}
					}
				}
			}
#line 375 "../src/nibbles-game.vala"
			b = (g_free (b), NULL);
#line 375 "../src/nibbles-game.vala"
			a = (g_free (a), NULL);
#line 2278 "nibbles-game.c"
		}
	}
#line 384 "../src/nibbles-game.vala"
	result = level;
#line 384 "../src/nibbles-game.vala"
	return result;
#line 2285 "nibbles-game.c"
}

static void
nibbles_game_end (NibblesGame* self)
{
#line 387 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 389 "../src/nibbles-game.vala"
	nibbles_game_stop (self);
#line 390 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 2297 "nibbles-game.c"
}

static gboolean
_game_status_equal (const GameStatus * s1,
                    const GameStatus * s2)
{
#line 396 "../src/nibbles-game.vala"
	if (s1 == s2) {
#line 396 "../src/nibbles-game.vala"
		return TRUE;
#line 2308 "nibbles-game.c"
	}
#line 396 "../src/nibbles-game.vala"
	if (s1 == NULL) {
#line 396 "../src/nibbles-game.vala"
		return FALSE;
#line 2314 "nibbles-game.c"
	}
#line 396 "../src/nibbles-game.vala"
	if (s2 == NULL) {
#line 396 "../src/nibbles-game.vala"
		return FALSE;
#line 2320 "nibbles-game.c"
	}
#line 396 "../src/nibbles-game.vala"
	return (*s1) == (*s2);
#line 2324 "nibbles-game.c"
}

static gboolean
nibbles_game_main_loop_cb (NibblesGame* self)
{
	GameStatus* status = NULL;
	GameStatus* _tmp0_;
	GameStatus* _tmp1_;
	GameStatus _tmp2_;
	gboolean result;
#line 393 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 395 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_game_status (self);
#line 395 "../src/nibbles-game.vala"
	status = _tmp0_;
#line 396 "../src/nibbles-game.vala"
	_tmp1_ = status;
#line 396 "../src/nibbles-game.vala"
	_tmp2_ = GAME_STATUS_GAMEOVER;
#line 396 "../src/nibbles-game.vala"
	if (_game_status_equal (_tmp1_, &_tmp2_) == TRUE) {
#line 2347 "nibbles-game.c"
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Worm* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 398 "../src/nibbles-game.vala"
		nibbles_game_end (self);
#line 400 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_worms;
#line 400 "../src/nibbles-game.vala"
		_tmp4_ = gee_linked_list_first (_tmp3_);
#line 400 "../src/nibbles-game.vala"
		_tmp5_ = (Worm*) _tmp4_;
#line 400 "../src/nibbles-game.vala"
		_tmp6_ = worm_get_score (_tmp5_);
#line 400 "../src/nibbles-game.vala"
		_tmp7_ = _tmp6_;
#line 400 "../src/nibbles-game.vala"
		_tmp8_ = self->priv->_current_level;
#line 400 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp7_, _tmp8_);
#line 400 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp5_);
#line 402 "../src/nibbles-game.vala"
		result = G_SOURCE_REMOVE;
#line 402 "../src/nibbles-game.vala"
		_g_free0 (status);
#line 402 "../src/nibbles-game.vala"
		return result;
#line 2378 "nibbles-game.c"
	} else {
		GameStatus* _tmp9_;
		GameStatus _tmp10_;
#line 404 "../src/nibbles-game.vala"
		_tmp9_ = status;
#line 404 "../src/nibbles-game.vala"
		_tmp10_ = GAME_STATUS_VICTORY;
#line 404 "../src/nibbles-game.vala"
		if (_game_status_equal (_tmp9_, &_tmp10_) == TRUE) {
#line 2388 "nibbles-game.c"
			Worm* winner = NULL;
			Worm* _tmp11_;
			Worm* _tmp12_;
#line 406 "../src/nibbles-game.vala"
			nibbles_game_end (self);
#line 408 "../src/nibbles-game.vala"
			_tmp11_ = nibbles_game_get_winner (self);
#line 408 "../src/nibbles-game.vala"
			winner = _tmp11_;
#line 409 "../src/nibbles-game.vala"
			_tmp12_ = winner;
#line 409 "../src/nibbles-game.vala"
			if (_tmp12_ != NULL) {
#line 2402 "nibbles-game.c"
				Worm* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
#line 410 "../src/nibbles-game.vala"
				_tmp13_ = winner;
#line 410 "../src/nibbles-game.vala"
				_tmp14_ = worm_get_score (_tmp13_);
#line 410 "../src/nibbles-game.vala"
				_tmp15_ = _tmp14_;
#line 410 "../src/nibbles-game.vala"
				_tmp16_ = self->priv->_current_level;
#line 410 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp15_, _tmp16_);
#line 2417 "nibbles-game.c"
			}
#line 412 "../src/nibbles-game.vala"
			result = G_SOURCE_REMOVE;
#line 412 "../src/nibbles-game.vala"
			_g_object_unref0 (winner);
#line 412 "../src/nibbles-game.vala"
			_g_free0 (status);
#line 412 "../src/nibbles-game.vala"
			return result;
#line 2427 "nibbles-game.c"
		} else {
			GameStatus* _tmp17_;
			GameStatus _tmp18_;
#line 414 "../src/nibbles-game.vala"
			_tmp17_ = status;
#line 414 "../src/nibbles-game.vala"
			_tmp18_ = GAME_STATUS_NEWROUND;
#line 414 "../src/nibbles-game.vala"
			if (_game_status_equal (_tmp17_, &_tmp18_) == TRUE) {
#line 2437 "nibbles-game.c"
				gint _tmp19_;
				gint _tmp20_;
#line 416 "../src/nibbles-game.vala"
				nibbles_game_stop (self);
#line 418 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 419 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL], 0);
#line 421 "../src/nibbles-game.vala"
				_tmp19_ = nibbles_game_get_progress (self);
#line 421 "../src/nibbles-game.vala"
				_tmp20_ = _tmp19_;
#line 421 "../src/nibbles-game.vala"
				if (_tmp20_ == 0) {
#line 2452 "nibbles-game.c"
					gint _tmp21_;
					gint _tmp22_;
#line 423 "../src/nibbles-game.vala"
					_tmp21_ = self->priv->_current_level;
#line 423 "../src/nibbles-game.vala"
					nibbles_game_set_current_level (self, _tmp21_ + 1);
#line 424 "../src/nibbles-game.vala"
					_tmp22_ = self->priv->_current_level;
#line 424 "../src/nibbles-game.vala"
					if (_tmp22_ == (NIBBLES_GAME_MAX_LEVEL + 1)) {
#line 2463 "nibbles-game.c"
						GeeLinkedList* _tmp23_;
						gpointer _tmp24_;
						Worm* _tmp25_;
						gint _tmp26_;
						gint _tmp27_;
						gint _tmp28_;
#line 425 "../src/nibbles-game.vala"
						_tmp23_ = self->priv->_worms;
#line 425 "../src/nibbles-game.vala"
						_tmp24_ = gee_linked_list_first (_tmp23_);
#line 425 "../src/nibbles-game.vala"
						_tmp25_ = (Worm*) _tmp24_;
#line 425 "../src/nibbles-game.vala"
						_tmp26_ = worm_get_score (_tmp25_);
#line 425 "../src/nibbles-game.vala"
						_tmp27_ = _tmp26_;
#line 425 "../src/nibbles-game.vala"
						_tmp28_ = self->priv->_current_level;
#line 425 "../src/nibbles-game.vala"
						g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp27_, _tmp28_);
#line 425 "../src/nibbles-game.vala"
						_g_object_unref0 (_tmp25_);
#line 2486 "nibbles-game.c"
					}
				} else {
					gint _tmp29_;
					gint _tmp30_;
#line 427 "../src/nibbles-game.vala"
					_tmp29_ = nibbles_game_get_progress (self);
#line 427 "../src/nibbles-game.vala"
					_tmp30_ = _tmp29_;
#line 427 "../src/nibbles-game.vala"
					if (_tmp30_ == 1) {
#line 2497 "nibbles-game.c"
						gint* _tmp31_;
						gint _tmp31__length1;
#line 429 "../src/nibbles-game.vala"
						_tmp31_ = self->levels_uncompleated;
#line 429 "../src/nibbles-game.vala"
						_tmp31__length1 = self->levels_uncompleated_length1;
#line 429 "../src/nibbles-game.vala"
						if (_tmp31__length1 > 0) {
#line 430 "../src/nibbles-game.vala"
							nibbles_game_set_current_level (self, nibbles_game_remove_one_uncompleated_level (self));
#line 2508 "nibbles-game.c"
						} else {
							GeeLinkedList* _tmp32_;
							gpointer _tmp33_;
							Worm* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
#line 432 "../src/nibbles-game.vala"
							_tmp32_ = self->priv->_worms;
#line 432 "../src/nibbles-game.vala"
							_tmp33_ = gee_linked_list_first (_tmp32_);
#line 432 "../src/nibbles-game.vala"
							_tmp34_ = (Worm*) _tmp33_;
#line 432 "../src/nibbles-game.vala"
							_tmp35_ = worm_get_score (_tmp34_);
#line 432 "../src/nibbles-game.vala"
							_tmp36_ = _tmp35_;
#line 432 "../src/nibbles-game.vala"
							_tmp37_ = self->priv->_current_level;
#line 432 "../src/nibbles-game.vala"
							g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp36_, _tmp37_);
#line 432 "../src/nibbles-game.vala"
							_g_object_unref0 (_tmp34_);
#line 2532 "nibbles-game.c"
						}
					}
				}
#line 436 "../src/nibbles-game.vala"
				result = G_SOURCE_REMOVE;
#line 436 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 436 "../src/nibbles-game.vala"
				return result;
#line 2542 "nibbles-game.c"
			} else {
#line 440 "../src/nibbles-game.vala"
				nibbles_game_move_worms (self);
#line 441 "../src/nibbles-game.vala"
				result = G_SOURCE_CONTINUE;
#line 441 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 441 "../src/nibbles-game.vala"
				return result;
#line 2552 "nibbles-game.c"
			}
		}
	}
}

static GeeList*
_nibbles_game_get_other_worms_worm_get_other_worms_type (Worm* _self_,
                                                         gpointer self)
{
	GeeList* result;
	result = nibbles_game_get_other_worms ((NibblesGame*) self, _self_);
#line 456 "../src/nibbles-game.vala"
	return result;
#line 2566 "nibbles-game.c"
}

static GeeList*
_nibbles_game_get_bonuses_worm_get_bonuses_type (gpointer self)
{
	GeeList* result;
	result = nibbles_game_get_bonuses ((NibblesGame*) self);
#line 456 "../src/nibbles-game.vala"
	return result;
#line 2576 "nibbles-game.c"
}

static void
_nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                               gpointer self)
{
#line 457 "../src/nibbles-game.vala"
	nibbles_game_bonus_found_cb ((NibblesGame*) self, _sender);
#line 2585 "nibbles-game.c"
}

void
nibbles_game_create_worms (NibblesGame* self,
                           GeeArrayList* worm_settings)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 449 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 451 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 451 "../src/nibbles-game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 453 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_numai;
#line 453 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->_numhumans;
#line 453 "../src/nibbles-game.vala"
	nibbles_game_set_numworms (self, _tmp1_ + _tmp2_);
#line 2607 "nibbles-game.c"
	{
		gint i = 0;
#line 454 "../src/nibbles-game.vala"
		i = 0;
#line 2612 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 454 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 454 "../src/nibbles-game.vala"
			while (TRUE) {
#line 2619 "nibbles-game.c"
				gint _tmp5_;
				Worm* worm = NULL;
				guint8 _tmp6_;
				guint8 _tmp7_;
				Worm* _tmp8_;
				Worm* _tmp9_;
				Worm* _tmp10_;
				gint _tmp11_;
				GeeLinkedList* _tmp12_;
				Worm* _tmp13_;
#line 454 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 2632 "nibbles-game.c"
					gint _tmp4_;
#line 454 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 454 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 2638 "nibbles-game.c"
				}
#line 454 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 454 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_numworms;
#line 454 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 454 "../src/nibbles-game.vala"
					break;
#line 2648 "nibbles-game.c"
				}
#line 456 "../src/nibbles-game.vala"
				_tmp6_ = self->priv->_width;
#line 456 "../src/nibbles-game.vala"
				_tmp7_ = self->priv->_height;
#line 456 "../src/nibbles-game.vala"
				_tmp8_ = worm_new (i, _tmp6_, _tmp7_, _nibbles_game_get_other_worms_worm_get_other_worms_type, self, _nibbles_game_get_bonuses_worm_get_bonuses_type, self);
#line 456 "../src/nibbles-game.vala"
				worm = _tmp8_;
#line 457 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 457 "../src/nibbles-game.vala"
				g_signal_connect_object (_tmp9_, "bonus-found", (GCallback) _nibbles_game_bonus_found_cb_worm_bonus_found, self, 0);
#line 458 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 458 "../src/nibbles-game.vala"
				_tmp11_ = self->priv->_numhumans;
#line 458 "../src/nibbles-game.vala"
				_tmp10_->is_human = i < _tmp11_;
#line 459 "../src/nibbles-game.vala"
				_tmp12_ = self->priv->_worms;
#line 459 "../src/nibbles-game.vala"
				_tmp13_ = worm;
#line 459 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 454 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 2676 "nibbles-game.c"
			}
		}
	}
#line 461 "../src/nibbles-game.vala"
	if (worm_settings != NULL) {
#line 462 "../src/nibbles-game.vala"
		nibbles_game_load_worm_properties (self, worm_settings);
#line 2684 "nibbles-game.c"
	}
}

void
nibbles_game_add_worms (NibblesGame* self)
{
#line 466 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 2693 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 468 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 468 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 468 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 468 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 468 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 468 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 468 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 468 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2718 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
#line 468 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 468 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 468 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 468 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 468 "../src/nibbles-game.vala"
				break;
#line 2738 "nibbles-game.c"
			}
#line 468 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 468 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 468 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 469 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 469 "../src/nibbles-game.vala"
			_tmp9_ = self->board;
#line 469 "../src/nibbles-game.vala"
			_tmp9__length1 = self->board_length1;
#line 469 "../src/nibbles-game.vala"
			_tmp9__length2 = self->board_length2;
#line 469 "../src/nibbles-game.vala"
			worm_spawn (_tmp8_, _tmp9_, (gint) _tmp9__length1, (gint) _tmp9__length2);
#line 468 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2758 "nibbles-game.c"
		}
	}
}

static void
nibbles_game_move_worms (NibblesGame* self)
{
	Boni* _tmp13_;
	guint8 missed_bonuses_to_replace = 0U;
	Boni* _tmp28_;
	guint8 _tmp29_ = 0U;
	GeeLinkedList* dead_worms = NULL;
	GeeLinkedList* _tmp32_;
#line 472 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 2774 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 474 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 474 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 474 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 474 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 474 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 474 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 474 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 474 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2799 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			Worm* _tmp10_;
#line 474 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 474 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 474 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 474 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 474 "../src/nibbles-game.vala"
				break;
#line 2817 "nibbles-game.c"
			}
#line 474 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 474 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 474 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 476 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 476 "../src/nibbles-game.vala"
			if (_tmp8_->rounds_to_stay_still == 1) {
#line 2829 "nibbles-game.c"
				Worm* _tmp9_;
#line 477 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 477 "../src/nibbles-game.vala"
				_tmp9_->is_stopped = FALSE;
#line 2835 "nibbles-game.c"
			}
#line 478 "../src/nibbles-game.vala"
			_tmp10_ = worm;
#line 478 "../src/nibbles-game.vala"
			if (_tmp10_->rounds_to_stay_still > 0) {
#line 2841 "nibbles-game.c"
				Worm* _tmp11_;
				gint _tmp12_;
#line 479 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 479 "../src/nibbles-game.vala"
				_tmp11_->rounds_to_stay_still = _tmp11_->rounds_to_stay_still - 1;
#line 479 "../src/nibbles-game.vala"
				_tmp12_ = _tmp11_->rounds_to_stay_still;
#line 2850 "nibbles-game.c"
			}
#line 474 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2854 "nibbles-game.c"
		}
	}
#line 482 "../src/nibbles-game.vala"
	_tmp13_ = self->priv->boni;
#line 482 "../src/nibbles-game.vala"
	if (boni_too_many_missed (_tmp13_)) {
#line 2861 "nibbles-game.c"
		{
			GeeLinkedList* _worm_list = NULL;
			GeeLinkedList* _tmp14_;
			gint _worm_size = 0;
			GeeLinkedList* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _worm_index = 0;
#line 484 "../src/nibbles-game.vala"
			_tmp14_ = self->priv->_worms;
#line 484 "../src/nibbles-game.vala"
			_worm_list = _tmp14_;
#line 484 "../src/nibbles-game.vala"
			_tmp15_ = _worm_list;
#line 484 "../src/nibbles-game.vala"
			_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 484 "../src/nibbles-game.vala"
			_tmp17_ = _tmp16_;
#line 484 "../src/nibbles-game.vala"
			_worm_size = _tmp17_;
#line 484 "../src/nibbles-game.vala"
			_worm_index = -1;
#line 484 "../src/nibbles-game.vala"
			while (TRUE) {
#line 2886 "nibbles-game.c"
				gint _tmp18_;
				gint _tmp19_;
				Worm* worm = NULL;
				GeeLinkedList* _tmp20_;
				gpointer _tmp21_;
				Worm* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 484 "../src/nibbles-game.vala"
				_worm_index = _worm_index + 1;
#line 484 "../src/nibbles-game.vala"
				_tmp18_ = _worm_index;
#line 484 "../src/nibbles-game.vala"
				_tmp19_ = _worm_size;
#line 484 "../src/nibbles-game.vala"
				if (!(_tmp18_ < _tmp19_)) {
#line 484 "../src/nibbles-game.vala"
					break;
#line 2905 "nibbles-game.c"
				}
#line 484 "../src/nibbles-game.vala"
				_tmp20_ = _worm_list;
#line 484 "../src/nibbles-game.vala"
				_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _worm_index);
#line 484 "../src/nibbles-game.vala"
				worm = (Worm*) _tmp21_;
#line 486 "../src/nibbles-game.vala"
				_tmp22_ = worm;
#line 486 "../src/nibbles-game.vala"
				_tmp23_ = worm_get_score (_tmp22_);
#line 486 "../src/nibbles-game.vala"
				_tmp24_ = _tmp23_;
#line 486 "../src/nibbles-game.vala"
				if (_tmp24_ > 0) {
#line 2921 "nibbles-game.c"
					Worm* _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
#line 487 "../src/nibbles-game.vala"
					_tmp25_ = worm;
#line 487 "../src/nibbles-game.vala"
					_tmp26_ = worm_get_score (_tmp25_);
#line 487 "../src/nibbles-game.vala"
					_tmp27_ = _tmp26_;
#line 487 "../src/nibbles-game.vala"
					worm_set_score (_tmp25_, _tmp27_ - 1);
#line 2933 "nibbles-game.c"
				}
#line 484 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 2937 "nibbles-game.c"
			}
		}
	}
#line 492 "../src/nibbles-game.vala"
	_tmp28_ = self->priv->boni;
#line 492 "../src/nibbles-game.vala"
	boni_on_worms_move (_tmp28_, &_tmp29_);
#line 492 "../src/nibbles-game.vala"
	missed_bonuses_to_replace = _tmp29_;
#line 2947 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 493 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 2952 "nibbles-game.c"
		{
			gboolean _tmp30_ = FALSE;
#line 493 "../src/nibbles-game.vala"
			_tmp30_ = TRUE;
#line 493 "../src/nibbles-game.vala"
			while (TRUE) {
#line 493 "../src/nibbles-game.vala"
				if (!_tmp30_) {
#line 2961 "nibbles-game.c"
					guint8 _tmp31_;
#line 493 "../src/nibbles-game.vala"
					_tmp31_ = i;
#line 493 "../src/nibbles-game.vala"
					i = _tmp31_ + 1;
#line 2967 "nibbles-game.c"
				}
#line 493 "../src/nibbles-game.vala"
				_tmp30_ = FALSE;
#line 493 "../src/nibbles-game.vala"
				if (!(i < missed_bonuses_to_replace)) {
#line 493 "../src/nibbles-game.vala"
					break;
#line 2975 "nibbles-game.c"
				}
#line 494 "../src/nibbles-game.vala"
				nibbles_game_add_bonus (self, TRUE);
#line 2979 "nibbles-game.c"
			}
		}
	}
#line 496 "../src/nibbles-game.vala"
	_tmp32_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 496 "../src/nibbles-game.vala"
	dead_worms = _tmp32_;
#line 2987 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp33_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _worm_index = 0;
#line 499 "../src/nibbles-game.vala"
		_tmp33_ = self->priv->_worms;
#line 499 "../src/nibbles-game.vala"
		_worm_list = _tmp33_;
#line 499 "../src/nibbles-game.vala"
		_tmp34_ = _worm_list;
#line 499 "../src/nibbles-game.vala"
		_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 499 "../src/nibbles-game.vala"
		_tmp36_ = _tmp35_;
#line 499 "../src/nibbles-game.vala"
		_worm_size = _tmp36_;
#line 499 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 499 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3012 "nibbles-game.c"
			gint _tmp37_;
			gint _tmp38_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp39_;
			gpointer _tmp40_;
			gboolean _tmp41_ = FALSE;
			Worm* _tmp42_;
			Worm* _tmp47_;
#line 499 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 499 "../src/nibbles-game.vala"
			_tmp37_ = _worm_index;
#line 499 "../src/nibbles-game.vala"
			_tmp38_ = _worm_size;
#line 499 "../src/nibbles-game.vala"
			if (!(_tmp37_ < _tmp38_)) {
#line 499 "../src/nibbles-game.vala"
				break;
#line 3031 "nibbles-game.c"
			}
#line 499 "../src/nibbles-game.vala"
			_tmp39_ = _worm_list;
#line 499 "../src/nibbles-game.vala"
			_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _worm_index);
#line 499 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp40_;
#line 501 "../src/nibbles-game.vala"
			_tmp42_ = worm;
#line 501 "../src/nibbles-game.vala"
			if (_tmp42_->is_stopped) {
#line 501 "../src/nibbles-game.vala"
				_tmp41_ = TRUE;
#line 3045 "nibbles-game.c"
			} else {
				Worm* _tmp43_;
				WormPositions* _tmp44_;
				gboolean _tmp45_;
				gboolean _tmp46_;
#line 502 "../src/nibbles-game.vala"
				_tmp43_ = worm;
#line 502 "../src/nibbles-game.vala"
				_tmp44_ = _tmp43_->list;
#line 502 "../src/nibbles-game.vala"
				_tmp45_ = gee_collection_get_is_empty ((GeeCollection*) _tmp44_);
#line 502 "../src/nibbles-game.vala"
				_tmp46_ = _tmp45_;
#line 502 "../src/nibbles-game.vala"
				_tmp41_ = _tmp46_;
#line 3061 "nibbles-game.c"
			}
#line 501 "../src/nibbles-game.vala"
			if (_tmp41_) {
#line 503 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 503 "../src/nibbles-game.vala"
				continue;
#line 3069 "nibbles-game.c"
			}
#line 505 "../src/nibbles-game.vala"
			_tmp47_ = worm;
#line 505 "../src/nibbles-game.vala"
			if (!_tmp47_->is_human) {
#line 3075 "nibbles-game.c"
				Worm* _tmp48_;
				gint* _tmp49_;
				gint _tmp49__length1;
				gint _tmp49__length2;
				GeeLinkedList* _tmp50_;
#line 506 "../src/nibbles-game.vala"
				_tmp48_ = worm;
#line 506 "../src/nibbles-game.vala"
				_tmp49_ = self->board;
#line 506 "../src/nibbles-game.vala"
				_tmp49__length1 = self->board_length1;
#line 506 "../src/nibbles-game.vala"
				_tmp49__length2 = self->board_length2;
#line 506 "../src/nibbles-game.vala"
				_tmp50_ = self->priv->_worms;
#line 506 "../src/nibbles-game.vala"
				worm_ai_move (_tmp48_, _tmp49_, (gint) _tmp49__length1, (gint) _tmp49__length2, _tmp50_);
#line 3093 "nibbles-game.c"
			}
#line 499 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3097 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp51_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gint _worm_index = 0;
#line 510 "../src/nibbles-game.vala"
		_tmp51_ = self->priv->_worms;
#line 510 "../src/nibbles-game.vala"
		_worm_list = _tmp51_;
#line 510 "../src/nibbles-game.vala"
		_tmp52_ = _worm_list;
#line 510 "../src/nibbles-game.vala"
		_tmp53_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp52_);
#line 510 "../src/nibbles-game.vala"
		_tmp54_ = _tmp53_;
#line 510 "../src/nibbles-game.vala"
		_worm_size = _tmp54_;
#line 510 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 510 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3124 "nibbles-game.c"
			gint _tmp55_;
			gint _tmp56_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp57_;
			gpointer _tmp58_;
			gboolean _tmp59_ = FALSE;
			Worm* _tmp60_;
			Position position = {0};
			Worm* _tmp65_;
			Position _tmp66_ = {0};
			guint8 target_x = 0U;
			guint8 target_y = 0U;
			gboolean _tmp67_ = FALSE;
			Worm* _tmp68_;
			WormDirection _tmp69_;
			WormDirection _tmp70_;
			WarpManager* _tmp74_;
			Position _tmp75_;
			Position _tmp76_;
			guint8 _tmp77_ = 0U;
			guint8 _tmp78_ = 0U;
			gboolean _tmp79_;
			Worm* _tmp81_;
			gint* _tmp82_;
			gint _tmp82__length1;
			gint _tmp82__length2;
			GeeLinkedList* _tmp83_;
			Position _tmp84_;
#line 510 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 510 "../src/nibbles-game.vala"
			_tmp55_ = _worm_index;
#line 510 "../src/nibbles-game.vala"
			_tmp56_ = _worm_size;
#line 510 "../src/nibbles-game.vala"
			if (!(_tmp55_ < _tmp56_)) {
#line 510 "../src/nibbles-game.vala"
				break;
#line 3163 "nibbles-game.c"
			}
#line 510 "../src/nibbles-game.vala"
			_tmp57_ = _worm_list;
#line 510 "../src/nibbles-game.vala"
			_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) _tmp57_, _worm_index);
#line 510 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp58_;
#line 512 "../src/nibbles-game.vala"
			_tmp60_ = worm;
#line 512 "../src/nibbles-game.vala"
			if (_tmp60_->is_stopped) {
#line 512 "../src/nibbles-game.vala"
				_tmp59_ = TRUE;
#line 3177 "nibbles-game.c"
			} else {
				Worm* _tmp61_;
				WormPositions* _tmp62_;
				gboolean _tmp63_;
				gboolean _tmp64_;
#line 513 "../src/nibbles-game.vala"
				_tmp61_ = worm;
#line 513 "../src/nibbles-game.vala"
				_tmp62_ = _tmp61_->list;
#line 513 "../src/nibbles-game.vala"
				_tmp63_ = gee_collection_get_is_empty ((GeeCollection*) _tmp62_);
#line 513 "../src/nibbles-game.vala"
				_tmp64_ = _tmp63_;
#line 513 "../src/nibbles-game.vala"
				_tmp59_ = _tmp64_;
#line 3193 "nibbles-game.c"
			}
#line 512 "../src/nibbles-game.vala"
			if (_tmp59_) {
#line 514 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 514 "../src/nibbles-game.vala"
				continue;
#line 3201 "nibbles-game.c"
			}
#line 516 "../src/nibbles-game.vala"
			_tmp65_ = worm;
#line 516 "../src/nibbles-game.vala"
			worm_position_move (_tmp65_, &_tmp66_);
#line 516 "../src/nibbles-game.vala"
			position = _tmp66_;
#line 520 "../src/nibbles-game.vala"
			_tmp68_ = worm;
#line 520 "../src/nibbles-game.vala"
			_tmp69_ = worm_get_direction (_tmp68_);
#line 520 "../src/nibbles-game.vala"
			_tmp70_ = _tmp69_;
#line 520 "../src/nibbles-game.vala"
			if (_tmp70_ == WORM_DIRECTION_LEFT) {
#line 520 "../src/nibbles-game.vala"
				_tmp67_ = TRUE;
#line 3219 "nibbles-game.c"
			} else {
				Worm* _tmp71_;
				WormDirection _tmp72_;
				WormDirection _tmp73_;
#line 520 "../src/nibbles-game.vala"
				_tmp71_ = worm;
#line 520 "../src/nibbles-game.vala"
				_tmp72_ = worm_get_direction (_tmp71_);
#line 520 "../src/nibbles-game.vala"
				_tmp73_ = _tmp72_;
#line 520 "../src/nibbles-game.vala"
				_tmp67_ = _tmp73_ == WORM_DIRECTION_RIGHT;
#line 3232 "nibbles-game.c"
			}
#line 519 "../src/nibbles-game.vala"
			_tmp74_ = self->priv->warp_manager;
#line 519 "../src/nibbles-game.vala"
			_tmp75_ = position;
#line 519 "../src/nibbles-game.vala"
			_tmp76_ = position;
#line 519 "../src/nibbles-game.vala"
			_tmp79_ = warp_manager_get_warp_target (_tmp74_, _tmp75_.x, _tmp76_.y, _tmp67_, &_tmp77_, &_tmp78_);
#line 519 "../src/nibbles-game.vala"
			target_x = _tmp77_;
#line 519 "../src/nibbles-game.vala"
			target_y = _tmp78_;
#line 519 "../src/nibbles-game.vala"
			if (_tmp79_) {
#line 3248 "nibbles-game.c"
				Position _tmp80_ = {0};
#line 522 "../src/nibbles-game.vala"
				memset (&_tmp80_, 0, sizeof (Position));
#line 522 "../src/nibbles-game.vala"
				_tmp80_.x = target_x;
#line 522 "../src/nibbles-game.vala"
				_tmp80_.y = target_y;
#line 522 "../src/nibbles-game.vala"
				position = _tmp80_;
#line 3258 "nibbles-game.c"
			}
#line 524 "../src/nibbles-game.vala"
			_tmp81_ = worm;
#line 524 "../src/nibbles-game.vala"
			_tmp82_ = self->board;
#line 524 "../src/nibbles-game.vala"
			_tmp82__length1 = self->board_length1;
#line 524 "../src/nibbles-game.vala"
			_tmp82__length2 = self->board_length2;
#line 524 "../src/nibbles-game.vala"
			_tmp83_ = self->priv->_worms;
#line 524 "../src/nibbles-game.vala"
			_tmp84_ = position;
#line 524 "../src/nibbles-game.vala"
			if (!worm_can_move_to (_tmp81_, _tmp82_, (gint) _tmp82__length1, (gint) _tmp82__length2, _tmp83_, &_tmp84_)) {
#line 3274 "nibbles-game.c"
				GeeLinkedList* _tmp85_;
				Worm* _tmp86_;
#line 526 "../src/nibbles-game.vala"
				_tmp85_ = dead_worms;
#line 526 "../src/nibbles-game.vala"
				_tmp86_ = worm;
#line 526 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp85_, _tmp86_);
#line 527 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "crash");
#line 3285 "nibbles-game.c"
			}
#line 510 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3289 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp87_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp88_;
		gint _tmp89_;
		gint _tmp90_;
		gint _worm_index = 0;
#line 532 "../src/nibbles-game.vala"
		_tmp87_ = self->priv->_worms;
#line 532 "../src/nibbles-game.vala"
		_worm_list = _tmp87_;
#line 532 "../src/nibbles-game.vala"
		_tmp88_ = _worm_list;
#line 532 "../src/nibbles-game.vala"
		_tmp89_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp88_);
#line 532 "../src/nibbles-game.vala"
		_tmp90_ = _tmp89_;
#line 532 "../src/nibbles-game.vala"
		_worm_size = _tmp90_;
#line 532 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 532 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3316 "nibbles-game.c"
			gint _tmp91_;
			gint _tmp92_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp93_;
			gpointer _tmp94_;
			gboolean _tmp95_ = FALSE;
			gboolean _tmp96_ = FALSE;
			Worm* _tmp97_;
			Worm* _tmp104_;
			gint* _tmp105_;
			gint _tmp105__length1;
			gint _tmp105__length2;
			Worm* _tmp106_;
			Position _tmp107_ = {0};
			Position _tmp108_;
			Worm* _tmp109_;
			Position _tmp110_ = {0};
			Position _tmp111_;
			gint _tmp112_;
#line 532 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 532 "../src/nibbles-game.vala"
			_tmp91_ = _worm_index;
#line 532 "../src/nibbles-game.vala"
			_tmp92_ = _worm_size;
#line 532 "../src/nibbles-game.vala"
			if (!(_tmp91_ < _tmp92_)) {
#line 532 "../src/nibbles-game.vala"
				break;
#line 3346 "nibbles-game.c"
			}
#line 532 "../src/nibbles-game.vala"
			_tmp93_ = _worm_list;
#line 532 "../src/nibbles-game.vala"
			_tmp94_ = gee_abstract_list_get ((GeeAbstractList*) _tmp93_, _worm_index);
#line 532 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp94_;
#line 534 "../src/nibbles-game.vala"
			_tmp97_ = worm;
#line 534 "../src/nibbles-game.vala"
			if (_tmp97_->is_stopped) {
#line 534 "../src/nibbles-game.vala"
				_tmp96_ = TRUE;
#line 3360 "nibbles-game.c"
			} else {
				Worm* _tmp98_;
				WormPositions* _tmp99_;
				gboolean _tmp100_;
				gboolean _tmp101_;
#line 535 "../src/nibbles-game.vala"
				_tmp98_ = worm;
#line 535 "../src/nibbles-game.vala"
				_tmp99_ = _tmp98_->list;
#line 535 "../src/nibbles-game.vala"
				_tmp100_ = gee_collection_get_is_empty ((GeeCollection*) _tmp99_);
#line 535 "../src/nibbles-game.vala"
				_tmp101_ = _tmp100_;
#line 535 "../src/nibbles-game.vala"
				_tmp96_ = _tmp101_;
#line 3376 "nibbles-game.c"
			}
#line 534 "../src/nibbles-game.vala"
			if (_tmp96_) {
#line 534 "../src/nibbles-game.vala"
				_tmp95_ = TRUE;
#line 3382 "nibbles-game.c"
			} else {
				GeeLinkedList* _tmp102_;
				Worm* _tmp103_;
#line 536 "../src/nibbles-game.vala"
				_tmp102_ = dead_worms;
#line 536 "../src/nibbles-game.vala"
				_tmp103_ = worm;
#line 536 "../src/nibbles-game.vala"
				_tmp95_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp102_, _tmp103_);
#line 3392 "nibbles-game.c"
			}
#line 534 "../src/nibbles-game.vala"
			if (_tmp95_) {
#line 537 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 537 "../src/nibbles-game.vala"
				continue;
#line 3400 "nibbles-game.c"
			}
#line 539 "../src/nibbles-game.vala"
			_tmp104_ = worm;
#line 539 "../src/nibbles-game.vala"
			worm_move_part_1 (_tmp104_);
#line 540 "../src/nibbles-game.vala"
			_tmp105_ = self->board;
#line 540 "../src/nibbles-game.vala"
			_tmp105__length1 = self->board_length1;
#line 540 "../src/nibbles-game.vala"
			_tmp105__length2 = self->board_length2;
#line 540 "../src/nibbles-game.vala"
			_tmp106_ = worm;
#line 540 "../src/nibbles-game.vala"
			worm_get_head (_tmp106_, &_tmp107_);
#line 540 "../src/nibbles-game.vala"
			_tmp108_ = _tmp107_;
#line 540 "../src/nibbles-game.vala"
			_tmp109_ = worm;
#line 540 "../src/nibbles-game.vala"
			worm_get_head (_tmp109_, &_tmp110_);
#line 540 "../src/nibbles-game.vala"
			_tmp111_ = _tmp110_;
#line 540 "../src/nibbles-game.vala"
			_tmp112_ = _tmp105_[(_tmp108_.x * _tmp105__length2) + _tmp111_.y];
#line 540 "../src/nibbles-game.vala"
			if (_tmp112_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
#line 3428 "nibbles-game.c"
				guint8 target_x = 0U;
				guint8 target_y = 0U;
				gboolean _tmp113_ = FALSE;
				Worm* _tmp114_;
				WormDirection _tmp115_;
				WormDirection _tmp116_;
				WarpManager* _tmp120_;
				Worm* _tmp121_;
				Position _tmp122_ = {0};
				Position _tmp123_;
				Worm* _tmp124_;
				Position _tmp125_ = {0};
				Position _tmp126_;
				guint8 _tmp127_ = 0U;
				guint8 _tmp128_ = 0U;
				gboolean _tmp129_;
				Worm* _tmp130_;
				gint* _tmp131_;
				gint _tmp131__length1;
				gint _tmp131__length2;
				Position _tmp132_ = {0};
#line 545 "../src/nibbles-game.vala"
				_tmp114_ = worm;
#line 545 "../src/nibbles-game.vala"
				_tmp115_ = worm_get_direction (_tmp114_);
#line 545 "../src/nibbles-game.vala"
				_tmp116_ = _tmp115_;
#line 545 "../src/nibbles-game.vala"
				if (_tmp116_ == WORM_DIRECTION_LEFT) {
#line 545 "../src/nibbles-game.vala"
					_tmp113_ = TRUE;
#line 3460 "nibbles-game.c"
				} else {
					Worm* _tmp117_;
					WormDirection _tmp118_;
					WormDirection _tmp119_;
#line 545 "../src/nibbles-game.vala"
					_tmp117_ = worm;
#line 545 "../src/nibbles-game.vala"
					_tmp118_ = worm_get_direction (_tmp117_);
#line 545 "../src/nibbles-game.vala"
					_tmp119_ = _tmp118_;
#line 545 "../src/nibbles-game.vala"
					_tmp113_ = _tmp119_ == WORM_DIRECTION_RIGHT;
#line 3473 "nibbles-game.c"
				}
#line 544 "../src/nibbles-game.vala"
				_tmp120_ = self->priv->warp_manager;
#line 544 "../src/nibbles-game.vala"
				_tmp121_ = worm;
#line 544 "../src/nibbles-game.vala"
				worm_get_head (_tmp121_, &_tmp122_);
#line 544 "../src/nibbles-game.vala"
				_tmp123_ = _tmp122_;
#line 544 "../src/nibbles-game.vala"
				_tmp124_ = worm;
#line 544 "../src/nibbles-game.vala"
				worm_get_head (_tmp124_, &_tmp125_);
#line 544 "../src/nibbles-game.vala"
				_tmp126_ = _tmp125_;
#line 544 "../src/nibbles-game.vala"
				_tmp129_ = warp_manager_get_warp_target (_tmp120_, _tmp123_.x, _tmp126_.y, _tmp113_, &_tmp127_, &_tmp128_);
#line 544 "../src/nibbles-game.vala"
				target_x = _tmp127_;
#line 544 "../src/nibbles-game.vala"
				target_y = _tmp128_;
#line 544 "../src/nibbles-game.vala"
				if (!_tmp129_) {
#line 547 "../src/nibbles-game.vala"
					g_assert_not_reached ();
#line 3499 "nibbles-game.c"
				}
#line 549 "../src/nibbles-game.vala"
				_tmp130_ = worm;
#line 549 "../src/nibbles-game.vala"
				_tmp131_ = self->board;
#line 549 "../src/nibbles-game.vala"
				_tmp131__length1 = self->board_length1;
#line 549 "../src/nibbles-game.vala"
				_tmp131__length2 = self->board_length2;
#line 549 "../src/nibbles-game.vala"
				memset (&_tmp132_, 0, sizeof (Position));
#line 549 "../src/nibbles-game.vala"
				_tmp132_.x = target_x;
#line 549 "../src/nibbles-game.vala"
				_tmp132_.y = target_y;
#line 549 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp130_, _tmp131_, (gint) _tmp131__length1, (gint) _tmp131__length2, &_tmp132_);
#line 3517 "nibbles-game.c"
			} else {
				Worm* _tmp133_;
				gint* _tmp134_;
				gint _tmp134__length1;
				gint _tmp134__length2;
#line 552 "../src/nibbles-game.vala"
				_tmp133_ = worm;
#line 552 "../src/nibbles-game.vala"
				_tmp134_ = self->board;
#line 552 "../src/nibbles-game.vala"
				_tmp134__length1 = self->board_length1;
#line 552 "../src/nibbles-game.vala"
				_tmp134__length2 = self->board_length2;
#line 552 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp133_, _tmp134_, (gint) _tmp134__length1, (gint) _tmp134__length2, NULL);
#line 3533 "nibbles-game.c"
			}
			{
				GeeLinkedList* _other_worm_list = NULL;
				GeeLinkedList* _tmp135_;
				gint _other_worm_size = 0;
				GeeLinkedList* _tmp136_;
				gint _tmp137_;
				gint _tmp138_;
				gint _other_worm_index = 0;
#line 555 "../src/nibbles-game.vala"
				_tmp135_ = self->priv->_worms;
#line 555 "../src/nibbles-game.vala"
				_other_worm_list = _tmp135_;
#line 555 "../src/nibbles-game.vala"
				_tmp136_ = _other_worm_list;
#line 555 "../src/nibbles-game.vala"
				_tmp137_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp136_);
#line 555 "../src/nibbles-game.vala"
				_tmp138_ = _tmp137_;
#line 555 "../src/nibbles-game.vala"
				_other_worm_size = _tmp138_;
#line 555 "../src/nibbles-game.vala"
				_other_worm_index = -1;
#line 555 "../src/nibbles-game.vala"
				while (TRUE) {
#line 3559 "nibbles-game.c"
					gint _tmp139_;
					gint _tmp140_;
					Worm* other_worm = NULL;
					GeeLinkedList* _tmp141_;
					gpointer _tmp142_;
					gboolean _tmp143_ = FALSE;
					gboolean _tmp144_ = FALSE;
					gboolean _tmp145_ = FALSE;
					gboolean _tmp146_ = FALSE;
					Worm* _tmp147_;
					Worm* _tmp148_;
#line 555 "../src/nibbles-game.vala"
					_other_worm_index = _other_worm_index + 1;
#line 555 "../src/nibbles-game.vala"
					_tmp139_ = _other_worm_index;
#line 555 "../src/nibbles-game.vala"
					_tmp140_ = _other_worm_size;
#line 555 "../src/nibbles-game.vala"
					if (!(_tmp139_ < _tmp140_)) {
#line 555 "../src/nibbles-game.vala"
						break;
#line 3581 "nibbles-game.c"
					}
#line 555 "../src/nibbles-game.vala"
					_tmp141_ = _other_worm_list;
#line 555 "../src/nibbles-game.vala"
					_tmp142_ = gee_abstract_list_get ((GeeAbstractList*) _tmp141_, _other_worm_index);
#line 555 "../src/nibbles-game.vala"
					other_worm = (Worm*) _tmp142_;
#line 557 "../src/nibbles-game.vala"
					_tmp147_ = worm;
#line 557 "../src/nibbles-game.vala"
					_tmp148_ = other_worm;
#line 557 "../src/nibbles-game.vala"
					if (_tmp147_ != _tmp148_) {
#line 3595 "nibbles-game.c"
						Worm* _tmp149_;
#line 558 "../src/nibbles-game.vala"
						_tmp149_ = other_worm;
#line 558 "../src/nibbles-game.vala"
						_tmp146_ = !_tmp149_->is_stopped;
#line 3601 "nibbles-game.c"
					} else {
#line 557 "../src/nibbles-game.vala"
						_tmp146_ = FALSE;
#line 3605 "nibbles-game.c"
					}
#line 557 "../src/nibbles-game.vala"
					if (_tmp146_) {
#line 3609 "nibbles-game.c"
						Worm* _tmp150_;
						WormPositions* _tmp151_;
						gboolean _tmp152_;
						gboolean _tmp153_;
#line 559 "../src/nibbles-game.vala"
						_tmp150_ = other_worm;
#line 559 "../src/nibbles-game.vala"
						_tmp151_ = _tmp150_->list;
#line 559 "../src/nibbles-game.vala"
						_tmp152_ = gee_collection_get_is_empty ((GeeCollection*) _tmp151_);
#line 559 "../src/nibbles-game.vala"
						_tmp153_ = _tmp152_;
#line 559 "../src/nibbles-game.vala"
						_tmp145_ = !_tmp153_;
#line 3624 "nibbles-game.c"
					} else {
#line 557 "../src/nibbles-game.vala"
						_tmp145_ = FALSE;
#line 3628 "nibbles-game.c"
					}
#line 557 "../src/nibbles-game.vala"
					if (_tmp145_) {
#line 3632 "nibbles-game.c"
						Worm* _tmp154_;
						Position _tmp155_ = {0};
						Position _tmp156_;
						Worm* _tmp157_;
						Position _tmp158_ = {0};
						Position _tmp159_;
#line 560 "../src/nibbles-game.vala"
						_tmp154_ = worm;
#line 560 "../src/nibbles-game.vala"
						worm_get_head (_tmp154_, &_tmp155_);
#line 560 "../src/nibbles-game.vala"
						_tmp156_ = _tmp155_;
#line 560 "../src/nibbles-game.vala"
						_tmp157_ = other_worm;
#line 560 "../src/nibbles-game.vala"
						worm_get_head (_tmp157_, &_tmp158_);
#line 560 "../src/nibbles-game.vala"
						_tmp159_ = _tmp158_;
#line 560 "../src/nibbles-game.vala"
						_tmp144_ = _tmp156_.x == _tmp159_.x;
#line 3653 "nibbles-game.c"
					} else {
#line 557 "../src/nibbles-game.vala"
						_tmp144_ = FALSE;
#line 3657 "nibbles-game.c"
					}
#line 557 "../src/nibbles-game.vala"
					if (_tmp144_) {
#line 3661 "nibbles-game.c"
						Worm* _tmp160_;
						Position _tmp161_ = {0};
						Position _tmp162_;
						Worm* _tmp163_;
						Position _tmp164_ = {0};
						Position _tmp165_;
#line 561 "../src/nibbles-game.vala"
						_tmp160_ = worm;
#line 561 "../src/nibbles-game.vala"
						worm_get_head (_tmp160_, &_tmp161_);
#line 561 "../src/nibbles-game.vala"
						_tmp162_ = _tmp161_;
#line 561 "../src/nibbles-game.vala"
						_tmp163_ = other_worm;
#line 561 "../src/nibbles-game.vala"
						worm_get_head (_tmp163_, &_tmp164_);
#line 561 "../src/nibbles-game.vala"
						_tmp165_ = _tmp164_;
#line 561 "../src/nibbles-game.vala"
						_tmp143_ = _tmp162_.y == _tmp165_.y;
#line 3682 "nibbles-game.c"
					} else {
#line 557 "../src/nibbles-game.vala"
						_tmp143_ = FALSE;
#line 3686 "nibbles-game.c"
					}
#line 557 "../src/nibbles-game.vala"
					if (_tmp143_) {
#line 3690 "nibbles-game.c"
						GeeLinkedList* _tmp166_;
						Worm* _tmp167_;
						GeeLinkedList* _tmp170_;
						Worm* _tmp171_;
#line 563 "../src/nibbles-game.vala"
						_tmp166_ = dead_worms;
#line 563 "../src/nibbles-game.vala"
						_tmp167_ = worm;
#line 563 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp166_, _tmp167_)) {
#line 3701 "nibbles-game.c"
							GeeLinkedList* _tmp168_;
							Worm* _tmp169_;
#line 564 "../src/nibbles-game.vala"
							_tmp168_ = dead_worms;
#line 564 "../src/nibbles-game.vala"
							_tmp169_ = worm;
#line 564 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp168_, _tmp169_);
#line 3710 "nibbles-game.c"
						}
#line 565 "../src/nibbles-game.vala"
						_tmp170_ = dead_worms;
#line 565 "../src/nibbles-game.vala"
						_tmp171_ = other_worm;
#line 565 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp170_, _tmp171_)) {
#line 3718 "nibbles-game.c"
							GeeLinkedList* _tmp172_;
							Worm* _tmp173_;
#line 566 "../src/nibbles-game.vala"
							_tmp172_ = dead_worms;
#line 566 "../src/nibbles-game.vala"
							_tmp173_ = other_worm;
#line 566 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp172_, _tmp173_);
#line 3727 "nibbles-game.c"
						}
					}
#line 555 "../src/nibbles-game.vala"
					_g_object_unref0 (other_worm);
#line 3732 "nibbles-game.c"
				}
			}
#line 532 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3737 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp174_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp175_;
		gint _tmp176_;
		gint _tmp177_;
		gint _worm_index = 0;
#line 572 "../src/nibbles-game.vala"
		_tmp174_ = dead_worms;
#line 572 "../src/nibbles-game.vala"
		_worm_list = _tmp174_;
#line 572 "../src/nibbles-game.vala"
		_tmp175_ = _worm_list;
#line 572 "../src/nibbles-game.vala"
		_tmp176_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp175_);
#line 572 "../src/nibbles-game.vala"
		_tmp177_ = _tmp176_;
#line 572 "../src/nibbles-game.vala"
		_worm_size = _tmp177_;
#line 572 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 572 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3764 "nibbles-game.c"
			gint _tmp178_;
			gint _tmp179_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp180_;
			gpointer _tmp181_;
			gint _tmp182_;
			Worm* _tmp187_;
			guint8 _tmp188_;
			guint8 _tmp189_;
#line 572 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 572 "../src/nibbles-game.vala"
			_tmp178_ = _worm_index;
#line 572 "../src/nibbles-game.vala"
			_tmp179_ = _worm_size;
#line 572 "../src/nibbles-game.vala"
			if (!(_tmp178_ < _tmp179_)) {
#line 572 "../src/nibbles-game.vala"
				break;
#line 3784 "nibbles-game.c"
			}
#line 572 "../src/nibbles-game.vala"
			_tmp180_ = _worm_list;
#line 572 "../src/nibbles-game.vala"
			_tmp181_ = gee_abstract_list_get ((GeeAbstractList*) _tmp180_, _worm_index);
#line 572 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp181_;
#line 574 "../src/nibbles-game.vala"
			_tmp182_ = self->priv->_numworms;
#line 574 "../src/nibbles-game.vala"
			if (_tmp182_ > 1) {
#line 3796 "nibbles-game.c"
				Worm* _tmp183_;
				Worm* _tmp184_;
				gint _tmp185_;
				gint _tmp186_;
#line 575 "../src/nibbles-game.vala"
				_tmp183_ = worm;
#line 575 "../src/nibbles-game.vala"
				_tmp184_ = worm;
#line 575 "../src/nibbles-game.vala"
				_tmp185_ = worm_get_score (_tmp184_);
#line 575 "../src/nibbles-game.vala"
				_tmp186_ = _tmp185_;
#line 575 "../src/nibbles-game.vala"
				worm_set_score (_tmp183_, (_tmp186_ * 7) / 10);
#line 3811 "nibbles-game.c"
			}
#line 577 "../src/nibbles-game.vala"
			_tmp187_ = worm;
#line 577 "../src/nibbles-game.vala"
			_tmp188_ = worm_get_lives (_tmp187_);
#line 577 "../src/nibbles-game.vala"
			_tmp189_ = _tmp188_;
#line 577 "../src/nibbles-game.vala"
			if (((gint) _tmp189_) > 0) {
#line 3821 "nibbles-game.c"
				Worm* _tmp190_;
				gint* _tmp191_;
				gint _tmp191__length1;
				gint _tmp191__length2;
#line 578 "../src/nibbles-game.vala"
				_tmp190_ = worm;
#line 578 "../src/nibbles-game.vala"
				_tmp191_ = self->board;
#line 578 "../src/nibbles-game.vala"
				_tmp191__length1 = self->board_length1;
#line 578 "../src/nibbles-game.vala"
				_tmp191__length2 = self->board_length2;
#line 578 "../src/nibbles-game.vala"
				worm_reset (_tmp190_, _tmp191_, (gint) _tmp191__length1, (gint) _tmp191__length2);
#line 3836 "nibbles-game.c"
			}
#line 572 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3840 "nibbles-game.c"
		}
	}
#line 582 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_REDRAW_SIGNAL], 0, TRUE);
#line 472 "../src/nibbles-game.vala"
	_g_object_unref0 (dead_worms);
#line 3847 "nibbles-game.c"
}

static void
nibbles_game_reverse_worms (NibblesGame* self,
                            Worm* worm)
{
#line 585 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 585 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 3858 "nibbles-game.c"
	{
		GeeLinkedList* _other_worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _other_worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _other_worm_index = 0;
#line 587 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 587 "../src/nibbles-game.vala"
		_other_worm_list = _tmp0_;
#line 587 "../src/nibbles-game.vala"
		_tmp1_ = _other_worm_list;
#line 587 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 587 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 587 "../src/nibbles-game.vala"
		_other_worm_size = _tmp3_;
#line 587 "../src/nibbles-game.vala"
		_other_worm_index = -1;
#line 587 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3883 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* other_worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
#line 587 "../src/nibbles-game.vala"
			_other_worm_index = _other_worm_index + 1;
#line 587 "../src/nibbles-game.vala"
			_tmp4_ = _other_worm_index;
#line 587 "../src/nibbles-game.vala"
			_tmp5_ = _other_worm_size;
#line 587 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 587 "../src/nibbles-game.vala"
				break;
#line 3900 "nibbles-game.c"
			}
#line 587 "../src/nibbles-game.vala"
			_tmp6_ = _other_worm_list;
#line 587 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _other_worm_index);
#line 587 "../src/nibbles-game.vala"
			other_worm = (Worm*) _tmp7_;
#line 588 "../src/nibbles-game.vala"
			_tmp8_ = other_worm;
#line 588 "../src/nibbles-game.vala"
			if (worm != _tmp8_) {
#line 3912 "nibbles-game.c"
				Worm* _tmp9_;
#line 589 "../src/nibbles-game.vala"
				_tmp9_ = other_worm;
#line 589 "../src/nibbles-game.vala"
				worm_reverse (_tmp9_);
#line 3918 "nibbles-game.c"
			}
#line 587 "../src/nibbles-game.vala"
			_g_object_unref0 (other_worm);
#line 3922 "nibbles-game.c"
		}
	}
}

static gboolean
nibbles_game_is_space_empty (NibblesGame* self,
                             guint8 x,
                             guint8 y,
                             gboolean* worms_at,
                             gint worms_at_length1,
                             gint worms_at_length2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	gint _tmp12_;
	gboolean result;
#line 596 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../src/nibbles-game.vala"
	_tmp11_ = self->board;
#line 598 "../src/nibbles-game.vala"
	_tmp11__length1 = self->board_length1;
#line 598 "../src/nibbles-game.vala"
	_tmp11__length2 = self->board_length2;
#line 598 "../src/nibbles-game.vala"
	_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 598 "../src/nibbles-game.vala"
	if (((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp12_) {
#line 3963 "nibbles-game.c"
		gint* _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		gint _tmp14_;
#line 598 "../src/nibbles-game.vala"
		_tmp13_ = self->board;
#line 598 "../src/nibbles-game.vala"
		_tmp13__length1 = self->board_length1;
#line 598 "../src/nibbles-game.vala"
		_tmp13__length2 = self->board_length2;
#line 598 "../src/nibbles-game.vala"
		_tmp14_ = _tmp13_[((x + 1) * _tmp13__length2) + (y + 1)];
#line 598 "../src/nibbles-game.vala"
		_tmp10_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp14_;
#line 3978 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp10_ = FALSE;
#line 3982 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp10_) {
#line 3986 "nibbles-game.c"
		gint* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		gint _tmp16_;
#line 599 "../src/nibbles-game.vala"
		_tmp15_ = self->board;
#line 599 "../src/nibbles-game.vala"
		_tmp15__length1 = self->board_length1;
#line 599 "../src/nibbles-game.vala"
		_tmp15__length2 = self->board_length2;
#line 599 "../src/nibbles-game.vala"
		_tmp16_ = _tmp15_[((x + 1) * _tmp15__length2) + y];
#line 599 "../src/nibbles-game.vala"
		_tmp9_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp16_;
#line 4001 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp9_ = FALSE;
#line 4005 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp9_) {
#line 4009 "nibbles-game.c"
		gint* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint _tmp18_;
#line 599 "../src/nibbles-game.vala"
		_tmp17_ = self->board;
#line 599 "../src/nibbles-game.vala"
		_tmp17__length1 = self->board_length1;
#line 599 "../src/nibbles-game.vala"
		_tmp17__length2 = self->board_length2;
#line 599 "../src/nibbles-game.vala"
		_tmp18_ = _tmp17_[(x * _tmp17__length2) + (y + 1)];
#line 599 "../src/nibbles-game.vala"
		_tmp8_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp18_;
#line 4024 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp8_ = FALSE;
#line 4028 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp8_) {
#line 4032 "nibbles-game.c"
		Boni* _tmp19_;
		Bonus* _tmp20_;
		Bonus* _tmp21_;
#line 600 "../src/nibbles-game.vala"
		_tmp19_ = self->priv->boni;
#line 600 "../src/nibbles-game.vala"
		_tmp20_ = boni_get_bonus (_tmp19_, x, y);
#line 600 "../src/nibbles-game.vala"
		_tmp21_ = _tmp20_;
#line 600 "../src/nibbles-game.vala"
		_tmp7_ = _tmp21_ == NULL;
#line 600 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp21_);
#line 4046 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp7_ = FALSE;
#line 4050 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp7_) {
#line 4054 "nibbles-game.c"
		Boni* _tmp22_;
		Bonus* _tmp23_;
		Bonus* _tmp24_;
#line 600 "../src/nibbles-game.vala"
		_tmp22_ = self->priv->boni;
#line 600 "../src/nibbles-game.vala"
		_tmp23_ = boni_get_bonus (_tmp22_, (guint8) (x + 1), (guint8) (y + 1));
#line 600 "../src/nibbles-game.vala"
		_tmp24_ = _tmp23_;
#line 600 "../src/nibbles-game.vala"
		_tmp6_ = _tmp24_ == NULL;
#line 600 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp24_);
#line 4068 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp6_ = FALSE;
#line 4072 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp6_) {
#line 4076 "nibbles-game.c"
		Boni* _tmp25_;
		Bonus* _tmp26_;
		Bonus* _tmp27_;
#line 601 "../src/nibbles-game.vala"
		_tmp25_ = self->priv->boni;
#line 601 "../src/nibbles-game.vala"
		_tmp26_ = boni_get_bonus (_tmp25_, (guint8) (x + 1), y);
#line 601 "../src/nibbles-game.vala"
		_tmp27_ = _tmp26_;
#line 601 "../src/nibbles-game.vala"
		_tmp5_ = _tmp27_ == NULL;
#line 601 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp27_);
#line 4090 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp5_ = FALSE;
#line 4094 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp5_) {
#line 4098 "nibbles-game.c"
		Boni* _tmp28_;
		Bonus* _tmp29_;
		Bonus* _tmp30_;
#line 601 "../src/nibbles-game.vala"
		_tmp28_ = self->priv->boni;
#line 601 "../src/nibbles-game.vala"
		_tmp29_ = boni_get_bonus (_tmp28_, x, (guint8) (y + 1));
#line 601 "../src/nibbles-game.vala"
		_tmp30_ = _tmp29_;
#line 601 "../src/nibbles-game.vala"
		_tmp4_ = _tmp30_ == NULL;
#line 601 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp30_);
#line 4112 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp4_ = FALSE;
#line 4116 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp4_) {
#line 4120 "nibbles-game.c"
		gboolean _tmp31_;
#line 602 "../src/nibbles-game.vala"
		_tmp31_ = worms_at[(x * worms_at_length2) + y];
#line 602 "../src/nibbles-game.vala"
		_tmp3_ = !_tmp31_;
#line 4126 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp3_ = FALSE;
#line 4130 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp3_) {
#line 4134 "nibbles-game.c"
		gboolean _tmp32_;
#line 602 "../src/nibbles-game.vala"
		_tmp32_ = worms_at[((x + 1) * worms_at_length2) + (y + 1)];
#line 602 "../src/nibbles-game.vala"
		_tmp2_ = !_tmp32_;
#line 4140 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp2_ = FALSE;
#line 4144 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp2_) {
#line 4148 "nibbles-game.c"
		gboolean _tmp33_;
#line 603 "../src/nibbles-game.vala"
		_tmp33_ = worms_at[((x + 1) * worms_at_length2) + y];
#line 603 "../src/nibbles-game.vala"
		_tmp1_ = !_tmp33_;
#line 4154 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp1_ = FALSE;
#line 4158 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	if (_tmp1_) {
#line 4162 "nibbles-game.c"
		gboolean _tmp34_;
#line 603 "../src/nibbles-game.vala"
		_tmp34_ = worms_at[(x * worms_at_length2) + (y + 1)];
#line 603 "../src/nibbles-game.vala"
		_tmp0_ = !_tmp34_;
#line 4168 "nibbles-game.c"
	} else {
#line 598 "../src/nibbles-game.vala"
		_tmp0_ = FALSE;
#line 4172 "nibbles-game.c"
	}
#line 598 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 598 "../src/nibbles-game.vala"
	return result;
#line 4178 "nibbles-game.c"
}

static void
nibbles_game_add_bonus (NibblesGame* self,
                        gboolean regular)
{
	gboolean good = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
	gboolean* worms_at = NULL;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gboolean* _tmp2_;
	gint worms_at_length1;
	gint worms_at_length2;
#line 606 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 608 "../src/nibbles-game.vala"
	good = FALSE;
#line 609 "../src/nibbles-game.vala"
	x = (guint8) 0;
#line 610 "../src/nibbles-game.vala"
	y = (guint8) 0;
#line 611 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_width;
#line 611 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_height;
#line 611 "../src/nibbles-game.vala"
	_tmp2_ = g_new0 (gboolean, _tmp0_ * _tmp1_);
#line 611 "../src/nibbles-game.vala"
	worms_at = _tmp2_;
#line 611 "../src/nibbles-game.vala"
	worms_at_length1 = _tmp0_;
#line 611 "../src/nibbles-game.vala"
	worms_at_length2 = _tmp1_;
#line 613 "../src/nibbles-game.vala"
	if (!regular) {
#line 615 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 50) != ((gint32) 0)) {
#line 616 "../src/nibbles-game.vala"
			worms_at = (g_free (worms_at), NULL);
#line 616 "../src/nibbles-game.vala"
			return;
#line 4222 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp3_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _worm_index = 0;
#line 619 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_worms;
#line 619 "../src/nibbles-game.vala"
		_worm_list = _tmp3_;
#line 619 "../src/nibbles-game.vala"
		_tmp4_ = _worm_list;
#line 619 "../src/nibbles-game.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 619 "../src/nibbles-game.vala"
		_tmp6_ = _tmp5_;
#line 619 "../src/nibbles-game.vala"
		_worm_size = _tmp6_;
#line 619 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 619 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4249 "nibbles-game.c"
			gint _tmp7_;
			gint _tmp8_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp9_;
			gpointer _tmp10_;
			Worm* _tmp11_;
#line 619 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 619 "../src/nibbles-game.vala"
			_tmp7_ = _worm_index;
#line 619 "../src/nibbles-game.vala"
			_tmp8_ = _worm_size;
#line 619 "../src/nibbles-game.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 619 "../src/nibbles-game.vala"
				break;
#line 4266 "nibbles-game.c"
			}
#line 619 "../src/nibbles-game.vala"
			_tmp9_ = _worm_list;
#line 619 "../src/nibbles-game.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _worm_index);
#line 619 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp10_;
#line 620 "../src/nibbles-game.vala"
			_tmp11_ = worm;
#line 620 "../src/nibbles-game.vala"
			if (!_tmp11_->is_stopped) {
#line 4278 "nibbles-game.c"
				{
					WormPositions* _p_list = NULL;
					Worm* _tmp12_;
					WormPositions* _tmp13_;
					gint _p_size = 0;
					WormPositions* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					gint _p_index = 0;
#line 621 "../src/nibbles-game.vala"
					_tmp12_ = worm;
#line 621 "../src/nibbles-game.vala"
					_tmp13_ = _tmp12_->list;
#line 621 "../src/nibbles-game.vala"
					_p_list = _tmp13_;
#line 621 "../src/nibbles-game.vala"
					_tmp14_ = _p_list;
#line 621 "../src/nibbles-game.vala"
					_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 621 "../src/nibbles-game.vala"
					_tmp16_ = _tmp15_;
#line 621 "../src/nibbles-game.vala"
					_p_size = _tmp16_;
#line 621 "../src/nibbles-game.vala"
					_p_index = -1;
#line 621 "../src/nibbles-game.vala"
					while (TRUE) {
#line 4306 "nibbles-game.c"
						gint _tmp17_;
						gint _tmp18_;
						guint16 p = 0U;
						WormPositions* _tmp19_;
						gpointer _tmp20_;
						gboolean* _tmp21_;
						gint _tmp21__length1;
						gint _tmp21__length2;
#line 621 "../src/nibbles-game.vala"
						_p_index = _p_index + 1;
#line 621 "../src/nibbles-game.vala"
						_tmp17_ = _p_index;
#line 621 "../src/nibbles-game.vala"
						_tmp18_ = _p_size;
#line 621 "../src/nibbles-game.vala"
						if (!(_tmp17_ < _tmp18_)) {
#line 621 "../src/nibbles-game.vala"
							break;
#line 4325 "nibbles-game.c"
						}
#line 621 "../src/nibbles-game.vala"
						_tmp19_ = _p_list;
#line 621 "../src/nibbles-game.vala"
						_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _p_index);
#line 621 "../src/nibbles-game.vala"
						p = (guint16) ((guintptr) _tmp20_);
#line 622 "../src/nibbles-game.vala"
						_tmp21_ = worms_at;
#line 622 "../src/nibbles-game.vala"
						_tmp21__length1 = worms_at_length1;
#line 622 "../src/nibbles-game.vala"
						_tmp21__length2 = worms_at_length2;
#line 622 "../src/nibbles-game.vala"
						_tmp21_[((p >> 8) * _tmp21__length2) + ((guint8) p)] = TRUE;
#line 4341 "nibbles-game.c"
					}
				}
			}
#line 619 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4347 "nibbles-game.c"
		}
	}
	{
		gboolean _tmp22_ = FALSE;
#line 624 "../src/nibbles-game.vala"
		_tmp22_ = TRUE;
#line 624 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4356 "nibbles-game.c"
			guint8 _tmp24_;
			guint8 _tmp25_;
#line 624 "../src/nibbles-game.vala"
			if (!_tmp22_) {
#line 4361 "nibbles-game.c"
				gboolean* _tmp23_;
				gint _tmp23__length1;
				gint _tmp23__length2;
#line 628 "../src/nibbles-game.vala"
				_tmp23_ = worms_at;
#line 628 "../src/nibbles-game.vala"
				_tmp23__length1 = worms_at_length1;
#line 628 "../src/nibbles-game.vala"
				_tmp23__length2 = worms_at_length2;
#line 628 "../src/nibbles-game.vala"
				if (!(!nibbles_game_is_space_empty (self, x, y, _tmp23_, (gint) _tmp23__length1, (gint) _tmp23__length2))) {
#line 628 "../src/nibbles-game.vala"
					break;
#line 4375 "nibbles-game.c"
				}
			}
#line 624 "../src/nibbles-game.vala"
			_tmp22_ = FALSE;
#line 626 "../src/nibbles-game.vala"
			_tmp24_ = self->priv->_width;
#line 626 "../src/nibbles-game.vala"
			x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp24_ - 1));
#line 627 "../src/nibbles-game.vala"
			_tmp25_ = self->priv->_height;
#line 627 "../src/nibbles-game.vala"
			y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp25_ - 1));
#line 4388 "nibbles-game.c"
		}
	}
#line 630 "../src/nibbles-game.vala"
	if (regular) {
#line 4393 "nibbles-game.c"
		gboolean _tmp26_ = FALSE;
#line 632 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 7) == ((gint32) 0)) {
#line 4397 "nibbles-game.c"
			gboolean _tmp27_;
#line 632 "../src/nibbles-game.vala"
			_tmp27_ = self->priv->_fakes;
#line 632 "../src/nibbles-game.vala"
			_tmp26_ = _tmp27_;
#line 4403 "nibbles-game.c"
		} else {
#line 632 "../src/nibbles-game.vala"
			_tmp26_ = FALSE;
#line 4407 "nibbles-game.c"
		}
#line 632 "../src/nibbles-game.vala"
		if (_tmp26_) {
#line 633 "../src/nibbles-game.vala"
			_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, TRUE, (guint16) 300);
#line 4413 "nibbles-game.c"
		}
		{
			gboolean _tmp28_ = FALSE;
#line 635 "../src/nibbles-game.vala"
			_tmp28_ = TRUE;
#line 635 "../src/nibbles-game.vala"
			while (TRUE) {
#line 4421 "nibbles-game.c"
				guint8 _tmp30_;
				guint8 _tmp31_;
#line 635 "../src/nibbles-game.vala"
				if (!_tmp28_) {
#line 4426 "nibbles-game.c"
					gboolean* _tmp29_;
					gint _tmp29__length1;
					gint _tmp29__length2;
#line 639 "../src/nibbles-game.vala"
					_tmp29_ = worms_at;
#line 639 "../src/nibbles-game.vala"
					_tmp29__length1 = worms_at_length1;
#line 639 "../src/nibbles-game.vala"
					_tmp29__length2 = worms_at_length2;
#line 639 "../src/nibbles-game.vala"
					if (!(!nibbles_game_is_space_empty (self, x, y, _tmp29_, (gint) _tmp29__length1, (gint) _tmp29__length2))) {
#line 639 "../src/nibbles-game.vala"
						break;
#line 4440 "nibbles-game.c"
					}
				}
#line 635 "../src/nibbles-game.vala"
				_tmp28_ = FALSE;
#line 637 "../src/nibbles-game.vala"
				_tmp30_ = self->priv->_width;
#line 637 "../src/nibbles-game.vala"
				x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp30_ - 1));
#line 638 "../src/nibbles-game.vala"
				_tmp31_ = self->priv->_height;
#line 638 "../src/nibbles-game.vala"
				y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp31_ - 1));
#line 4453 "nibbles-game.c"
			}
		}
#line 640 "../src/nibbles-game.vala"
		_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, FALSE, (guint16) 300);
#line 4458 "nibbles-game.c"
	} else {
		Boni* _tmp32_;
#line 642 "../src/nibbles-game.vala"
		_tmp32_ = self->priv->boni;
#line 642 "../src/nibbles-game.vala"
		if (!boni_too_many_missed (_tmp32_)) {
#line 4465 "nibbles-game.c"
			gboolean _tmp33_ = FALSE;
#line 644 "../src/nibbles-game.vala"
			if (g_random_int_range ((gint32) 0, (gint32) 7) != ((gint32) 0)) {
#line 645 "../src/nibbles-game.vala"
				good = FALSE;
#line 4471 "nibbles-game.c"
			} else {
#line 647 "../src/nibbles-game.vala"
				good = TRUE;
#line 4475 "nibbles-game.c"
			}
#line 649 "../src/nibbles-game.vala"
			if (good) {
#line 4479 "nibbles-game.c"
				gboolean _tmp34_;
#line 649 "../src/nibbles-game.vala"
				_tmp34_ = self->priv->_fakes;
#line 649 "../src/nibbles-game.vala"
				_tmp33_ = !_tmp34_;
#line 4485 "nibbles-game.c"
			} else {
#line 649 "../src/nibbles-game.vala"
				_tmp33_ = FALSE;
#line 4489 "nibbles-game.c"
			}
#line 649 "../src/nibbles-game.vala"
			if (_tmp33_) {
#line 650 "../src/nibbles-game.vala"
				worms_at = (g_free (worms_at), NULL);
#line 650 "../src/nibbles-game.vala"
				return;
#line 4497 "nibbles-game.c"
			}
#line 652 "../src/nibbles-game.vala"
			switch (g_random_int_range ((gint32) 0, (gint32) 21)) {
#line 652 "../src/nibbles-game.vala"
				case 0:
#line 652 "../src/nibbles-game.vala"
				case 1:
#line 652 "../src/nibbles-game.vala"
				case 2:
#line 652 "../src/nibbles-game.vala"
				case 3:
#line 652 "../src/nibbles-game.vala"
				case 4:
#line 652 "../src/nibbles-game.vala"
				case 5:
#line 652 "../src/nibbles-game.vala"
				case 6:
#line 652 "../src/nibbles-game.vala"
				case 7:
#line 652 "../src/nibbles-game.vala"
				case 8:
#line 652 "../src/nibbles-game.vala"
				case 9:
#line 4521 "nibbles-game.c"
				{
#line 664 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_HALF, good, (guint16) 200);
#line 665 "../src/nibbles-game.vala"
					break;
#line 4527 "nibbles-game.c"
				}
#line 652 "../src/nibbles-game.vala"
				case 10:
#line 652 "../src/nibbles-game.vala"
				case 11:
#line 652 "../src/nibbles-game.vala"
				case 12:
#line 652 "../src/nibbles-game.vala"
				case 13:
#line 652 "../src/nibbles-game.vala"
				case 14:
#line 4539 "nibbles-game.c"
				{
#line 671 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_DOUBLE, good, (guint16) 150);
#line 672 "../src/nibbles-game.vala"
					break;
#line 4545 "nibbles-game.c"
				}
#line 652 "../src/nibbles-game.vala"
				case 15:
#line 4549 "nibbles-game.c"
				{
#line 674 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_LIFE, good, (guint16) 100);
#line 675 "../src/nibbles-game.vala"
					break;
#line 4555 "nibbles-game.c"
				}
#line 652 "../src/nibbles-game.vala"
				case 16:
#line 652 "../src/nibbles-game.vala"
				case 17:
#line 652 "../src/nibbles-game.vala"
				case 18:
#line 652 "../src/nibbles-game.vala"
				case 19:
#line 652 "../src/nibbles-game.vala"
				case 20:
#line 4567 "nibbles-game.c"
				{
					gint _tmp35_;
#line 681 "../src/nibbles-game.vala"
					_tmp35_ = self->priv->_numworms;
#line 681 "../src/nibbles-game.vala"
					if (_tmp35_ > 1) {
#line 682 "../src/nibbles-game.vala"
						_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REVERSE, good, (guint16) 150);
#line 4576 "nibbles-game.c"
					}
#line 683 "../src/nibbles-game.vala"
					break;
#line 4580 "nibbles-game.c"
				}
				default:
#line 652 "../src/nibbles-game.vala"
				break;
#line 4585 "nibbles-game.c"
			}
		}
	}
#line 606 "../src/nibbles-game.vala"
	worms_at = (g_free (worms_at), NULL);
#line 4591 "nibbles-game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 690 "../src/nibbles-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 4599 "nibbles-game.c"
}

static inline void
_nibbles_game_add_bonus (NibblesGame* self,
                         guint8 x,
                         guint8 y,
                         BonusType bonus_type,
                         gboolean fake,
                         guint16 countdown)
{
	Bonus* bonus = NULL;
	Bonus* _tmp0_;
	Boni* _tmp1_;
	Bonus* _tmp2_;
	Bonus* _tmp3_;
#line 687 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 689 "../src/nibbles-game.vala"
	_tmp0_ = bonus_new (x, y, bonus_type, fake, countdown);
#line 689 "../src/nibbles-game.vala"
	bonus = _tmp0_;
#line 690 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->boni;
#line 690 "../src/nibbles-game.vala"
	_tmp2_ = bonus;
#line 690 "../src/nibbles-game.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 690 "../src/nibbles-game.vala"
	if (boni_add_bonus (_tmp1_, _tmp3_)) {
#line 4629 "nibbles-game.c"
		Bonus* _tmp4_;
		BonusType _tmp5_;
		BonusType _tmp6_;
#line 691 "../src/nibbles-game.vala"
		_tmp4_ = bonus;
#line 691 "../src/nibbles-game.vala"
		_tmp5_ = bonus_get_bonus_type (_tmp4_);
#line 691 "../src/nibbles-game.vala"
		_tmp6_ = _tmp5_;
#line 691 "../src/nibbles-game.vala"
		if (_tmp6_ != BONUS_TYPE_REGULAR) {
#line 692 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "appear");
#line 4643 "nibbles-game.c"
		}
	}
#line 687 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 4648 "nibbles-game.c"
}

static void
nibbles_game_apply_bonus (NibblesGame* self,
                          Bonus* bonus,
                          Worm* worm)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	BonusType _tmp2_;
	BonusType _tmp3_;
#line 695 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 695 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 695 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 697 "../src/nibbles-game.vala"
	_tmp0_ = bonus_get_fake (bonus);
#line 697 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 697 "../src/nibbles-game.vala"
	if (_tmp1_) {
#line 699 "../src/nibbles-game.vala"
		worm_reverse (worm);
#line 701 "../src/nibbles-game.vala"
		return;
#line 4676 "nibbles-game.c"
	}
#line 704 "../src/nibbles-game.vala"
	_tmp2_ = bonus_get_bonus_type (bonus);
#line 704 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 704 "../src/nibbles-game.vala"
	switch (_tmp3_) {
#line 704 "../src/nibbles-game.vala"
		case BONUS_TYPE_REGULAR:
#line 4686 "nibbles-game.c"
		{
			guint8 nth_bonus = 0U;
			Boni* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 707 "../src/nibbles-game.vala"
			_tmp4_ = self->priv->boni;
#line 707 "../src/nibbles-game.vala"
			nth_bonus = boni_new_regular_bonus_eaten (_tmp4_);
#line 708 "../src/nibbles-game.vala"
			_tmp5_ = worm_get_change (worm);
#line 708 "../src/nibbles-game.vala"
			_tmp6_ = _tmp5_;
#line 708 "../src/nibbles-game.vala"
			worm_set_change (worm, _tmp6_ + (((gint) nth_bonus) * WORM_GROW_FACTOR));
#line 709 "../src/nibbles-game.vala"
			_tmp7_ = worm_get_score (worm);
#line 709 "../src/nibbles-game.vala"
			_tmp8_ = _tmp7_;
#line 709 "../src/nibbles-game.vala"
			_tmp9_ = self->priv->_current_level;
#line 709 "../src/nibbles-game.vala"
			worm_set_score (worm, _tmp8_ + (((gint) nth_bonus) * _tmp9_));
#line 710 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "gobble");
#line 711 "../src/nibbles-game.vala"
			break;
#line 4717 "nibbles-game.c"
		}
#line 704 "../src/nibbles-game.vala"
		case BONUS_TYPE_DOUBLE:
#line 4721 "nibbles-game.c"
		{
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
#line 713 "../src/nibbles-game.vala"
			_tmp10_ = worm_get_score (worm);
#line 713 "../src/nibbles-game.vala"
			_tmp11_ = _tmp10_;
#line 713 "../src/nibbles-game.vala"
			_tmp12_ = worm_get_length (worm);
#line 713 "../src/nibbles-game.vala"
			_tmp13_ = _tmp12_;
#line 713 "../src/nibbles-game.vala"
			_tmp14_ = worm_get_change (worm);
#line 713 "../src/nibbles-game.vala"
			_tmp15_ = _tmp14_;
#line 713 "../src/nibbles-game.vala"
			_tmp16_ = self->priv->_current_level;
#line 713 "../src/nibbles-game.vala"
			worm_set_score (worm, _tmp11_ + ((_tmp13_ + _tmp15_) * _tmp16_));
#line 714 "../src/nibbles-game.vala"
			_tmp17_ = worm_get_change (worm);
#line 714 "../src/nibbles-game.vala"
			_tmp18_ = _tmp17_;
#line 714 "../src/nibbles-game.vala"
			_tmp19_ = worm_get_length (worm);
#line 714 "../src/nibbles-game.vala"
			_tmp20_ = _tmp19_;
#line 714 "../src/nibbles-game.vala"
			_tmp21_ = worm_get_change (worm);
#line 714 "../src/nibbles-game.vala"
			_tmp22_ = _tmp21_;
#line 714 "../src/nibbles-game.vala"
			worm_set_change (worm, _tmp18_ + (_tmp20_ + _tmp22_));
#line 715 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "bonus");
#line 716 "../src/nibbles-game.vala"
			break;
#line 4770 "nibbles-game.c"
		}
#line 704 "../src/nibbles-game.vala"
		case BONUS_TYPE_HALF:
#line 4774 "nibbles-game.c"
		{
			gint _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
#line 718 "../src/nibbles-game.vala"
			_tmp23_ = worm_get_length (worm);
#line 718 "../src/nibbles-game.vala"
			_tmp24_ = _tmp23_;
#line 718 "../src/nibbles-game.vala"
			_tmp25_ = worm_get_change (worm);
#line 718 "../src/nibbles-game.vala"
			_tmp26_ = _tmp25_;
#line 718 "../src/nibbles-game.vala"
			if ((_tmp24_ + _tmp26_) > 2) {
#line 4790 "nibbles-game.c"
				gint _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
#line 720 "../src/nibbles-game.vala"
				_tmp27_ = worm_get_score (worm);
#line 720 "../src/nibbles-game.vala"
				_tmp28_ = _tmp27_;
#line 720 "../src/nibbles-game.vala"
				_tmp29_ = worm_get_length (worm);
#line 720 "../src/nibbles-game.vala"
				_tmp30_ = _tmp29_;
#line 720 "../src/nibbles-game.vala"
				_tmp31_ = worm_get_change (worm);
#line 720 "../src/nibbles-game.vala"
				_tmp32_ = _tmp31_;
#line 720 "../src/nibbles-game.vala"
				_tmp33_ = self->priv->_current_level;
#line 720 "../src/nibbles-game.vala"
				worm_set_score (worm, _tmp28_ + ((_tmp30_ + (_tmp32_ / 2)) * _tmp33_));
#line 721 "../src/nibbles-game.vala"
				_tmp34_ = worm_get_length (worm);
#line 721 "../src/nibbles-game.vala"
				_tmp35_ = _tmp34_;
#line 721 "../src/nibbles-game.vala"
				worm_reduce_tail (worm, _tmp35_ / 2);
#line 722 "../src/nibbles-game.vala"
				_tmp36_ = worm_get_change (worm);
#line 722 "../src/nibbles-game.vala"
				_tmp37_ = _tmp36_;
#line 722 "../src/nibbles-game.vala"
				_tmp38_ = worm_get_length (worm);
#line 722 "../src/nibbles-game.vala"
				_tmp39_ = _tmp38_;
#line 722 "../src/nibbles-game.vala"
				_tmp40_ = worm_get_change (worm);
#line 722 "../src/nibbles-game.vala"
				_tmp41_ = _tmp40_;
#line 722 "../src/nibbles-game.vala"
				worm_set_change (worm, _tmp37_ - ((_tmp39_ + _tmp41_) / 2));
#line 4842 "nibbles-game.c"
			}
#line 724 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "bonus");
#line 725 "../src/nibbles-game.vala"
			break;
#line 4848 "nibbles-game.c"
		}
#line 704 "../src/nibbles-game.vala"
		case BONUS_TYPE_LIFE:
#line 4852 "nibbles-game.c"
		{
#line 727 "../src/nibbles-game.vala"
			worm_add_life (worm);
#line 728 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "life");
#line 729 "../src/nibbles-game.vala"
			break;
#line 4860 "nibbles-game.c"
		}
#line 704 "../src/nibbles-game.vala"
		case BONUS_TYPE_REVERSE:
#line 4864 "nibbles-game.c"
		{
#line 731 "../src/nibbles-game.vala"
			nibbles_game_reverse_worms (self, worm);
#line 732 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "reverse");
#line 733 "../src/nibbles-game.vala"
			break;
#line 4872 "nibbles-game.c"
		}
#line 704 "../src/nibbles-game.vala"
		case BONUS_TYPE_WARP:
#line 4876 "nibbles-game.c"
		{
#line 735 "../src/nibbles-game.vala"
			break;
#line 4880 "nibbles-game.c"
		}
		default:
#line 704 "../src/nibbles-game.vala"
		break;
#line 4885 "nibbles-game.c"
	}
}

static void
nibbles_game_bonus_found_cb (NibblesGame* self,
                             Worm* worm)
{
	Bonus* bonus = NULL;
	Boni* _tmp0_;
	Position _tmp1_ = {0};
	Position _tmp2_;
	Position _tmp3_ = {0};
	Position _tmp4_;
	Bonus* _tmp5_;
	Bonus* _tmp6_;
	Position _tmp7_ = {0};
	Position _tmp8_;
	Position _tmp9_ = {0};
	Position _tmp10_;
	Bonus* _tmp11_;
	Bonus* _tmp12_;
	gboolean _tmp13_ = FALSE;
	Bonus* _tmp14_;
	BonusType _tmp15_;
	BonusType _tmp16_;
	gboolean real_bonus = FALSE;
	Boni* _tmp20_;
	Bonus* _tmp21_;
	gboolean _tmp22_ = FALSE;
#line 739 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 739 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 741 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->boni;
#line 741 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp1_);
#line 741 "../src/nibbles-game.vala"
	_tmp2_ = _tmp1_;
#line 741 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp3_);
#line 741 "../src/nibbles-game.vala"
	_tmp4_ = _tmp3_;
#line 741 "../src/nibbles-game.vala"
	_tmp5_ = boni_get_bonus (_tmp0_, _tmp2_.x, _tmp4_.y);
#line 741 "../src/nibbles-game.vala"
	bonus = _tmp5_;
#line 742 "../src/nibbles-game.vala"
	_tmp6_ = bonus;
#line 742 "../src/nibbles-game.vala"
	if (_tmp6_ == NULL) {
#line 743 "../src/nibbles-game.vala"
		_g_object_unref0 (bonus);
#line 743 "../src/nibbles-game.vala"
		return;
#line 4941 "nibbles-game.c"
	}
#line 744 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp7_);
#line 744 "../src/nibbles-game.vala"
	_tmp8_ = _tmp7_;
#line 744 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp9_);
#line 744 "../src/nibbles-game.vala"
	_tmp10_ = _tmp9_;
#line 744 "../src/nibbles-game.vala"
	worm_add_bonus_eaten_position (worm, _tmp8_.x, _tmp10_.y);
#line 745 "../src/nibbles-game.vala"
	_tmp11_ = bonus;
#line 745 "../src/nibbles-game.vala"
	nibbles_game_apply_bonus (self, _tmp11_, worm);
#line 746 "../src/nibbles-game.vala"
	_tmp12_ = bonus;
#line 746 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL], 0, _tmp12_, worm);
#line 748 "../src/nibbles-game.vala"
	_tmp14_ = bonus;
#line 748 "../src/nibbles-game.vala"
	_tmp15_ = bonus_get_bonus_type (_tmp14_);
#line 748 "../src/nibbles-game.vala"
	_tmp16_ = _tmp15_;
#line 748 "../src/nibbles-game.vala"
	if (_tmp16_ == BONUS_TYPE_REGULAR) {
#line 4969 "nibbles-game.c"
		Bonus* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
#line 748 "../src/nibbles-game.vala"
		_tmp17_ = bonus;
#line 748 "../src/nibbles-game.vala"
		_tmp18_ = bonus_get_fake (_tmp17_);
#line 748 "../src/nibbles-game.vala"
		_tmp19_ = _tmp18_;
#line 748 "../src/nibbles-game.vala"
		_tmp13_ = !_tmp19_;
#line 4981 "nibbles-game.c"
	} else {
#line 748 "../src/nibbles-game.vala"
		_tmp13_ = FALSE;
#line 4985 "nibbles-game.c"
	}
#line 748 "../src/nibbles-game.vala"
	real_bonus = _tmp13_;
#line 750 "../src/nibbles-game.vala"
	_tmp20_ = self->priv->boni;
#line 750 "../src/nibbles-game.vala"
	_tmp21_ = bonus;
#line 750 "../src/nibbles-game.vala"
	boni_remove_bonus (_tmp20_, _tmp21_);
#line 752 "../src/nibbles-game.vala"
	if (real_bonus) {
#line 4997 "nibbles-game.c"
		Boni* _tmp23_;
#line 752 "../src/nibbles-game.vala"
		_tmp23_ = self->priv->boni;
#line 752 "../src/nibbles-game.vala"
		_tmp22_ = !boni_last_regular_bonus (_tmp23_);
#line 5003 "nibbles-game.c"
	} else {
#line 752 "../src/nibbles-game.vala"
		_tmp22_ = FALSE;
#line 5007 "nibbles-game.c"
	}
#line 752 "../src/nibbles-game.vala"
	if (_tmp22_) {
#line 753 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, TRUE);
#line 5013 "nibbles-game.c"
	}
#line 739 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 5017 "nibbles-game.c"
}

static GameStatus*
_game_status_dup (GameStatus* self)
{
	GameStatus* dup;
#line 764 "../src/nibbles-game.vala"
	dup = g_new0 (GameStatus, 1);
#line 764 "../src/nibbles-game.vala"
	memcpy (dup, self, sizeof (GameStatus));
#line 764 "../src/nibbles-game.vala"
	return dup;
#line 5030 "nibbles-game.c"
}

static gpointer
__game_status_dup0 (gpointer self)
{
#line 764 "../src/nibbles-game.vala"
	return self ? _game_status_dup (self) : NULL;
#line 5038 "nibbles-game.c"
}

GameStatus*
nibbles_game_get_game_status (NibblesGame* self)
{
	gint worms_left = 0;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	Boni* _tmp30_;
	GameStatus* result;
#line 756 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 758 "../src/nibbles-game.vala"
	worms_left = 0;
#line 5053 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 759 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 759 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 759 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 759 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 759 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 759 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 759 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 759 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5078 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
#line 759 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 759 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 759 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 759 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 759 "../src/nibbles-game.vala"
				break;
#line 5097 "nibbles-game.c"
			}
#line 759 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 759 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 759 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 761 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 761 "../src/nibbles-game.vala"
			_tmp9_ = worm_get_lives (_tmp8_);
#line 761 "../src/nibbles-game.vala"
			_tmp10_ = _tmp9_;
#line 761 "../src/nibbles-game.vala"
			if (((gint) _tmp10_) > 0) {
#line 762 "../src/nibbles-game.vala"
				worms_left += 1;
#line 5115 "nibbles-game.c"
			} else {
				gboolean _tmp11_ = FALSE;
				gint _tmp12_;
#line 763 "../src/nibbles-game.vala"
				_tmp12_ = self->priv->_numhumans;
#line 763 "../src/nibbles-game.vala"
				if (_tmp12_ == 0) {
#line 5123 "nibbles-game.c"
					Worm* _tmp13_;
					guint8 _tmp14_;
					guint8 _tmp15_;
#line 763 "../src/nibbles-game.vala"
					_tmp13_ = worm;
#line 763 "../src/nibbles-game.vala"
					_tmp14_ = worm_get_lives (_tmp13_);
#line 763 "../src/nibbles-game.vala"
					_tmp15_ = _tmp14_;
#line 763 "../src/nibbles-game.vala"
					_tmp11_ = ((gint) _tmp15_) == 0;
#line 5135 "nibbles-game.c"
				} else {
#line 763 "../src/nibbles-game.vala"
					_tmp11_ = FALSE;
#line 5139 "nibbles-game.c"
				}
#line 763 "../src/nibbles-game.vala"
				if (_tmp11_) {
#line 5143 "nibbles-game.c"
					GameStatus _tmp16_;
					GameStatus* _tmp17_;
#line 764 "../src/nibbles-game.vala"
					_tmp16_ = GAME_STATUS_GAMEOVER;
#line 764 "../src/nibbles-game.vala"
					_tmp17_ = __game_status_dup0 (&_tmp16_);
#line 764 "../src/nibbles-game.vala"
					result = _tmp17_;
#line 764 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 764 "../src/nibbles-game.vala"
					return result;
#line 5156 "nibbles-game.c"
				}
			}
#line 759 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5161 "nibbles-game.c"
		}
	}
#line 767 "../src/nibbles-game.vala"
	if (worms_left == 1) {
#line 5166 "nibbles-game.c"
		gint _tmp20_;
#line 767 "../src/nibbles-game.vala"
		_tmp20_ = self->priv->_numworms;
#line 767 "../src/nibbles-game.vala"
		_tmp19_ = _tmp20_ > 1;
#line 5172 "nibbles-game.c"
	} else {
#line 767 "../src/nibbles-game.vala"
		_tmp19_ = FALSE;
#line 5176 "nibbles-game.c"
	}
#line 767 "../src/nibbles-game.vala"
	if (_tmp19_) {
#line 767 "../src/nibbles-game.vala"
		_tmp18_ = TRUE;
#line 5182 "nibbles-game.c"
	} else {
		gboolean _tmp21_ = FALSE;
#line 767 "../src/nibbles-game.vala"
		if (nibbles_game_humans_left (self) == ((guint) 1)) {
#line 5187 "nibbles-game.c"
			gint _tmp22_;
#line 767 "../src/nibbles-game.vala"
			_tmp22_ = self->priv->_numhumans;
#line 767 "../src/nibbles-game.vala"
			_tmp21_ = _tmp22_ > 1;
#line 5193 "nibbles-game.c"
		} else {
#line 767 "../src/nibbles-game.vala"
			_tmp21_ = FALSE;
#line 5197 "nibbles-game.c"
		}
#line 767 "../src/nibbles-game.vala"
		_tmp18_ = _tmp21_;
#line 5201 "nibbles-game.c"
	}
#line 767 "../src/nibbles-game.vala"
	if (_tmp18_) {
#line 5205 "nibbles-game.c"
		GameStatus _tmp23_;
		GameStatus* _tmp24_;
#line 770 "../src/nibbles-game.vala"
		_tmp23_ = GAME_STATUS_VICTORY;
#line 770 "../src/nibbles-game.vala"
		_tmp24_ = __game_status_dup0 (&_tmp23_);
#line 770 "../src/nibbles-game.vala"
		result = _tmp24_;
#line 770 "../src/nibbles-game.vala"
		return result;
#line 5216 "nibbles-game.c"
	} else {
		gboolean _tmp25_ = FALSE;
#line 772 "../src/nibbles-game.vala"
		if (worms_left == 0) {
#line 772 "../src/nibbles-game.vala"
			_tmp25_ = TRUE;
#line 5223 "nibbles-game.c"
		} else {
			gboolean _tmp26_ = FALSE;
#line 772 "../src/nibbles-game.vala"
			if (nibbles_game_humans_left (self) == ((guint) 0)) {
#line 5228 "nibbles-game.c"
				gint _tmp27_;
#line 772 "../src/nibbles-game.vala"
				_tmp27_ = self->priv->_numhumans;
#line 772 "../src/nibbles-game.vala"
				_tmp26_ = _tmp27_ == 1;
#line 5234 "nibbles-game.c"
			} else {
#line 772 "../src/nibbles-game.vala"
				_tmp26_ = FALSE;
#line 5238 "nibbles-game.c"
			}
#line 772 "../src/nibbles-game.vala"
			_tmp25_ = _tmp26_;
#line 5242 "nibbles-game.c"
		}
#line 772 "../src/nibbles-game.vala"
		if (_tmp25_) {
#line 5246 "nibbles-game.c"
			GameStatus _tmp28_;
			GameStatus* _tmp29_;
#line 775 "../src/nibbles-game.vala"
			_tmp28_ = GAME_STATUS_GAMEOVER;
#line 775 "../src/nibbles-game.vala"
			_tmp29_ = __game_status_dup0 (&_tmp28_);
#line 775 "../src/nibbles-game.vala"
			result = _tmp29_;
#line 775 "../src/nibbles-game.vala"
			return result;
#line 5257 "nibbles-game.c"
		}
	}
#line 778 "../src/nibbles-game.vala"
	_tmp30_ = self->priv->boni;
#line 778 "../src/nibbles-game.vala"
	if (boni_last_regular_bonus (_tmp30_)) {
#line 5264 "nibbles-game.c"
		GameStatus _tmp31_;
		GameStatus* _tmp32_;
#line 779 "../src/nibbles-game.vala"
		_tmp31_ = GAME_STATUS_NEWROUND;
#line 779 "../src/nibbles-game.vala"
		_tmp32_ = __game_status_dup0 (&_tmp31_);
#line 779 "../src/nibbles-game.vala"
		result = _tmp32_;
#line 779 "../src/nibbles-game.vala"
		return result;
#line 5275 "nibbles-game.c"
	}
#line 781 "../src/nibbles-game.vala"
	result = NULL;
#line 781 "../src/nibbles-game.vala"
	return result;
#line 5281 "nibbles-game.c"
}

guint
nibbles_game_humans_left (NibblesGame* self)
{
	guint count = 0U;
	guint result;
#line 784 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 786 "../src/nibbles-game.vala"
	count = (guint) 0;
#line 5293 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 787 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 787 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 787 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 787 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 787 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 787 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 787 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 787 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5318 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			Worm* _tmp9_;
#line 787 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 787 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 787 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 787 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 787 "../src/nibbles-game.vala"
				break;
#line 5336 "nibbles-game.c"
			}
#line 787 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 787 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 787 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 788 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 788 "../src/nibbles-game.vala"
			if (_tmp9_->is_human) {
#line 5348 "nibbles-game.c"
				Worm* _tmp10_;
				guint8 _tmp11_;
				guint8 _tmp12_;
#line 788 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 788 "../src/nibbles-game.vala"
				_tmp11_ = worm_get_lives (_tmp10_);
#line 788 "../src/nibbles-game.vala"
				_tmp12_ = _tmp11_;
#line 788 "../src/nibbles-game.vala"
				_tmp8_ = ((gint) _tmp12_) > 0;
#line 5360 "nibbles-game.c"
			} else {
#line 788 "../src/nibbles-game.vala"
				_tmp8_ = FALSE;
#line 5364 "nibbles-game.c"
			}
#line 788 "../src/nibbles-game.vala"
			if (_tmp8_) {
#line 5368 "nibbles-game.c"
				guint _tmp13_;
#line 789 "../src/nibbles-game.vala"
				count = count + 1;
#line 789 "../src/nibbles-game.vala"
				_tmp13_ = count;
#line 5374 "nibbles-game.c"
			}
#line 787 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5378 "nibbles-game.c"
		}
	}
#line 790 "../src/nibbles-game.vala"
	result = count;
#line 790 "../src/nibbles-game.vala"
	return result;
#line 5385 "nibbles-game.c"
}

Worm*
nibbles_game_get_winner (NibblesGame* self)
{
	gboolean one_human_left = FALSE;
	Worm* result;
#line 793 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 795 "../src/nibbles-game.vala"
	one_human_left = nibbles_game_humans_left (self) == ((guint) 1);
#line 5397 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 796 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 796 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 796 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 796 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 796 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 796 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 796 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 796 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5422 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 796 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 796 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 796 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 796 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 796 "../src/nibbles-game.vala"
				break;
#line 5441 "nibbles-game.c"
			}
#line 796 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 796 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 796 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 797 "../src/nibbles-game.vala"
			if (one_human_left) {
#line 5451 "nibbles-game.c"
				Worm* _tmp11_;
#line 797 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 797 "../src/nibbles-game.vala"
				_tmp10_ = _tmp11_->is_human;
#line 5457 "nibbles-game.c"
			} else {
#line 797 "../src/nibbles-game.vala"
				_tmp10_ = FALSE;
#line 5461 "nibbles-game.c"
			}
#line 797 "../src/nibbles-game.vala"
			if (_tmp10_) {
#line 797 "../src/nibbles-game.vala"
				_tmp9_ = TRUE;
#line 5467 "nibbles-game.c"
			} else {
				gboolean _tmp12_ = FALSE;
#line 798 "../src/nibbles-game.vala"
				if (!one_human_left) {
#line 5472 "nibbles-game.c"
					Worm* _tmp13_;
#line 798 "../src/nibbles-game.vala"
					_tmp13_ = worm;
#line 798 "../src/nibbles-game.vala"
					_tmp12_ = !_tmp13_->is_human;
#line 5478 "nibbles-game.c"
				} else {
#line 798 "../src/nibbles-game.vala"
					_tmp12_ = FALSE;
#line 5482 "nibbles-game.c"
				}
#line 798 "../src/nibbles-game.vala"
				_tmp9_ = _tmp12_;
#line 5486 "nibbles-game.c"
			}
#line 797 "../src/nibbles-game.vala"
			if (_tmp9_) {
#line 5490 "nibbles-game.c"
				Worm* _tmp14_;
				guint8 _tmp15_;
				guint8 _tmp16_;
#line 798 "../src/nibbles-game.vala"
				_tmp14_ = worm;
#line 798 "../src/nibbles-game.vala"
				_tmp15_ = worm_get_lives (_tmp14_);
#line 798 "../src/nibbles-game.vala"
				_tmp16_ = _tmp15_;
#line 798 "../src/nibbles-game.vala"
				_tmp8_ = ((gint) _tmp16_) > 0;
#line 5502 "nibbles-game.c"
			} else {
#line 797 "../src/nibbles-game.vala"
				_tmp8_ = FALSE;
#line 5506 "nibbles-game.c"
			}
#line 797 "../src/nibbles-game.vala"
			if (_tmp8_) {
#line 799 "../src/nibbles-game.vala"
				result = worm;
#line 799 "../src/nibbles-game.vala"
				return result;
#line 5514 "nibbles-game.c"
			}
#line 796 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5518 "nibbles-game.c"
		}
	}
#line 800 "../src/nibbles-game.vala"
	result = NULL;
#line 800 "../src/nibbles-game.vala"
	return result;
#line 5525 "nibbles-game.c"
}

static gboolean
__lambda7_ (NibblesGame* self,
            GValue* value,
            GVariant* variant,
            void* data)
{
	const gchar* _tmp0_;
	gboolean result;
#line 812 "../src/nibbles-game.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 812 "../src/nibbles-game.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 814 "../src/nibbles-game.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 814 "../src/nibbles-game.vala"
	g_value_set_int (value, nibbles_game_get_color_num (_tmp0_));
#line 815 "../src/nibbles-game.vala"
	result = TRUE;
#line 815 "../src/nibbles-game.vala"
	return result;
#line 5548 "nibbles-game.c"
}

static gboolean
___lambda7___localfunc0_ (GValue* value,
                          GVariant* variant,
                          void* data,
                          gpointer self)
{
	gboolean result;
	result = __lambda7_ ((NibblesGame*) self, value, variant, data);
#line 812 "../src/nibbles-game.vala"
	return result;
#line 5561 "nibbles-game.c"
}

static GVariant*
__lambda8_ (NibblesGame* self,
            GValue* value,
            const GVariantType* type,
            void* data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 820 "../src/nibbles-game.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 820 "../src/nibbles-game.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 822 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_color_string (g_value_get_int (value));
#line 822 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 822 "../src/nibbles-game.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 822 "../src/nibbles-game.vala"
	g_variant_ref_sink (_tmp2_);
#line 822 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 822 "../src/nibbles-game.vala"
	_g_free0 (_tmp1_);
#line 822 "../src/nibbles-game.vala"
	result = _tmp3_;
#line 822 "../src/nibbles-game.vala"
	return result;
#line 5595 "nibbles-game.c"
}

static GVariant*
___lambda8___localfunc1_ (GValue* value,
                          const GVariantType* type,
                          void* data,
                          gpointer self)
{
	GVariant* result;
	result = __lambda8_ ((NibblesGame*) self, value, type, data);
#line 820 "../src/nibbles-game.vala"
	return result;
#line 5608 "nibbles-game.c"
}

void
nibbles_game_load_worm_properties (NibblesGame* self,
                                   GeeArrayList* worm_settings)
{
	_LocalFunc0_ GetMappingFunction = NULL;
	gpointer GetMappingFunction_target;
	_LocalFunc1_ SetMappingFunction = NULL;
	gpointer SetMappingFunction_target;
	GeeHashMap* _tmp0_;
#line 807 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 807 "../src/nibbles-game.vala"
	g_return_if_fail (worm_settings != NULL);
#line 812 "../src/nibbles-game.vala"
	GetMappingFunction = ___lambda7___localfunc0_;
#line 812 "../src/nibbles-game.vala"
	GetMappingFunction_target = self;
#line 820 "../src/nibbles-game.vala"
	SetMappingFunction = ___lambda8___localfunc1_;
#line 820 "../src/nibbles-game.vala"
	SetMappingFunction_target = self;
#line 824 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 824 "../src/nibbles-game.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 5636 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 825 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 825 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 825 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 825 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 825 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 825 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 825 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 825 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5661 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			WormProperties* properties = NULL;
			WormProperties* _tmp9_;
			Worm* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			GSettings* _tmp14_;
			WormProperties* _tmp15_;
			_LocalFunc0_ _tmp16_;
			gpointer _tmp16__target;
			_LocalFunc1_ _tmp17_;
			gpointer _tmp17__target;
			Worm* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gpointer _tmp21_;
			GSettings* _tmp22_;
			WormProperties* _tmp23_;
			Worm* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gpointer _tmp27_;
			GSettings* _tmp28_;
			WormProperties* _tmp29_;
			Worm* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gpointer _tmp33_;
			GSettings* _tmp34_;
			WormProperties* _tmp35_;
			Worm* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gpointer _tmp39_;
			GSettings* _tmp40_;
			WormProperties* _tmp41_;
			Worm* _tmp42_;
			gint _tmp43_;
			gint _tmp44_;
			gpointer _tmp45_;
			GSettings* _tmp46_;
			WormProperties* _tmp47_;
			Worm* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			gpointer _tmp51_;
			GSettings* _tmp52_;
			WormProperties* _tmp53_;
			Worm* _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
			gpointer _tmp57_;
			GSettings* _tmp58_;
			WormProperties* _tmp59_;
			Worm* _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
			gpointer _tmp63_;
			GSettings* _tmp64_;
			WormProperties* _tmp65_;
			GeeHashMap* _tmp66_;
			Worm* _tmp67_;
			WormProperties* _tmp68_;
#line 825 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 825 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 825 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 825 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 825 "../src/nibbles-game.vala"
				break;
#line 5740 "nibbles-game.c"
			}
#line 825 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 825 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 825 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 827 "../src/nibbles-game.vala"
			_tmp9_ = worm_properties_new ();
#line 827 "../src/nibbles-game.vala"
			properties = _tmp9_;
#line 828 "../src/nibbles-game.vala"
			_tmp10_ = worm;
#line 828 "../src/nibbles-game.vala"
			_tmp11_ = worm_get_id (_tmp10_);
#line 828 "../src/nibbles-game.vala"
			_tmp12_ = _tmp11_;
#line 828 "../src/nibbles-game.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp12_);
#line 828 "../src/nibbles-game.vala"
			_tmp14_ = (GSettings*) _tmp13_;
#line 828 "../src/nibbles-game.vala"
			_tmp15_ = properties;
#line 828 "../src/nibbles-game.vala"
			_tmp16_ = GetMappingFunction;
#line 828 "../src/nibbles-game.vala"
			_tmp16__target = GetMappingFunction_target;
#line 828 "../src/nibbles-game.vala"
			_tmp17_ = SetMappingFunction;
#line 828 "../src/nibbles-game.vala"
			_tmp17__target = SetMappingFunction_target;
#line 828 "../src/nibbles-game.vala"
			g_settings_bind_with_mapping (_tmp14_, "color", (GObject*) _tmp15_, "color", G_SETTINGS_BIND_DEFAULT, (GSettingsBindGetMapping) _tmp16_, (GSettingsBindSetMapping) _tmp17_, NULL, NULL);
#line 828 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp14_);
#line 835 "../src/nibbles-game.vala"
			_tmp18_ = worm;
#line 835 "../src/nibbles-game.vala"
			_tmp19_ = worm_get_id (_tmp18_);
#line 835 "../src/nibbles-game.vala"
			_tmp20_ = _tmp19_;
#line 835 "../src/nibbles-game.vala"
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp20_);
#line 835 "../src/nibbles-game.vala"
			_tmp22_ = (GSettings*) _tmp21_;
#line 835 "../src/nibbles-game.vala"
			_tmp23_ = properties;
#line 835 "../src/nibbles-game.vala"
			g_settings_bind (_tmp22_, "key-up", (GObject*) _tmp23_, "up", G_SETTINGS_BIND_DEFAULT);
#line 835 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp22_);
#line 836 "../src/nibbles-game.vala"
			_tmp24_ = worm;
#line 836 "../src/nibbles-game.vala"
			_tmp25_ = worm_get_id (_tmp24_);
#line 836 "../src/nibbles-game.vala"
			_tmp26_ = _tmp25_;
#line 836 "../src/nibbles-game.vala"
			_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp26_);
#line 836 "../src/nibbles-game.vala"
			_tmp28_ = (GSettings*) _tmp27_;
#line 836 "../src/nibbles-game.vala"
			_tmp29_ = properties;
#line 836 "../src/nibbles-game.vala"
			g_settings_bind (_tmp28_, "key-down", (GObject*) _tmp29_, "down", G_SETTINGS_BIND_DEFAULT);
#line 836 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp28_);
#line 837 "../src/nibbles-game.vala"
			_tmp30_ = worm;
#line 837 "../src/nibbles-game.vala"
			_tmp31_ = worm_get_id (_tmp30_);
#line 837 "../src/nibbles-game.vala"
			_tmp32_ = _tmp31_;
#line 837 "../src/nibbles-game.vala"
			_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp32_);
#line 837 "../src/nibbles-game.vala"
			_tmp34_ = (GSettings*) _tmp33_;
#line 837 "../src/nibbles-game.vala"
			_tmp35_ = properties;
#line 837 "../src/nibbles-game.vala"
			g_settings_bind (_tmp34_, "key-left", (GObject*) _tmp35_, "left", G_SETTINGS_BIND_DEFAULT);
#line 837 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp34_);
#line 838 "../src/nibbles-game.vala"
			_tmp36_ = worm;
#line 838 "../src/nibbles-game.vala"
			_tmp37_ = worm_get_id (_tmp36_);
#line 838 "../src/nibbles-game.vala"
			_tmp38_ = _tmp37_;
#line 838 "../src/nibbles-game.vala"
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp38_);
#line 838 "../src/nibbles-game.vala"
			_tmp40_ = (GSettings*) _tmp39_;
#line 838 "../src/nibbles-game.vala"
			_tmp41_ = properties;
#line 838 "../src/nibbles-game.vala"
			g_settings_bind (_tmp40_, "key-right", (GObject*) _tmp41_, "right", G_SETTINGS_BIND_DEFAULT);
#line 838 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp40_);
#line 839 "../src/nibbles-game.vala"
			_tmp42_ = worm;
#line 839 "../src/nibbles-game.vala"
			_tmp43_ = worm_get_id (_tmp42_);
#line 839 "../src/nibbles-game.vala"
			_tmp44_ = _tmp43_;
#line 839 "../src/nibbles-game.vala"
			_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp44_);
#line 839 "../src/nibbles-game.vala"
			_tmp46_ = (GSettings*) _tmp45_;
#line 839 "../src/nibbles-game.vala"
			_tmp47_ = properties;
#line 839 "../src/nibbles-game.vala"
			g_settings_bind (_tmp46_, "key-up-raw", (GObject*) _tmp47_, "raw-up", G_SETTINGS_BIND_DEFAULT);
#line 839 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp46_);
#line 840 "../src/nibbles-game.vala"
			_tmp48_ = worm;
#line 840 "../src/nibbles-game.vala"
			_tmp49_ = worm_get_id (_tmp48_);
#line 840 "../src/nibbles-game.vala"
			_tmp50_ = _tmp49_;
#line 840 "../src/nibbles-game.vala"
			_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp50_);
#line 840 "../src/nibbles-game.vala"
			_tmp52_ = (GSettings*) _tmp51_;
#line 840 "../src/nibbles-game.vala"
			_tmp53_ = properties;
#line 840 "../src/nibbles-game.vala"
			g_settings_bind (_tmp52_, "key-down-raw", (GObject*) _tmp53_, "raw-down", G_SETTINGS_BIND_DEFAULT);
#line 840 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp52_);
#line 841 "../src/nibbles-game.vala"
			_tmp54_ = worm;
#line 841 "../src/nibbles-game.vala"
			_tmp55_ = worm_get_id (_tmp54_);
#line 841 "../src/nibbles-game.vala"
			_tmp56_ = _tmp55_;
#line 841 "../src/nibbles-game.vala"
			_tmp57_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp56_);
#line 841 "../src/nibbles-game.vala"
			_tmp58_ = (GSettings*) _tmp57_;
#line 841 "../src/nibbles-game.vala"
			_tmp59_ = properties;
#line 841 "../src/nibbles-game.vala"
			g_settings_bind (_tmp58_, "key-left-raw", (GObject*) _tmp59_, "raw-left", G_SETTINGS_BIND_DEFAULT);
#line 841 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp58_);
#line 842 "../src/nibbles-game.vala"
			_tmp60_ = worm;
#line 842 "../src/nibbles-game.vala"
			_tmp61_ = worm_get_id (_tmp60_);
#line 842 "../src/nibbles-game.vala"
			_tmp62_ = _tmp61_;
#line 842 "../src/nibbles-game.vala"
			_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp62_);
#line 842 "../src/nibbles-game.vala"
			_tmp64_ = (GSettings*) _tmp63_;
#line 842 "../src/nibbles-game.vala"
			_tmp65_ = properties;
#line 842 "../src/nibbles-game.vala"
			g_settings_bind (_tmp64_, "key-right-raw", (GObject*) _tmp65_, "raw-right", G_SETTINGS_BIND_DEFAULT);
#line 842 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp64_);
#line 843 "../src/nibbles-game.vala"
			_tmp66_ = self->priv->_worm_props;
#line 843 "../src/nibbles-game.vala"
			_tmp67_ = worm;
#line 843 "../src/nibbles-game.vala"
			_tmp68_ = properties;
#line 843 "../src/nibbles-game.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp66_, _tmp67_, _tmp68_);
#line 825 "../src/nibbles-game.vala"
			_g_object_unref0 (properties);
#line 825 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5916 "nibbles-game.c"
		}
	}
}

static inline gchar*
nibbles_game_get_color_string (gint color)
{
	gchar* result;
#line 848 "../src/nibbles-game.vala"
	switch (color) {
#line 848 "../src/nibbles-game.vala"
		case 0:
#line 5929 "nibbles-game.c"
		{
			gchar* _tmp0_;
#line 850 "../src/nibbles-game.vala"
			_tmp0_ = g_strdup ("red");
#line 850 "../src/nibbles-game.vala"
			result = _tmp0_;
#line 850 "../src/nibbles-game.vala"
			return result;
#line 5938 "nibbles-game.c"
		}
#line 848 "../src/nibbles-game.vala"
		case 1:
#line 5942 "nibbles-game.c"
		{
			gchar* _tmp1_;
#line 851 "../src/nibbles-game.vala"
			_tmp1_ = g_strdup ("green");
#line 851 "../src/nibbles-game.vala"
			result = _tmp1_;
#line 851 "../src/nibbles-game.vala"
			return result;
#line 5951 "nibbles-game.c"
		}
#line 848 "../src/nibbles-game.vala"
		case 2:
#line 5955 "nibbles-game.c"
		{
			gchar* _tmp2_;
#line 852 "../src/nibbles-game.vala"
			_tmp2_ = g_strdup ("blue");
#line 852 "../src/nibbles-game.vala"
			result = _tmp2_;
#line 852 "../src/nibbles-game.vala"
			return result;
#line 5964 "nibbles-game.c"
		}
#line 848 "../src/nibbles-game.vala"
		case 3:
#line 5968 "nibbles-game.c"
		{
			gchar* _tmp3_;
#line 853 "../src/nibbles-game.vala"
			_tmp3_ = g_strdup ("yellow");
#line 853 "../src/nibbles-game.vala"
			result = _tmp3_;
#line 853 "../src/nibbles-game.vala"
			return result;
#line 5977 "nibbles-game.c"
		}
#line 848 "../src/nibbles-game.vala"
		case 4:
#line 5981 "nibbles-game.c"
		{
			gchar* _tmp4_;
#line 854 "../src/nibbles-game.vala"
			_tmp4_ = g_strdup ("cyan");
#line 854 "../src/nibbles-game.vala"
			result = _tmp4_;
#line 854 "../src/nibbles-game.vala"
			return result;
#line 5990 "nibbles-game.c"
		}
#line 848 "../src/nibbles-game.vala"
		case 5:
#line 5994 "nibbles-game.c"
		{
			gchar* _tmp5_;
#line 855 "../src/nibbles-game.vala"
			_tmp5_ = g_strdup ("purple");
#line 855 "../src/nibbles-game.vala"
			result = _tmp5_;
#line 855 "../src/nibbles-game.vala"
			return result;
#line 6003 "nibbles-game.c"
		}
		default:
		{
#line 856 "../src/nibbles-game.vala"
			g_assert_not_reached ();
#line 6009 "nibbles-game.c"
		}
	}
}

static inline gint
nibbles_game_get_color_num (const gchar* color)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 861 "../src/nibbles-game.vala"
	static GQuark _tmp1_label0 = 0;
#line 861 "../src/nibbles-game.vala"
	static GQuark _tmp1_label1 = 0;
#line 861 "../src/nibbles-game.vala"
	static GQuark _tmp1_label2 = 0;
#line 861 "../src/nibbles-game.vala"
	static GQuark _tmp1_label3 = 0;
#line 861 "../src/nibbles-game.vala"
	static GQuark _tmp1_label4 = 0;
#line 861 "../src/nibbles-game.vala"
	static GQuark _tmp1_label5 = 0;
#line 6031 "nibbles-game.c"
	gint result;
#line 859 "../src/nibbles-game.vala"
	g_return_val_if_fail (color != NULL, 0);
#line 861 "../src/nibbles-game.vala"
	_tmp0_ = color;
#line 861 "../src/nibbles-game.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 861 "../src/nibbles-game.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("red")))) {
#line 861 "../src/nibbles-game.vala"
		switch (0) {
#line 6043 "nibbles-game.c"
			default:
			{
#line 863 "../src/nibbles-game.vala"
				result = 0;
#line 863 "../src/nibbles-game.vala"
				return result;
#line 6050 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("green")))) {
#line 861 "../src/nibbles-game.vala"
		switch (0) {
#line 6056 "nibbles-game.c"
			default:
			{
#line 864 "../src/nibbles-game.vala"
				result = 1;
#line 864 "../src/nibbles-game.vala"
				return result;
#line 6063 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("blue")))) {
#line 861 "../src/nibbles-game.vala"
		switch (0) {
#line 6069 "nibbles-game.c"
			default:
			{
#line 865 "../src/nibbles-game.vala"
				result = 2;
#line 865 "../src/nibbles-game.vala"
				return result;
#line 6076 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("yellow")))) {
#line 861 "../src/nibbles-game.vala"
		switch (0) {
#line 6082 "nibbles-game.c"
			default:
			{
#line 866 "../src/nibbles-game.vala"
				result = 3;
#line 866 "../src/nibbles-game.vala"
				return result;
#line 6089 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("cyan")))) {
#line 861 "../src/nibbles-game.vala"
		switch (0) {
#line 6095 "nibbles-game.c"
			default:
			{
#line 867 "../src/nibbles-game.vala"
				result = 4;
#line 867 "../src/nibbles-game.vala"
				return result;
#line 6102 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("purple")))) {
#line 861 "../src/nibbles-game.vala"
		switch (0) {
#line 6108 "nibbles-game.c"
			default:
			{
#line 868 "../src/nibbles-game.vala"
				result = 5;
#line 868 "../src/nibbles-game.vala"
				return result;
#line 6115 "nibbles-game.c"
			}
		}
	} else {
#line 861 "../src/nibbles-game.vala"
		switch (0) {
#line 6121 "nibbles-game.c"
			default:
			{
#line 869 "../src/nibbles-game.vala"
				g_assert_not_reached ();
#line 6126 "nibbles-game.c"
			}
		}
	}
}

gboolean
nibbles_game_keypress (NibblesGame* self,
                       guint keyval,
                       guint keycode,
                       gboolean* remove_handler)
{
	gboolean _vala_remove_handler = FALSE;
	gboolean result;
#line 873 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 875 "../src/nibbles-game.vala"
	_vala_remove_handler = FALSE;
#line 876 "../src/nibbles-game.vala"
	result = nibbles_game_handle_keypress (self, keyval, keycode);
#line 876 "../src/nibbles-game.vala"
	if (remove_handler) {
#line 876 "../src/nibbles-game.vala"
		*remove_handler = _vala_remove_handler;
#line 6150 "nibbles-game.c"
	}
#line 876 "../src/nibbles-game.vala"
	return result;
#line 6154 "nibbles-game.c"
}

gboolean
nibbles_game_handle_keypress (NibblesGame* self,
                              guint keyval,
                              guint keycode)
{
	gboolean _tmp0_;
	gboolean result;
#line 879 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 881 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_is_running;
#line 881 "../src/nibbles-game.vala"
	if (!_tmp0_) {
#line 882 "../src/nibbles-game.vala"
		result = FALSE;
#line 882 "../src/nibbles-game.vala"
		return result;
#line 6174 "nibbles-game.c"
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 884 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 884 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 884 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 884 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 884 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 884 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 884 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 884 "../src/nibbles-game.vala"
		while (TRUE) {
#line 6200 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
#line 884 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 884 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 884 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 884 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 884 "../src/nibbles-game.vala"
				break;
#line 6217 "nibbles-game.c"
			}
#line 884 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 884 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 884 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 886 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 886 "../src/nibbles-game.vala"
			if (_tmp9_->is_human) {
#line 6229 "nibbles-game.c"
				Worm* _tmp10_;
				GeeHashMap* _tmp11_;
				gint* _tmp12_;
				gint _tmp12__length1;
				gint _tmp12__length2;
				GeeLinkedList* _tmp13_;
#line 887 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 887 "../src/nibbles-game.vala"
				_tmp11_ = self->priv->_worm_props;
#line 887 "../src/nibbles-game.vala"
				_tmp12_ = self->board;
#line 887 "../src/nibbles-game.vala"
				_tmp12__length1 = self->board_length1;
#line 887 "../src/nibbles-game.vala"
				_tmp12__length2 = self->board_length2;
#line 887 "../src/nibbles-game.vala"
				_tmp13_ = self->priv->_worms;
#line 887 "../src/nibbles-game.vala"
				if (worm_handle_keypress (_tmp10_, keycode, _tmp11_, _tmp12_, (gint) _tmp12__length1, (gint) _tmp12__length2, _tmp13_)) {
#line 888 "../src/nibbles-game.vala"
					result = TRUE;
#line 888 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 888 "../src/nibbles-game.vala"
					return result;
#line 6256 "nibbles-game.c"
				}
			}
#line 884 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 6261 "nibbles-game.c"
		}
	}
#line 891 "../src/nibbles-game.vala"
	result = FALSE;
#line 891 "../src/nibbles-game.vala"
	return result;
#line 6268 "nibbles-game.c"
}

static GeeList*
nibbles_game_get_other_worms (NibblesGame* self,
                              Worm* _self_)
{
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 898 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 898 "../src/nibbles-game.vala"
	g_return_val_if_fail (_self_ != NULL, NULL);
#line 900 "../src/nibbles-game.vala"
	_tmp0_ = gee_array_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 900 "../src/nibbles-game.vala"
	_result_ = _tmp0_;
#line 6286 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 901 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 901 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 901 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 901 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 901 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 901 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 901 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 901 "../src/nibbles-game.vala"
		while (TRUE) {
#line 6311 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
#line 901 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 901 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 901 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 901 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 901 "../src/nibbles-game.vala"
				break;
#line 6328 "nibbles-game.c"
			}
#line 901 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 901 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 901 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 903 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 903 "../src/nibbles-game.vala"
			if (_tmp9_ != _self_) {
#line 6340 "nibbles-game.c"
				GeeArrayList* _tmp10_;
				Worm* _tmp11_;
#line 904 "../src/nibbles-game.vala"
				_tmp10_ = _result_;
#line 904 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 904 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 6349 "nibbles-game.c"
			}
#line 901 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 6353 "nibbles-game.c"
		}
	}
#line 906 "../src/nibbles-game.vala"
	result = (GeeList*) _result_;
#line 906 "../src/nibbles-game.vala"
	return result;
#line 6360 "nibbles-game.c"
}

GeeList*
nibbles_game_get_bonuses (NibblesGame* self)
{
	Boni* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 909 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 911 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->boni;
#line 911 "../src/nibbles-game.vala"
	_tmp1_ = boni_get_bonuses (_tmp0_);
#line 911 "../src/nibbles-game.vala"
	result = _tmp1_;
#line 911 "../src/nibbles-game.vala"
	return result;
#line 6379 "nibbles-game.c"
}

gboolean
nibbles_game_get_skip_score (NibblesGame* self)
{
	gboolean result;
#line 55 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/nibbles-game.vala"
	result = self->priv->_skip_score;
#line 55 "../src/nibbles-game.vala"
	return result;
#line 6392 "nibbles-game.c"
}

void
nibbles_game_set_skip_score (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 55 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_skip_score (self);
#line 55 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 55 "../src/nibbles-game.vala"
		self->priv->_skip_score = value;
#line 55 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY]);
#line 6410 "nibbles-game.c"
	}
}

gint
nibbles_game_get_current_level (NibblesGame* self)
{
	gint result;
#line 56 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "../src/nibbles-game.vala"
	result = self->priv->_current_level;
#line 56 "../src/nibbles-game.vala"
	return result;
#line 6424 "nibbles-game.c"
}

void
nibbles_game_set_current_level (NibblesGame* self,
                                gint value)
{
	gint old_value;
#line 56 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_current_level (self);
#line 56 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 56 "../src/nibbles-game.vala"
		self->priv->_current_level = value;
#line 56 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY]);
#line 6442 "nibbles-game.c"
	}
}

gboolean
nibbles_game_get_three_dimensional_view (NibblesGame* self)
{
	gboolean result;
#line 57 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/nibbles-game.vala"
	result = self->priv->_three_dimensional_view;
#line 57 "../src/nibbles-game.vala"
	return result;
#line 6456 "nibbles-game.c"
}

void
nibbles_game_set_three_dimensional_view (NibblesGame* self,
                                         gboolean value)
{
	gboolean old_value;
#line 57 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_three_dimensional_view (self);
#line 57 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 57 "../src/nibbles-game.vala"
		self->priv->_three_dimensional_view = value;
#line 57 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY]);
#line 6474 "nibbles-game.c"
	}
}

gint
nibbles_game_get_speed (NibblesGame* self)
{
	gint result;
#line 58 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 58 "../src/nibbles-game.vala"
	result = self->priv->_speed;
#line 58 "../src/nibbles-game.vala"
	return result;
#line 6488 "nibbles-game.c"
}

void
nibbles_game_set_speed (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 58 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_speed (self);
#line 58 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 58 "../src/nibbles-game.vala"
		self->priv->_speed = value;
#line 58 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY]);
#line 6506 "nibbles-game.c"
	}
}

gint
nibbles_game_get_gamedelay (NibblesGame* self)
{
	gint result;
#line 59 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "../src/nibbles-game.vala"
	result = self->priv->_gamedelay;
#line 59 "../src/nibbles-game.vala"
	return result;
#line 6520 "nibbles-game.c"
}

static void
nibbles_game_set_gamedelay (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 59 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_gamedelay (self);
#line 59 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 59 "../src/nibbles-game.vala"
		self->priv->_gamedelay = value;
#line 59 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY]);
#line 6538 "nibbles-game.c"
	}
}

gint
nibbles_game_get_progress (NibblesGame* self)
{
	gint result;
#line 61 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 61 "../src/nibbles-game.vala"
	result = self->_progress;
#line 61 "../src/nibbles-game.vala"
	return result;
#line 6552 "nibbles-game.c"
}

void
nibbles_game_set_progress (NibblesGame* self,
                           gint value)
{
	Boni* _tmp0_;
#line 61 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/nibbles-game.vala"
	self->_progress = value;
#line 61 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->boni;
#line 61 "../src/nibbles-game.vala"
	if (_tmp0_ != NULL) {
#line 6568 "nibbles-game.c"
		Boni* _tmp1_;
#line 61 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->boni;
#line 61 "../src/nibbles-game.vala"
		_tmp1_->progress = self->_progress;
#line 6574 "nibbles-game.c"
	}
#line 61 "../src/nibbles-game.vala"
	g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_PROGRESS_PROPERTY]);
#line 6578 "nibbles-game.c"
}

gint
nibbles_game_get_start_level (NibblesGame* self)
{
	gint result;
#line 62 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../src/nibbles-game.vala"
	result = self->priv->_start_level;
#line 62 "../src/nibbles-game.vala"
	return result;
#line 6591 "nibbles-game.c"
}

void
nibbles_game_set_start_level (NibblesGame* self,
                              gint value)
{
	gint old_value;
#line 62 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_start_level (self);
#line 62 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 62 "../src/nibbles-game.vala"
		self->priv->_start_level = value;
#line 62 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_START_LEVEL_PROPERTY]);
#line 6609 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_width (NibblesGame* self)
{
	guint8 result;
#line 68 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 68 "../src/nibbles-game.vala"
	result = self->priv->_width;
#line 68 "../src/nibbles-game.vala"
	return result;
#line 6623 "nibbles-game.c"
}

static void
nibbles_game_set_width (NibblesGame* self,
                        guint8 value)
{
	guint8 old_value;
#line 68 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_width (self);
#line 68 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 68 "../src/nibbles-game.vala"
		self->priv->_width = value;
#line 68 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY]);
#line 6641 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_height (NibblesGame* self)
{
	guint8 result;
#line 69 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "../src/nibbles-game.vala"
	result = self->priv->_height;
#line 69 "../src/nibbles-game.vala"
	return result;
#line 6655 "nibbles-game.c"
}

static void
nibbles_game_set_height (NibblesGame* self,
                         guint8 value)
{
	guint8 old_value;
#line 69 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_height (self);
#line 69 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 69 "../src/nibbles-game.vala"
		self->priv->_height = value;
#line 69 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY]);
#line 6673 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numhumans (NibblesGame* self)
{
	gint result;
#line 72 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "../src/nibbles-game.vala"
	result = self->priv->_numhumans;
#line 72 "../src/nibbles-game.vala"
	return result;
#line 6687 "nibbles-game.c"
}

void
nibbles_game_set_numhumans (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 72 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numhumans (self);
#line 72 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 72 "../src/nibbles-game.vala"
		self->priv->_numhumans = value;
#line 72 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY]);
#line 6705 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numai (NibblesGame* self)
{
	gint result;
#line 73 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../src/nibbles-game.vala"
	result = self->priv->_numai;
#line 73 "../src/nibbles-game.vala"
	return result;
#line 6719 "nibbles-game.c"
}

void
nibbles_game_set_numai (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 73 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numai (self);
#line 73 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 73 "../src/nibbles-game.vala"
		self->priv->_numai = value;
#line 73 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY]);
#line 6737 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numworms (NibblesGame* self)
{
	gint result;
#line 74 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 74 "../src/nibbles-game.vala"
	result = self->priv->_numworms;
#line 74 "../src/nibbles-game.vala"
	return result;
#line 6751 "nibbles-game.c"
}

static void
nibbles_game_set_numworms (NibblesGame* self,
                           gint value)
{
	gint old_value;
#line 74 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numworms (self);
#line 74 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 74 "../src/nibbles-game.vala"
		self->priv->_numworms = value;
#line 74 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY]);
#line 6769 "nibbles-game.c"
	}
}

GeeLinkedList*
nibbles_game_get_worms (NibblesGame* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 77 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 77 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 77 "../src/nibbles-game.vala"
	return result;
#line 6786 "nibbles-game.c"
}

GeeHashMap*
nibbles_game_get_worm_props (NibblesGame* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 78 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 78 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 78 "../src/nibbles-game.vala"
	return result;
#line 6802 "nibbles-game.c"
}

gboolean
nibbles_game_get_is_running (NibblesGame* self)
{
	gboolean result;
#line 84 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../src/nibbles-game.vala"
	result = self->priv->_is_running;
#line 84 "../src/nibbles-game.vala"
	return result;
#line 6815 "nibbles-game.c"
}

static void
nibbles_game_set_is_running (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 84 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_is_running (self);
#line 84 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 84 "../src/nibbles-game.vala"
		self->priv->_is_running = value;
#line 84 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY]);
#line 6833 "nibbles-game.c"
	}
}

static gboolean
nibbles_game_get_is_paused (NibblesGame* self)
{
	gboolean result;
#line 85 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 85 "../src/nibbles-game.vala"
	result = self->priv->_is_paused;
#line 85 "../src/nibbles-game.vala"
	return result;
#line 6847 "nibbles-game.c"
}

static void
nibbles_game_set_is_paused (NibblesGame* self,
                            gboolean value)
{
#line 85 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/nibbles-game.vala"
	self->priv->_is_paused = value;
#line 6858 "nibbles-game.c"
}

gboolean
nibbles_game_get_paused (NibblesGame* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 88 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_is_paused;
#line 88 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 88 "../src/nibbles-game.vala"
	return result;
#line 6874 "nibbles-game.c"
}

void
nibbles_game_set_paused (NibblesGame* self,
                         gboolean value)
{
#line 89 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, value);
#line 92 "../src/nibbles-game.vala"
	if (value) {
#line 93 "../src/nibbles-game.vala"
		nibbles_game_stop (self);
#line 6889 "nibbles-game.c"
	} else {
#line 95 "../src/nibbles-game.vala"
		nibbles_game_start (self, FALSE);
#line 6893 "nibbles-game.c"
	}
#line 89 "../src/nibbles-game.vala"
	g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_PAUSED_PROPERTY]);
#line 6897 "nibbles-game.c"
}

gboolean
nibbles_game_get_fakes (NibblesGame* self)
{
	gboolean result;
#line 101 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 101 "../src/nibbles-game.vala"
	result = self->priv->_fakes;
#line 101 "../src/nibbles-game.vala"
	return result;
#line 6910 "nibbles-game.c"
}

void
nibbles_game_set_fakes (NibblesGame* self,
                        gboolean value)
{
	gboolean old_value;
#line 101 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_fakes (self);
#line 101 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 101 "../src/nibbles-game.vala"
		self->priv->_fakes = value;
#line 101 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY]);
#line 6928 "nibbles-game.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 43 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 43 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 43 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 6954 "nibbles-game.c"
	} else {
#line 43 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 43 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 6960 "nibbles-game.c"
	}
#line 43 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 43 "../src/nibbles-game.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6966 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 43 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 43 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 43 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 6991 "nibbles-game.c"
	} else {
#line 43 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 43 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 6997 "nibbles-game.c"
	}
#line 43 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 43 "../src/nibbles-game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 7003 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 43 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 43 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 43 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7028 "nibbles-game.c"
	} else {
#line 43 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 43 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7034 "nibbles-game.c"
	}
#line 43 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 43 "../src/nibbles-game.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 7040 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_STRING__VOID (GClosure * closure,
                                      GValue * return_value,
                                      guint n_param_values,
                                      const GValue * param_values,
                                      gpointer invocation_hint,
                                      gpointer marshal_data)
{
	typedef const char* (*GMarshalFunc_STRING__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_STRING__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	const char* v_return;
	cc = (GCClosure *) closure;
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (return_value != NULL);
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 1);
#line 43 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 43 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 43 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7068 "nibbles-game.c"
	} else {
#line 43 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 43 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7074 "nibbles-game.c"
	}
#line 43 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_STRING__VOID) (marshal_data ? marshal_data : cc->callback);
#line 43 "../src/nibbles-game.vala"
	v_return = callback (data1, data2);
#line 43 "../src/nibbles-game.vala"
	g_value_take_string (return_value, v_return);
#line 7082 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__POINTER_POINTER) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_BOOLEAN__POINTER_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (return_value != NULL);
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 43 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 43 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 43 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7110 "nibbles-game.c"
	} else {
#line 43 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 43 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7116 "nibbles-game.c"
	}
#line 43 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_BOOLEAN__POINTER_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 43 "../src/nibbles-game.vala"
	v_return = callback (data1, g_value_get_pointer (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 43 "../src/nibbles-game.vala"
	g_value_set_boolean (return_value, v_return);
#line 7124 "nibbles-game.c"
}

static void
_nibbles_game___lambda9_ (NibblesGame* self,
                          Bonus* bonus)
{
#line 127 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 127 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL], 0, bonus);
#line 7135 "nibbles-game.c"
}

static void
__nibbles_game___lambda9__boni_bonus_removed (Boni* _sender,
                                              Bonus* bonus,
                                              gpointer self)
{
#line 127 "../src/nibbles-game.vala"
	_nibbles_game___lambda9_ ((NibblesGame*) self, bonus);
#line 7145 "nibbles-game.c"
}

static GObject *
nibbles_game_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NibblesGame * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint* _tmp2_;
	Boni* _tmp3_;
#line 124 "../src/nibbles-game.vala"
	parent_class = G_OBJECT_CLASS (nibbles_game_parent_class);
#line 124 "../src/nibbles-game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 124 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 126 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_width;
#line 126 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_height;
#line 126 "../src/nibbles-game.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 126 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 126 "../src/nibbles-game.vala"
	self->board = _tmp2_;
#line 126 "../src/nibbles-game.vala"
	self->board_length1 = _tmp0_;
#line 126 "../src/nibbles-game.vala"
	self->board_length2 = _tmp1_;
#line 127 "../src/nibbles-game.vala"
	_tmp3_ = self->priv->boni;
#line 127 "../src/nibbles-game.vala"
	g_signal_connect_object (_tmp3_, "bonus-removed", (GCallback) __nibbles_game___lambda9__boni_bonus_removed, self, 0);
#line 124 "../src/nibbles-game.vala"
	return obj;
#line 7186 "nibbles-game.c"
}

static void
nibbles_game_class_init (NibblesGameClass * klass,
                         gpointer klass_data)
{
#line 43 "../src/nibbles-game.vala"
	nibbles_game_parent_class = g_type_class_peek_parent (klass);
#line 43 "../src/nibbles-game.vala"
	g_type_class_adjust_private_offset (klass, &NibblesGame_private_offset);
#line 43 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nibbles_game_get_property;
#line 43 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nibbles_game_set_property;
#line 43 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->constructor = nibbles_game_constructor;
#line 43 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_game_finalize;
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SKIP_SCORE_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY] = g_param_spec_boolean ("skip-score", "skip-score", "skip-score", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_CURRENT_LEVEL_PROPERTY, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY] = g_param_spec_int ("current-level", "current-level", "current-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY, nibbles_game_properties[NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY] = g_param_spec_boolean ("three-dimensional-view", "three-dimensional-view", "three-dimensional-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SPEED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY] = g_param_spec_int ("speed", "speed", "speed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_GAMEDELAY_PROPERTY, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY] = g_param_spec_int ("gamedelay", "gamedelay", "gamedelay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_PROGRESS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_PROGRESS_PROPERTY] = g_param_spec_int ("progress", "progress", "progress", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_START_LEVEL_PROPERTY, nibbles_game_properties[NIBBLES_GAME_START_LEVEL_PROPERTY] = g_param_spec_int ("start-level", "start-level", "start-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WIDTH_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_HEIGHT_PROPERTY, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMHUMANS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY] = g_param_spec_int ("numhumans", "numhumans", "numhumans", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMAI_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY] = g_param_spec_int ("numai", "numai", "numai", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMWORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY] = g_param_spec_int ("numworms", "numworms", "numworms", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORMS_PROPERTY] = g_param_spec_object ("worms", "worms", "worms", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORM_PROPS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORM_PROPS_PROPERTY] = g_param_spec_object ("worm-props", "worm-props", "worm-props", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_IS_RUNNING_PROPERTY, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_PAUSED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 43 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_FAKES_PROPERTY, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY] = g_param_spec_boolean ("fakes", "fakes", "fakes", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL] = g_signal_new ("bonus-applied", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_BONUS, TYPE_WORM);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL] = g_signal_new ("log-score", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL] = g_signal_new ("animate-end-game", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL] = g_signal_new ("level-completed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL] = g_signal_new ("warp-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_ADDED_SIGNAL] = g_signal_new ("bonus-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_GET_PKGDATADIR_SIGNAL] = g_signal_new ("get-pkgdatadir", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_STRING__VOID, G_TYPE_STRING, 0);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL] = g_signal_new ("add-keypress-handler", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER, G_TYPE_BOOLEAN, 2, G_TYPE_POINTER, G_TYPE_POINTER);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_REDRAW_SIGNAL] = g_signal_new ("redraw", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 43 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL] = g_signal_new ("play-sound", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 7261 "nibbles-game.c"
}

static void
nibbles_game_instance_init (NibblesGame * self,
                            gpointer klass)
{
	gint* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeHashMap* _tmp2_;
	Boni* _tmp3_;
	WarpManager* _tmp4_;
#line 43 "../src/nibbles-game.vala"
	self->priv = nibbles_game_get_instance_private (self);
#line 63 "../src/nibbles-game.vala"
	_tmp0_ = g_new0 (gint, 0);
#line 63 "../src/nibbles-game.vala"
	self->levels_uncompleated = _tmp0_;
#line 63 "../src/nibbles-game.vala"
	self->levels_uncompleated_length1 = 0;
#line 63 "../src/nibbles-game.vala"
	self->_levels_uncompleated_size_ = self->levels_uncompleated_length1;
#line 77 "../src/nibbles-game.vala"
	_tmp1_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 77 "../src/nibbles-game.vala"
	self->priv->_worms = _tmp1_;
#line 78 "../src/nibbles-game.vala"
	_tmp2_ = gee_hash_map_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_WORM_PROPERTIES, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 78 "../src/nibbles-game.vala"
	self->priv->_worm_props = _tmp2_;
#line 80 "../src/nibbles-game.vala"
	_tmp3_ = boni_new ();
#line 80 "../src/nibbles-game.vala"
	self->priv->boni = _tmp3_;
#line 81 "../src/nibbles-game.vala"
	_tmp4_ = warp_manager_new ();
#line 81 "../src/nibbles-game.vala"
	self->priv->warp_manager = _tmp4_;
#line 84 "../src/nibbles-game.vala"
	self->priv->_is_running = FALSE;
#line 85 "../src/nibbles-game.vala"
	self->priv->_is_paused = FALSE;
#line 99 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 115 "../src/nibbles-game.vala"
	self->added_keypress_handler = FALSE;
#line 328 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) 0;
#line 7309 "nibbles-game.c"
}

static void
nibbles_game_finalize (GObject * obj)
{
	NibblesGame * self;
#line 43 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 63 "../src/nibbles-game.vala"
	self->levels_uncompleated = (g_free (self->levels_uncompleated), NULL);
#line 66 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 77 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worms);
#line 78 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worm_props);
#line 80 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->boni);
#line 81 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->warp_manager);
#line 43 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (nibbles_game_parent_class)->finalize (obj);
#line 7332 "nibbles-game.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesGame), 0, (GInstanceInitFunc) nibbles_game_instance_init, NULL };
	GType nibbles_game_type_id;
	nibbles_game_type_id = g_type_register_static (G_TYPE_OBJECT, "NibblesGame", &g_define_type_info, 0);
	NibblesGame_private_offset = g_type_add_instance_private (nibbles_game_type_id, sizeof (NibblesGamePrivate));
	return nibbles_game_type_id;
}

GType
nibbles_game_get_type (void)
{
	static gsize nibbles_game_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_type_id__once)) {
		GType nibbles_game_type_id;
		nibbles_game_type_id = nibbles_game_get_type_once ();
		g_once_init_leave (&nibbles_game_type_id__once, nibbles_game_type_id);
	}
	return nibbles_game_type_id__once;
}

static void
_vala_nibbles_game_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 43 "../src/nibbles-game.vala"
	switch (property_id) {
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_skip_score (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_current_level (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_three_dimensional_view (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_speed (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_gamedelay (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PROGRESS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_progress (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_START_LEVEL_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_start_level (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_width (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_height (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numhumans (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numai (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numworms (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORMS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worms (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORM_PROPS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worm_props (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_is_running (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PAUSED_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_paused (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_fakes (self));
#line 43 "../src/nibbles-game.vala"
		break;
#line 7469 "nibbles-game.c"
		default:
#line 43 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 43 "../src/nibbles-game.vala"
		break;
#line 7475 "nibbles-game.c"
	}
}

static void
_vala_nibbles_game_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 43 "../src/nibbles-game.vala"
	switch (property_id) {
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_skip_score (self, g_value_get_boolean (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_three_dimensional_view (self, g_value_get_boolean (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_speed (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_gamedelay (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PROGRESS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_progress (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_START_LEVEL_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_start_level (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_width (self, g_value_get_uchar (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_height (self, g_value_get_uchar (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_numhumans (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_numai (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_numworms (self, g_value_get_int (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_is_running (self, g_value_get_boolean (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PAUSED_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_paused (self, g_value_get_boolean (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 43 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 43 "../src/nibbles-game.vala"
		nibbles_game_set_fakes (self, g_value_get_boolean (value));
#line 43 "../src/nibbles-game.vala"
		break;
#line 7579 "nibbles-game.c"
		default:
#line 43 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 43 "../src/nibbles-game.vala"
		break;
#line 7585 "nibbles-game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

